/*//////////   SCRIPT:   Jumper  Cam v1.1   //////////*/
/*//////////   WRITTEN BY:   Branko Zivkovic   //////////*/
/*//////////   EMAIL:   barigazy@hotmail.com   //////////*/
(
global jcRoll
if jcRoll != undefined do try (destroyDialog jcRoll) catch()
rollout jcRoll "   Jumper  Cam v1.1 "
(
	dotNetControl jcPnl1 "Panel" pos:[0,0]
	dotNetControl jcPnl2 "Panel" pos:[0,62]
	timer jctimeTick interval:30
/*///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   LOCALS   //////////*/
/*//////////   Locals on "Setup" Panel   //////////*/
	local jcToolTip, jcTTb1, jcLbl1, jcBtn1, jcLbl2, jcBtnSetup, jcBtnTune, jcBtnJump, jcListBox, jcLblS1, jcLblS2, jcLblS1h, jcLblSJC, jcTBoxS1, \
	jcBtnWC, jcCB1, jcCB2, jcCB3, jcCB4, jcLblS3, jcLblS4, jcBtnCCFV, jcBtnSwC, jcBtnRV, jcBtnSvC, jcBtnSpV, jcBtnSpC, jcLblAS, jcSpnAng, jcSpnSpd, jcCB5, \
	jcCB6, jcCB7, jcCB8, jcCB9, jcSpnSAI1, jcSpnSAI2, jcSpnACS, jcLblACS, jcSpnSCS, jcLblSCS, jcTBoxS2, jcBtnRCF, jcBtnAF, jcBtnCJC, jcLBS_Roll
/*//////////   Locals on "Tune" Panel   //////////*/
	local jcLblT1, jcLblT2, jcLblT3, jcLblT4, jcLblT5, jcLblT6, jcComBoxJCL, jcBtnSJC, jcBtnT1K, jcBtnT2K, jcBtnT3K, jcBtnT4K, jcBtnPlay, jcLblAInf, jcBtnT1F, \
	jcLblNthF, jcSpnNthF, jcBtnT1F, jcBtnT2F, jcBtnT3F, jcBtnT4F, jcSpnStart, jcSpnSlid, jcSpnEnd, jcLblAnim, jcCBAnim, jcBtnT1N, jcBtnT2N, jcBtnT3N, jcBtnT4N, \
	jcBtnT5N, jcBtnT6N, jcBtnT7N, jcBtnT8N, jcBtnFSM, jcBtnVPT, jcLblT7, jcLblTLens, jcComBoxLens, jcLblT_FOV, jcLblT_TD, jcLblT_SS, jcLblT_FS, jcLblT_ISO, \
	jcLblSlid_FOV, jcLblSlid_TD, jcLblSlid_SS, jcLblSlid_FS, jcLblSlid_ISO, jcSpn_FOV, jcSpn_TD, jcSpn_SS, jcSpn_FS, jcSpn_ISO
/*//////////   Locals on "Jump" Panel   //////////*/
	local jcLblJ1, jcBtnRWN, jcComBoxJCG, jcBtnJOn, jcLblX, jcSpnX, jcLblY, jcSpnY, jcBtnClrL, jcBtnClrT, jcCBtbg, jcColDial

	local posX1 = 0, posX2 = -164, posX3 = -328
	local jcFont1 = dotNetObject "System.Drawing.Font" "Verdana" 7 ((dotNetClass "System.Drawing.FontStyle").bold)
	local jcFont2 = dotNetObject "System.Drawing.Font" "ISOCTEUR" 12 ((dotNetClass "System.Drawing.FontStyle").bold)
	local jcFont3 = dotNetObject "System.Drawing.Font" "ArialBlack" 18 ((dotNetClass "System.Drawing.FontStyle").bold)
	local jcFont4 = dotNetObject "System.Drawing.Font" "Webdings" 10.5 ((dotNetClass "System.Drawing.FontStyle").regular)
	local jcFont5 = dotNetObject "System.Drawing.Font" "Webdings" 16.5 ((dotNetClass "System.Drawing.FontStyle").regular)
	local jcFont6 = dotNetObject "System.Drawing.Font" "Wingdings" 11 ((dotNetClass "System.Drawing.FontStyle").regular)
	local jcFont7 = dotNetObject "System.Drawing.Font" "Verdana" 11 ((dotNetClass "System.Drawing.FontStyle").bold)
	local jcFont8 = dotNetObject "System.Drawing.Font" "ISOCPEUR" 12 ((dotNetClass "System.Drawing.FontStyle").bold)
	local jcSM = (dotNetClass "System.Windows.Forms.SelectionMode").MultiExtended
	local jcCurs = (dotNetClass "System.Windows.Forms.Cursors").Hand
	local jcCurs1 = (dotNetClass "System.Windows.Forms.Cursors").Help
	local jcAlign1 = (dotNetClass "System.Drawing.ContentAlignment").MiddleCenter
	local jcAlign2 = (dotNetClass "System.Drawing.ContentAlignment").BottomCenter
	local jcAlign3 = (dotNetClass "System.Drawing.ContentAlignment").MiddleLeft
	local jcAlign4 = (dotNetClass "System.Drawing.ContentAlignment").TopLeft
	local jcHorizA = (dotNetClass "System.Windows.Forms.HorizontalAlignment").Center
	local jcFS1 = (dotNetClass "System.Windows.Forms.FlatStyle").Popup
	local jcFS2 = (dotNetClass "System.Windows.Forms.FlatStyle").Flat
	local jcFS3 = (dotNetClass "System.Windows.Forms.FlatStyle").Standard
	local jcBS1 = (dotNetClass "System.Windows.Forms.BorderStyle").None
	local jcCBA = (dotNetClass "System.Windows.Forms.Appearance").Button
	local jcCBS = (dotNetClass "System.Windows.Forms.ComboBoxStyle").DropDownList
	local jcPadd1 = dotNetObject "Padding" 1 2 1 1
	local jcPadd2 = dotNetObject "Padding" 0 0 0 0
	local jcBC = (dotNetClass "System.Drawing.Color").FromArgb 100 100 100
	local jcBC1 = (dotNetClass "System.Drawing.Color").FromArgb 80 80 80
	local jcBC2 = (dotNetClass "System.Drawing.Color").FromArgb 40 40 40
	local jcBC3 = (dotNetClass "System.Drawing.Color").FromArgb 60 60 60
	local jcBC4 = (dotNetClass "System.Drawing.Color").FromArgb 20 20 20
	local jcFC = (dotNetClass "System.Drawing.Color").FromArgb 200 200 200
	local jcFC1 = (dotNetClass "System.Drawing.Color").FromArgb 140 140 140
	local jcCWC = (dotNetClass "System.Drawing.Color").FromArgb 170 255 0
	local jcWGC = (dotNetClass "System.Drawing.Color").FromArgb 135 185 100
	local jcWBC = (dotNetClass "System.Drawing.SystemColors").MenuHighlight
	local jcWWC = (dotNetClass "System.Drawing.SystemColors").HighlightText
	local jcWFC = (dotNetClass "System.Drawing.Color").Firebrick
	local jcWMC = (dotNetClass "System.Drawing.Color").FromArgb 80 0 0
	local jcGM = (dotNetClass "System.Drawing.Drawing2D.LinearGradientMode").Vertical
	local jcF_HCT = dotNet.CombineEnums (dotNetClass "TextFormatFlags").HorizontalCenter (dotNetClass "TextFormatFlags").Top
	local jcF_HCB = dotNet.CombineEnums (dotNetClass "TextFormatFlags").HorizontalCenter (dotNetClass "TextFormatFlags").Bottom
	local jcF_HCVC = dotNet.CombineEnums (dotNetClass "TextFormatFlags").HorizontalCenter (dotNetClass "TextFormatFlags").VerticalCenter
	local jcTxtR = dotNetClass "TextRenderer"
	local jcGC = dotNetClass "System.GC"

	local AnimInfo = "FPS | frame | time >>>\n" + framerate as string + " | " + slidertime as string + " | " + (formattedPrint ((slidertime.frame as float)/framerate) format:"0.3f") + "s"
	local jcSceneCamArr = #(), jcLB_Items = #(), jcLB_selIdx = #(), jcLB_selItems = #(), jcLB_swapIdx = #()
	local LensesTypeArr = #(" Lenses >", "  15mm", "  20mm", "  24mm", "  28mm", "  35mm", "  50mm", "  85mm", "  135mm", "  200mm")
	local GridTypeArr = #("  Rule Of Thirds", "  Quadrants ", "  Golden Ratio", "  Diagonals", "  Custom Lines", "  Custom Target", "  Camera Info", "  Camera Note")
	local J_Cam = undefined, followMouse = false, crOffset = 2, ClickPosX = undefined, jcTTtxt, JC_Layer
	local Arr_FOV = #(0, 0, 0), Arr_TD = #(0, 0, 0), Arr_SS = #(0, 0, 0), Arr_FS = #(0, 0, 0), Arr_ISO = #(0, 0, 0)
	local mrR = "#(1492548972, 1338981315)", mrIRR = "#(1048411834, 348141227)", vrR = "#(1941615238, 2012806412)", vrRTR = "#(1770671000, 1323107829)"
	local br2R = "#(95494396, 474502030)", frR = "#(217131703, 58075251)"
	local theChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789"
/*///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   FUNCTION DEFINITIONS   //////////*/
	mapped fn dispFB brushArr = (brushArr.Dispose)
	fn camFilter m = isValidnode m and isKindOf m camera and substring m.name 1 3 != "JC_" and not isKindOf m VRayDomeCamera and not m.isHidden and not isDeleted m
	fn camNoteFilter n = isValidnode n and isKindOf n camera and not isKindOf n VRayDomeCamera
	fn JC_Filter jc = isValidnode jc and isKindOf jc camera and substring jc.name 1 3 == "JC_" and jc != getActiveCamera()
	fn AddRangeFn jcObject mxsArr = for i in 1 to mxsArr.count do jcObject.Items.Add (dotNetObject "System.String" mxsArr[i])
	fn DisableAccel = (enableAccelerators = false) ; fn EnableAccel = (enableAccelerators = true)
	fn RefreshOnce jcObject = (if onRefresh == true do ( onRefresh = false ; jcObject.Refresh() ; onRefresh = true ))
	fn round val dp = (	local result = formattedPrint val format:("0." + (dp as string) + "f") )
	fn toTop Arr1 Arr2 Arr3 =
	(
		Arr3 = for i in Arr1 collect Arr2[i]
		for i in Arr2 do appendIfUnique Arr3 i
		Arr2 = Arr3
	)
	fn toBottom Arr1 Arr2 Arr3 Arr4 =
	(
		Arr3 = for i in Arr1 collect Arr2[i]
		for i in Arr4 do deleteItem Arr2 i
		join Arr2 Arr3
	)
	fn RedrawActiveView =
	(
		local vav = viewport.activeViewport
		try(if vav == 1 do viewport.setGridVisibility vav (viewport.getGridVisibility vav)) catch()
	)
	fn maxunits =
	(
		local unit = ""
		if units.DisplayType == #metric then
		( 
			case units.MetricType of ( #kilometers: unit = "km" ; #meters: unit = "m" ; #centimeters: unit = "cm" ; #millimeters: unit = "mm" ) 
		) else unit = ""
	)
	fn cleanString st =
	(
		st = trimLeft (trimRight st) ; local cnt = st.count
		if cnt != 0 do for i = cnt to 1 by -1 do (	if findString theChars st[i] == undefined do (st = replace st i 1 " ") )
		return st
	)
	fn JC_Labels =
	(
		gw.setTransform (matrix3 1)
		local jc_cam = undefined, rctClr = (color 170 250 0), jc_camsArr = #()
		jc_camsArr = for jcc in cameras where JC_Filter jcc == true and isValidNode jcc collect jcc
		if jc_camsArr.count != 0 then
		(
			for itm in 1 to jc_camsArr.count do
			(
				jc_cam = jc_camsArr[itm]
				cc = gw.wTransPoint jc_cam.pos ; ct = gw.wTransPoint jc_cam.pos + [20,-20,0]
				local bgW = jc_cam.name.count, cwc = jc_cam.wirecolor + 50
				gw.wrect ( box2 (ct[1]-2) (ct[2]) ((bgW+3)*5.5) 3 ) rctClr
				gw.wrect ( box2 (ct[1]-2) (ct[2]-20) ((bgW+3)*5.5) 3 ) rctClr
				gw.wtext ct (" " + jc_cam.name) color:rctClr
			)
		)
		else ( unregisterRedrawViewsCallback JC_Labels ; RedrawActiveView() ; jcCB7.Checked == false )
		gw.enlargeUpdateRect #whole ; gw.updateScreen() ; redrawViews()
	)
	fn calculateFrames jcTBox =
	(
		if selection.count == 1 and isKindOf selection[1] camera and substring selection[1].name 1 3 == "JC_" then
		(
			local sjc = selection[1], allKC = sjc[3][1].track.keys.count, eTxt = ""
			for i = 1 to allKC do eTxt += ((sjc[3][1].track.keys[i].time.frame) as integer) as string + ","
			jcTBox.Text = trimRight eTxt "," ; jcTBox.ForeColor = jcFC
		) else ( jcTBox.ForeColor = jcBC2 ; jcTBox.Text = " Create or Select JC!")
	)
	fn Fill_JC_Layer JC =
	(
		JC_Layer = LayerManager.getLayerFromName "#[JAMPERCAM]"
		if JC_Layer == undefined then
		(
			JC_Layer = LayerManager.newLayerFromName "#[JAMPERCAM]"
			JC_Layer.current = true ; JC_Layer.wireColor = [170,255,0]
		) else (JC_Layer.current = true) ; if isvalidNode JC do (JC_Layer.addNode JC )
	)
	fn J_Cam_Type = 
	(
			J_Cam = case of (
			(jcCB1.Checked == true): Freecamera fov:54.4322 targetDistance:100 nearclip:1 farclip:1000 nearrange:0 farrange:1000 \
			mpassEnabled:off mpassRenderPerPass:off transform:(matrix3 [1,0,0] [0,0,1] [0,-1,0] [0,0,0]) isSelected:off
			(jcCB2.Checked == true): VRayPhysicalCamera whiteBalance_preset:1 whiteBalance:(color 255 255 255) targeted:off specify_fov:on \
			target_distance:100 shutter_speed:200 f_number:8 ISO:100 transform:(matrix3 [1,0,0] [0,0,1] [0,-1,0] [0,0,0]) isSelected:off
			(jcCB3.Checked == true): Freecamera fov:54.4322 targetDistance:100 nearclip:1 farclip:1000 nearrange:0 farrange:1000 \
			mpassEnabled:off mpassRenderPerPass:off transform:(matrix3 [1,0,0] [0,0,1] [0,-1,0] [0,0,0]) isSelected:off
			(jcCB4.Checked == true): Main_Camera target_distance_internal:100 target_on:off clip_near:0 clip_far:1000 range_near:0 range_far:1000 isSelected:off
		)
	)
	fn AdvCamsBake =
	(
		if jcListBox.Items.Count > 0 do
		(
			local camsArr = #(), stillCams = #(), animCams = #(), animTimeArr = #(), animPosArr =#(), animRotArr = #(), transArr = #(), fovArr = #()
			local intervalArr = #(), wClr = jcBtnWC.BackColor, sc_step = jcSpnSCS.Value, ac_step = jcSpnACS.Value, iStart = -1000f, iEnd = 1000f
			camsArr = for i in 1 to jcListBox.Items.Count where isValidNode (getNodeByName jcListBox.Items.item[i-1]) collect (getNodeByName jcListBox.Items.item[i-1])
			if jcCB8.Checked == true then
			(
				for cam in camsArr do
				(
					if jcCB9.Checked == true do (iStart = (jcSpnSAI1.Value as time) ; iEnd = (jcSpnSAI2.Value as time))
					animPosArr = for t in iStart to iEnd-1 where (at time t cam.pos) != (at time (t+1) cam.pos) collect t+1
					animRotArr = for t in iStart to iEnd-1 where (at time t cam.transform.rotationpart) != (at time (t+1) cam.transform.rotationpart) collect t+1
					animTimeArr = sort ( makeUniqueArray ( join animPosArr animRotArr ) )
					if animTimeArr.count > 0 then ( append intervalArr #(amin animTimeArr - 1, amax animTimeArr) ; append animCams cam	) else (append stillCams cam)
				)
				if animCams.count > 0 do
				(
					J_Cam_Type() ; J_Cam.name = uniquename "JC_JumperCam" ; J_Cam.wirecolor = color (wClr.r) (wClr.g) (wClr.b)
					if slidertime != 0f do slidertime = 0f ; maxops.setDefaultTangentType #linear #linear
					if animCams.count > 1 do maxOps.autoKeyDefaultKeyOn = false
					for c in 1 to animCams.count do
					(
						for t = intervalArr[c][1] to intervalArr[c][2] by ac_step do at time t
						(
							append transArr animCams[c].transform
							if classof animCams[c] != Main_Camera then (append fovArr animCams[c].fov)
							else (if classof animCams[c].lens != Environ_Mapper_Lens do append fovArr animCams[c].lens.fov)
						)
						local endOfTime = ((transArr.count)*ac_step) as time, jct = #()
						jct = for t = 0f to endOfTime by ac_step collect t
						animate on
						for a in 1 to transArr.count do
						(
							at time jct[a]
							(
								J_Cam.transform = transArr[a]
								if classof J_Cam != Main_Camera then (J_Cam.fov = fovArr[a]) else (J_Cam.lens.fov = fovArr[a])
							)
						)
					)
					J_Cam.showTrajectory = on ; select J_Cam ; deleteKeys J_Cam[3][3].track ; maxOps.autoKeyDefaultKeyOn = true
					if jcCB6.Checked == true and J_Cam.isSelected == true do viewport.setType #view_camera
					local kc = J_Cam[3][1].track.keys.count, lastKeyTime = J_Cam[3][1].track.keys[kc].time
					if lastKeyTime >= 50f do animationRange = (interval 0f lastKeyTime ) ; maxOps.trackBar.redraw()
				)
			) else ( stillCams = camsArr ; format "stillCams = %\n" stillCams )
			if stillCams.count > 1 do
			(
				maxops.setDefaultTangentType #linear #linear
				if jcCB8.Checked == true and animCams.count != 0 and J_Cam.isSelected == true then
				(
					local sct = stillCams.count as time
					moveKeys J_Cam (sct*sc_step-ac_step)
					for i in 0 to stillCams.count-1 do
					(
						set animate on ; set time (i*sc_step)
						J_Cam.transform = stillCams[i+1].transform
						if (classof J_Cam != Main_Camera and classof stillCams[i+1] != Main_Camera) then (J_Cam.fov = stillCams[i+1].fov)
						else if (classof J_Cam == Main_Camera and classof stillCams[i+1] != Main_Camera) then (J_Cam.lens.fov = stillCams[i+1].fov)
						else if (classof J_Cam != Main_Camera and (classof stillCams[i+1] == Main_Camera and classof stillCams[i+1].lens != Environ_Mapper_Lens)) do (J_Cam.fov = stillCams[i+1].lens.fov)
						set animate off ; set time off
					)
				)
				else
				(
					J_Cam_Type() ; J_Cam.name = uniquename "JC_JumperCam" ; J_Cam.wirecolor = color (wClr.r) (wClr.g) (wClr.b)
					for i = 0 to stillCams.count-1 do
					(
						set animate on ; set time (i*sc_step)
						J_Cam.transform = stillCams[i+1].transform
						if (classof J_Cam != Main_Camera and classof stillCams[i+1] != Main_Camera) then (J_Cam.fov = stillCams[i+1].fov)
						else if (classof J_Cam == Main_Camera and classof stillCams[i+1] != Main_Camera) then (J_Cam.lens.fov = stillCams[i+1].fov)
						else if (classof J_Cam != Main_Camera and (classof stillCams[i+1] == Main_Camera and classof stillCams[i+1].lens != Environ_Mapper_Lens)) do (J_Cam.fov = stillCams[i+1].lens.fov)
						set animate off ; set time off
					)
				)
				J_Cam.showTrajectory = on ; select J_Cam ; deleteKeys J_Cam[3][3].track ; if slidertime != 0f do slidertime = 0f
				if jcCB6.Checked == true and J_Cam.isSelected == true do viewport.setType #view_camera
				local kc = J_Cam[3][1].track.keys.count, lastKeyTime = J_Cam[3][1].track.keys[kc].time
				if lastKeyTime >= 50f do animationRange = (interval 0f lastKeyTime ) ; maxOps.trackBar.redraw()
			) ; calculateFrames jcTBoxS2 ; Fill_JC_Layer J_Cam
		)
	)
	fn defineSliderPaint jcSpn jcLbl Arr =
	(
		Arr[1] = case of
		(
			(jcSpn.Minimum < 0): (	if jcSpn.Maximum > 0 then (abs jcSpn.Minimum + abs jcSpn.Maximum)
									else if jcSpn.Maximum < 0 do (abs jcSpn.Minimum - abs jcSpn.Maximum) )
			(jcSpn.Minimum > 0): jcSpn.Maximum - jcSpn.Minimum
			(jcSpn.Minimum == 0): abs jcSpn.Maximum
		)
		Arr[2] = ( Arr[1] as float / jcLbl.Width as float ) ; Arr[3] = (jcLbl.Width as float / Arr[1] as float) ; jcLbl.invalidate()
	)
	fn getClickPosX jcSpn jcLbl Arr pos =
	(
		if jcSpn.Enabled == true do
		(
			jcClickpos = pos.x
			if jcClickpos >= 0 and jcClickpos <= jcLbl.Width do ( jcSpn.Value = (jcSpn.Minimum + (jcClickpos * Arr[2])as integer) ; jcLbl.invalidate())
		)
	)
	fn PaintSlide jcSpn jcLbl Arr clr =
	(
		cr = jcLbl.ClientRectangle ; Painter = clr.Graphics
		if jcClickpos != undefined then crW = jcClickpos else
		(
			crW = case of
			(
				(jcSpn.Minimum <= 0):   (abs jcSpn.Minimum + jcSpn.Value) * Arr[3]
				(jcSpn.Minimum > 0):   (jcSpn.Value - jcSpn.Minimum) * Arr[3]
			)
		)
		crH = ((cr.Height/2) - crOffset) ; crX = cr.x ; crY = cr.y + crOffset
		rectT = dotNetObject "System.Drawing.Rectangle" crX crY crW (crH*2)
		rectM = dotNetObject "System.Drawing.Rectangle" crX ((cr.Height/2) - (crOffset/2)) crW crOffset
		jcSBrushT = dotNetObject "System.Drawing.SolidBrush" jcFC
		if jcCBAnim.Checked != true then (jcSBrushM = dotNetObject "System.Drawing.SolidBrush" jcWBC)
		else (jcSBrushM = dotNetObject "System.Drawing.SolidBrush" jcWFC)
		Painter.FillRectangle jcSBrushT rectT ; Painter.FillRectangle jcSBrushM rectM ; dispFB #(jcSBrushT, jcSBrushM) 
	)
	fn createJC_List =
	(
		local JC_CB_ListArr = #(), CBArr = #() 
		JC_CB_ListArr = for cams in cameras where (isKindOf cams camera and substring cams.name 1 3 == "JC_") collect cams.name
		sort (makeUniqueArray JC_CB_ListArr)
		if jcComBoxJCL.items.count != 0 then (CBArr = for i in 1 to jcComBoxJCL.Items.Count where isValidNode (getNodeByName jcComBoxJCL.Items.item[i-1]) collect jcComBoxJCL.Items.item[i-1])
		else CBArr = #() 
		if JC_CB_ListArr.count > 0 do
		(
			if CBArr.count == 0 then ( AddRangeFn jcComBoxJCL JC_CB_ListArr ; jcComBoxJCL.SelectedIndex = 0 )
			else
			(
				if (CBArr.count != JC_CB_ListArr.count) or ((m = for i in JC_CB_ListArr where (finditem CBArr i) == 0 collect i).count == 0) do
				(
					jcComBoxJCL.Items.Clear() ; RefreshOnce jcComBoxJCL ; AddRangeFn jcComBoxJCL JC_CB_ListArr
					if jcComBoxJCL.Items.count > 0 do
					(
						if selection.count == 1 then
						(
							for i=1 to jcComBoxJCL.items.count where (jcComBoxJCL.Items.item[i-1] == selection[1].name) do ( jcComBoxJCL.SelectedIndex = (i-1) )
						) else jcComBoxJCL.SelectedIndex = 0
					)
				)	
			)
		)
	)
	fn jcLB_Shortcuts =
	(
		if jcLBS_Roll != undefined do try(destroyDialog jcLBS_Roll)catch()
		rollout jcLBS_Roll ""
		(
			dotNetControl jcBnr "Label" pos:[0,0] width:211 height:15
			dotNetControl jcStxt "Label" pos:[0,15] width:211 height:130
			local banerTXT = "   L i s t B o x  S h o r t c u t s   "	
			local lbShct = "  [ DubleClick ] :: select an item\r\n  [ Enter ] :: select the items\r\n  [ Esc ] :: deselect active selection\r
  [ Del ] :: delete items from listbox\r\n  [ Y ] :: insert items into listbox\r\n  [ 1 ] :: move items to the top\r\n  [ 2 ] :: move items up (one step)\r
  [ 3 ] :: move items down (one step)\r\n  [ 4 ] :: move items to the bottom\r\n  [ 5 ] :: sort items alphabetically\r\n  [ 6 ] :: clear/empty listbox"
			on jcLBS_Roll open do
			(
				jcBnr.BackColor = jcStxt.ForeColor = jcFC ; jcBnr.ForeColor = jcBC2 ; jcStxt.BackColor = jcBC1
				jcBnr.TextAlign = jcAlign1 ; jcStxt.TextAlign = jcAlign4 ; jcBnr.Font = jcStxt.Font = jcFont1
				jcBnr.Text = banerTXT ; jcStxt.Text = lbShct
			)
		)
		createdialog jcLBS_Roll 211 145 (mouse.pos.x + 20) (mouse.pos.y + 75) style: #()
	)
/*//////////   FUNCTION FOR THE EVENTS   //////////*/
	fn getjcTTMH sender arg = ( jcTTtxt = jcToolTip.GetToolTip sender)
	fn jcTTb1Draw ttjc =
	(
  		local ttjcTitle = "Jumper * Cam v1.0", ttjcSize = ttjc.Bounds, ttjcBO = 3
		local ttjctxt = "created by: Branko Zivkovic\r\nemail: barigazy@hotmail.com"
		rectTTjc = dotNetObject "System.Drawing.Rectangle" (ttjcSize.x + ttjcBO) (ttjcSize.y + ttjcBO) (ttjcSize.Width - 2*ttjcBO) (ttjcSize.Height - 2*ttjcBO)
		ttjcGBrush = dotnetobject "System.Drawing.Drawing2D.LinearGradientBrush" ttjcSize jcBC jcBC2 jcGM
		ttjcGBrush1 = dotnetobject "System.Drawing.Drawing2D.LinearGradientBrush" ttjcSize jcBC4 jcBC3 jcGM
  		ttjc.Graphics.FillRectangle ttjcGBrush ttjcSize ; ttjc.Graphics.FillRectangle ttjcGBrush1 rectTTjc
		jcTxtR.DrawText ttjc.Graphics ttjcTitle jcFont8 rectTTjc jcFC jcF_HCT
		jcTxtR.DrawText ttjc.Graphics ttjctxt jcFont1 rectTTjc jcFC1 jcF_HCB
	)
	fn jcToolTipDraw ttjc =
	(
		local ttjcSize = ttjc.Bounds
		ttjcGBrush = dotnetobject "System.Drawing.Drawing2D.LinearGradientBrush" ttjcSize jcFC jcFC1 jcGM
  		ttjc.Graphics.FillRectangle ttjcGBrush ttjcSize ; jcTxtR.DrawText ttjc.Graphics jcTTtxt jcFont1 ttjcSize jcBC2 jcF_HCVC
	)
/*//////////   "Setup" Panel FN   //////////*/
	fn jcBtn1Click =
	(
		if jcRoll.height != 43 and jcBtn1.BackColor != jcBC1 then	( jcRoll.height = 43 ; jcBtn1.BackColor = jcBC1	)
		else
		(
			jcRoll.height = 62 ; jcBtn1.BackColor = jcFC
			jcBtnSetup.ForeColor = jcBtnTune.ForeColor = jcBtnJump.ForeColor = jcFC
			jcBtnSetup.BackColor = jcBtnTune.BackColor = jcBtnJump.BackColor = jcBC1
		)
	)
	fn jcBtnSetupClick =
	(
		if jcRoll.height != 62 and jcBtnSetup.BackColor != jcBC1 and jcBtnSetup.ForeColor != jcFC then
		(
			jcRoll.height = 62 ; jcBtnSetup.BackColor = jcBC1 ; jcBtnSetup.ForeColor = jcFC
		)
		else
		(
			TC = jcTBoxS1.Text.count
			jcRoll.height = 517 ; jcBtnSetup.BackColor = jcFC ; jcBtnSetup.ForeColor = jcBC2 ; jcPnl2.pos.x = posX1
			jcBtnTune.BackColor = jcBtnJump.BackColor = jcBC1 ; jcBtnTune.ForeColor = jcBtnJump.ForeColor = jcFC
			jcTBoxS1.Focus() ; if TC != 0	do (jcTBoxS1.Select 0 TC)
		)
	)
	fn jcBtnTuneClick =
	(
		if jcRoll.height != 62 and jcBtnTune.BackColor != jcBC1 and jcBtnTune.ForeColor != jcFC then
		(
			jcRoll.height = 62 ; jcBtnTune.BackColor = jcBC1 ; jcBtnTune.ForeColor = jcFC
		)
		else
		(
			jcRoll.height = 519 ; jcBtnTune.BackColor = jcFC ; jcBtnTune.ForeColor = jcBC2 ; jcPnl2.pos.x = posX2
			jcBtnSetup.BackColor = jcBtnJump.BackColor = jcBC1 ; jcBtnSetup.ForeColor = jcBtnJump.ForeColor = jcFC
		)
		if jcLblT1.Location.x == 330 do
		(
			local xx = 164
			jcLblT1.Location.x -= xx ; jcLblT2.Location.x -= xx ; jcComBoxJCL.Location.x -= xx ;  jcBtnSJC.Location.x -= xx ; jcBtnT1K.Location.x -= xx
			jcBtnT2K.Location.x -= xx ; jcBtnT3K.Location.x -= xx ; jcBtnT4K.Location.x -= xx ; jcLblAInf.Location.x -= xx ;  ; jcBtnPlay.Location.x -= xx
		)
	)
	fn jcBtnJumpClick =
	(
		if jcRoll.height != 62 and jcBtnJump.BackColor != jcBC1 and jcBtnJump.ForeColor != jcFC then
		(
			jcRoll.height = 62 ; jcBtnJump.BackColor = jcBC1 ; jcBtnJump.ForeColor = jcFC
		)
		else
		(
			jcRoll.height = 237 ; jcBtnJump.BackColor = jcFC ; jcBtnJump.ForeColor = jcBC2 ; jcPnl2.pos.x = posX3
			jcBtnSetup.BackColor = jcBtnTune.BackColor = jcBC1 ; jcBtnSetup.ForeColor = jcBtnTune.ForeColor = jcFC
		)
		if jcLblT1.Location.x == 166 do
		(
			local xx = 164
			jcLblT1.Location.x += xx ; jcLblT2.Location.x += xx ; jcComBoxJCL.Location.x += xx ; jcBtnSJC.Location.x += xx ; jcBtnT1K.Location.x += xx
			jcBtnT2K.Location.x += xx ; jcBtnT3K.Location.x += xx ; jcBtnT4K.Location.x += xx ; jcLblAInf.Location.x += xx ; jcBtnPlay.Location.x += xx
		)
	)
	fn jcLblS1hMH = (jcLblS1h.BackColor = jcWBC ; jcLblS1h.ForeColor = jcWWC ; jcLB_Shortcuts())
	fn jcLblS1hML = (jcLblS1h.BackColor = jcFC ; jcLblS1h.ForeColor = jcBC2 ; if jcLBS_Roll != undefined do try(destroyDialog jcLBS_Roll)catch())
	fn jcListBoxDC arg = try (select (getNodeByName jcListBox.SelectedItem) ) catch()
	fn jcListBoxGF =
	(
		jcListBox.BackColor = jcBC2
		if jcListBox.Items.Count == 0 then #abort else
		(
			local new_jcLB_Items = #() ; onRefresh = true
			new_jcLB_Items = for i in 1 to jcListBox.Items.Count where isValidNode (getNodeByName jcListBox.Items.item[i-1]) collect jcListBox.Items.item[i-1]
			if jcListBox.Items.Count == new_jcLB_Items.count then #abort else (jcListBox.items.Clear() ; RefreshOnce jcListBox ; AddRangeFn jcListBox new_jcLB_Items)
		)
		if new_jcLB_Items != undefined do (clearListener())
	)
	fn jcListBoxLF = (jcListBox.BackColor = jcBC1)
	fn jcListBoxKD arg = ( jcListBox.Focus() ; DisableAccel() ; if selection.count != 0 do (for obj in selection where not isKindof obj camera do deselect obj) )
	fn jcListBoxKU arg =
	(
		case arg.keyValue of
		(
			27:		( if jcListBox.items.count != 0 do jcListBox.ClearSelected() ; clearSelection() )
			54:		( jcListBox.items.Clear() ; onRefresh = true ; RefreshOnce jcListBox)
			53: 	( if jcListBox.items.count != 0 do (jcListBox.Sorted = true ; jcListBox.Sorted = false) )
			13:		( try(select (for i = 1 to jcListBox.SelectedItems.Count collect getNodeByName jcListBox.SelectedItems.Item[i-1])) catch() )
			89: 	(
						if selection.count != 0 then
						(
							jcSceneCamArr = #()
							selCamArr = for cam in selection where camFilter cam == true collect cam
							for i in 1 to selCamArr.count do append jcSceneCamArr selCamArr[i].name
							if jcSceneCamArr != undefined do (clearListener() ; print jcSceneCamArr )
						)
						else
						(
							actCam = getActiveCamera() ; jcSceneCamArr = #()
							if actCam != undefined and camFilter actCam == true then (append jcSceneCamArr actCam.name)
							else
							(
								jcsbnArr = selectByName title:"Pick Camera's To Insert" buttontext:"Insert" filter:camFilter
								if jcsbnArr != undefined do ( for i in 1 to jcsbnArr.count where isValidNode jcsbnArr[i] do append jcSceneCamArr jcsbnArr[i].name )
							) ; if jcSceneCamArr != undefined do (clearListener() ; print jcSceneCamArr )
						)
						jcLB_Items = for i in 1 to jcListBox.Items.Count where isValidNode (getNodeByName jcListBox.Items.item[i-1]) collect jcListBox.Items.item[i-1]
						jcLB_ICount = jcLB_Items.count ; join jcLB_Items jcSceneCamArr ; jcSceneCamArr = makeUniqueArray jcLB_Items
						if jcSceneCamArr.count != jcLB_ICount then
						(	
							jcListBox.BeginUpdate() ; jcListBox.items.Clear() ; RefreshOnce jcListBox
							AddRangeFn jcListBox jcSceneCamArr ; jcListBox.EndUpdate() ; clearSelection()
						) else clearSelection()
					)
			46:		(
						jcLB_selIdx = (for i = 1 to jcListBox.SelectedItems.Count collect jcListBox.SelectedIndices.item[i-1]+1)
						jcLB_Items = for i in 1 to jcListBox.Items.Count collect jcListBox.Items.item[i-1] ; onRefresh = true
						for i = jcLB_selIdx.count to 1 by -1 do deleteitem jcLB_Items jcLB_selIdx[i]
						jcListBox.BeginUpdate() ; jcListBox.items.Clear() ; RefreshOnce jcListBox ; AddRangeFn jcListBox jcLB_Items ; jcListBox.EndUpdate()
					)
			50:		(
						jcLB_selIdx = (for i = 1 to jcListBox.SelectedItems.Count collect jcListBox.SelectedIndices.item[i-1]+1)
						jcLB_Items = for i in 1 to jcListBox.Items.Count collect jcListBox.Items.item[i-1]
						jcMinIdx = amin jcLB_selIdx ; sort jcLB_selIdx ; jcLB_selItems = #() ; onRefresh = true
						if jcMinIdx > 1 then ( for i in jcLB_selIdx do swap jcLB_Items[i] jcLB_Items[i-1] ; jcNewIdx = for i in 1 to jcLB_selIdx.count collect jcLB_selIdx[i]-1 )
						else if jcMinIdx == 1 do ( jcLB_Items = toTop jcLB_selIdx jcLB_Items jcLB_selItems ; jcNewIdx = for i = 1 to jcLB_selIdx.count collect i) ; jcLB_Items
						jcListBox.BeginUpdate() ; jcListBox.items.Clear() ; RefreshOnce jcListBox ; AddRangeFn jcListBox jcLB_Items ; jcListBox.EndUpdate()
						for s = 1 to jcNewIdx.count do ( jcListBox.SelectedIndex = jcNewIdx[s]-1)
					)
			51:		(
						jcLB_selIdx = (for i = 1 to jcListBox.SelectedItems.Count collect jcListBox.SelectedIndices.item[i-1]+1)
						jcLB_Items = for i in 1 to jcListBox.Items.Count collect jcListBox.Items.item[i-1]
						maxIndex = amax jcLB_selIdx ; sort jcLB_selIdx ; jcLB_selItems = #() ; onRefresh = true
						jcLB_swapIdx = for i = jcLB_selIdx.count to 1 by -1 collect jcLB_selIdx[i]
						if maxIndex < jcLB_Items.count then ( for i in jcLB_swapIdx do swap jcLB_Items[i] jcLB_Items[i+1]
						jcNewIdx = for i in 1 to jcLB_swapIdx.count collect jcLB_swapIdx[i]-1 )
						else if maxIndex == jcLB_Items.count do ( jcLB_Items = toBottom jcLB_selIdx jcLB_Items jcLB_selItems jcLB_swapIdx
						jcNewIdx = for i = jcLB_swapIdx.count to 1 by -1 collect i+((jcLB_Items.count - jcLB_swapIdx.count)-2) ) ; jcLB_Items
						jcListBox.BeginUpdate() ; jcListBox.items.Clear() ; RefreshOnce jcListBox ; AddRangeFn jcListBox jcLB_Items ; jcListBox.EndUpdate()
						for s = 1 to jcNewIdx.count do ( jcListBox.SelectedIndex = jcNewIdx[s]+1)
					)
			49:		(
						if viewport.GetType() == #view_camera do viewport.setType #view_persp_user
						jcLB_selIdx = (for i = 1 to jcListBox.SelectedItems.Count collect jcListBox.SelectedIndices.item[i-1]+1)
						jcLB_Items = for i in 1 to jcListBox.Items.Count collect jcListBox.Items.item[i-1]
						jcMinIdx = amin jcLB_selIdx ; sort jcLB_selIdx ; jcLB_selItems = #() ; onRefresh = true
						if jcMinIdx >= 1 do ( (jcLB_Items = toTop jcLB_selIdx jcLB_Items jcLB_selItems
						jcNewIdx = for i = 1 to jcLB_selIdx.count collect i) ; jcLB_Items
						jcListBox.BeginUpdate() ; jcListBox.items.Clear() ; RefreshOnce jcListBox ; AddRangeFn jcListBox jcLB_Items ; jcListBox.EndUpdate() )
						for s = 1 to jcNewIdx.count do ( jcListBox.SelectedIndex = jcNewIdx[s]-1)
					)
			52:		(
						if viewport.GetType() == #view_camera do viewport.setType #view_persp_user
						jcLB_selIdx = (for i = 1 to jcListBox.SelectedItems.Count collect jcListBox.SelectedIndices.item[i-1]+1)
						jcLB_Items = for i in 1 to jcListBox.Items.Count collect jcListBox.Items.item[i-1]
						maxIndex = amax jcLB_selIdx ; sort jcLB_selIdx ; jcLB_selItems = #() ; onRefresh = true
						jcLB_swapIdx = for i = jcLB_selIdx.count to 1 by -1 collect jcLB_selIdx[i]
						if maxIndex <= jcLB_Items.count do ( (jcLB_Items = toBottom jcLB_selIdx jcLB_Items jcLB_selItems jcLB_swapIdx
						jcNewIdx = for i = jcLB_swapIdx.count to 1 by -1 collect i+((jcLB_Items.count - jcLB_swapIdx.count)-2) ) ; jcLB_Items
						jcListBox.BeginUpdate() ; jcListBox.items.Clear() ; RefreshOnce jcListBox ; AddRangeFn jcListBox jcLB_Items ; jcListBox.EndUpdate() )
						for s = 1 to jcNewIdx.count do ( jcListBox.SelectedIndex = jcNewIdx[s]+1)
					)
		) ; EnableAccel()
	)
	fn jcTBoxS1GF = ( jcTBoxS1.BackColor = jcBC2 ; DisableAccel() ) ; fn jcTBoxS1LF = ( jcTBoxS1.BackColor = jcBC1 ; EnableAccel() )
	fn jcCB1Click =
	(
		if jcCB1.Checked == true then ( jcCB2.Checked = jcCB3.Checked = jcCB4.Checked = false)
		else if (jcCB1.Checked == false and jcCB2.Checked == false and jcCB3.Checked == false and jcCB4.Checked == false) do jcCB1.Checked = true
	)
	fn jcCB2Click =
	(
		if jcCB2.Checked == true then ( jcCB1.Checked = jcCB3.Checked = jcCB4.Checked = false)
		else if (jcCB1.Checked == false and jcCB2.Checked == false and jcCB3.Checked == false and jcCB4.Checked == false) do jcCB2.Checked = true
	)
	fn jcCB3Click =
	(
		if jcCB3.Checked == true then ( jcCB1.Checked = jcCB2.Checked = jcCB4.Checked = false)
		else if (jcCB1.Checked == false and jcCB2.Checked == false and jcCB3.Checked == false and jcCB4.Checked == false) do jcCB3.Checked = true
	)
	fn jcCB4Click =
	(
		if jcCB4.Checked == true then ( jcCB1.Checked = jcCB2.Checked = jcCB3.Checked = false)
		else if (jcCB1.Checked == false and jcCB2.Checked == false and jcCB3.Checked == false and jcCB4.Checked == false) do jcCB4.Checked = true
	)
	fn rendererCheck =
	(
		local RCArr = rendererClass.classes
		if ((for o in RCArr where matchPattern (o as string) pattern:"*V_Ray*" collect o).count > 0) do ( jcCB2.Checked = false ; jcCB2.Enabled = true ; jcCB2.FlatStyle = jcFS3 )
		if ((for o in RCArr where matchPattern (o as string) pattern:"*finalRender*" collect o).count > 0) do ( jcCB3.Checked = false ; jcCB3.Enabled = true ; jcCB3.FlatStyle = jcFS3 )
		if ((for o in RCArr where matchPattern (o as string) pattern:"*Brazil*" collect o).count > 0) do ( jcCB4.Checked = false ; jcCB4.Enabled = true ; jcCB4.FlatStyle = jcFS3 )
	)
	fn jcBtnCCFVClick =
	(
		undo on
		(
			FocalDist = gw.GetFocalDist() ; stwRay = mapscreentoworldray (getviewsize()/2)
			camTarg = TargetObject position:(stwRay.pos+(stwRay.dir*FocalDist)) name:"camTarg" ; fovVal = getViewFOV()
			NewCamera = case of (
				(jcCB1.Checked == true): TargetCamera pos:stwRay.pos target:camTarg
				(jcCB2.Checked == true): VRayPhysicalCamera pos:stwRay.pos targeted:on target:camTarg specify_fov:on
				(jcCB3.Checked == true): TargetCamera pos:stwRay.pos target:camTarg
				(jcCB4.Checked == true): Main_Camera pos:stwRay.pos target_on:on target:camTarg
			)
			if classof NewCamera != Main_Camera then (NewCamera.fov = fovVal) else (NewCamera.lens.fov = fovVal)
			NewCamera.target.name = NewCamera.name + ".Target"
			NewCamera.wirecolor = NewCamera.target.wirecolor = [87, 120, 204]
			viewport.setCamera NewCamera ; select NewCamera
			if jcCB5.Checked == true do
			(
				jcLB_Items = for i in 1 to jcListBox.Items.Count collect jcListBox.Items.item[i-1]
				onRefresh = true ; append jcLB_Items NewCamera.name ; jcLB_Items = makeUniqueArray jcLB_Items
				jcListBox.items.Clear() ; RefreshOnce jcListBox ; AddRangeFn jcListBox jcLB_Items
			)
		)
	)
	fn jcBtnSwCClick =
	(
		global NextCamView ; CamsCatcher = #()
		CamsCatcher = (for cam in cameras where camFilter cam == true collect cam)
		if CamsCatcher.count != 0 then (
		if viewport.getCamera() != undefined then (activeView = viewport.getCamera())
		else (	activeView = CamsCatcher[1] ) ; noCam = CamsCatcher.count
		for i in 1 to noCam do
		(
			if activeView == CamsCatcher[noCam] then ( NextCamView = CamsCatcher[1] )
			else ( if activeView == CamsCatcher[i] do NextCamView = CamsCatcher[(i + 1)] )
		)
		viewport.setCamera NextCamView ; RedrawActiveView() ) else #abort
	)
	fn jcBtnRVClick =
	(
		if (viewport.getType() != #view_persp_user) then
		(
			viewport.setType #view_persp_user
			ViewCubeOps.GoHome()
		) else ViewCubeOps.GoHome()
	)
	fn jcBtnSvCClick =
	(
		actcam = try(getActiveCamera()) catch()
		if actcam != undefined and actcam.isSelected == false do select actcam
	)
	fn jcBtnSpVClick =
	(
		if (viewport.getType() != #view_persp_user) do viewport.setType #view_persp_user
		local coords = (viewport.getTM()).row3, angleVal = jcSpnAng.Value, speedVal = jcSpnSpd.Value
		if angleVal < 0 do (speedVal = -1*jcSpnSpd.Value)
		for i = 1 to (abs (angleVal/speedVal)) do ( viewport.rotate (quat speedVal coords) ; completeredraw() )
	)
	fn jcBtnSpCClick =
	(
		if selection.count == 1 and isKindof selection[1] camera and selection[1][3].isAnimated == false and animButtonState == false do
		(
			if getCommandPanelTaskMode() != #create do setCommandPanelTaskMode mode:#create
			local spinCam = selection[1]
			case isValidNode spinCam.target of (
				(true): (in coordsys world about spinCam.target rotate spinCam jcSpnAng.Value z_axis ; spinCam.controller.Roll_Angle = 0)
				(false): (
					local pis = spinCam.pos + ((normalize (-spinCam.dir))*spinCam.target_distance)
					in coordsys world about pis rotate spinCam jcSpnAng.Value z_axis
				)
			)
		)
	)
	fn jcSpnAngGF = ( jcSpnAng.BackColor = jcBC2 ; DisableAccel() ) ; fn jcSpnAngLF = ( jcSpnAng.BackColor = jcBC1 ; EnableAccel() )
	fn jcSpnSpdGF = ( jcSpnSpd.BackColor = jcBC2 ; DisableAccel() ) ; fn jcSpnSpdLF = ( jcSpnSpd.BackColor = jcBC1 ; EnableAccel() )
	fn jcSpnACSGF = ( jcSpnACS.BackColor = jcBC2 ; DisableAccel() ) ; fn jcSpnACSLF = ( jcSpnACS.BackColor = jcBC1 ; EnableAccel() )
	fn jcSpnSCSGF = ( jcSpnSCS.BackColor = jcBC2 ; DisableAccel() ) ; fn jcSpnSCSLF = ( jcSpnSCS.BackColor = jcBC1 ; EnableAccel() )
	fn jcCB7Click =
	(
		if jcCB7.Checked == true then ( registerRedrawViewsCallback JC_Labels ; RedrawActiveView() )
		else ( unregisterRedrawViewsCallback JC_Labels ; RedrawActiveView() )
	)
	fn jcCB8Click =
	(
		if jcCB8.Checked != true then 
		(
			jcSpnACS.Enabled = false ; jcLblACS.ForeColor = jcBC2
			jcCB9.Checked = jcCB9.Enabled = jcSpnSAI1.Enabled = jcSpnSAI2.Enabled = false ; jcCB9.FlatStyle = jcFS2
		) else ( jcSpnACS.Enabled = true ; jcLblACS.ForeColor = jcFC ; jcCB9.Enabled = true ; jcCB9.FlatStyle = jcFS3 )
	)
	fn jcCB9Click = ( if jcCB9.Checked != true then (jcSpnSAI1.Enabled = jcSpnSAI2.Enabled = false) else (jcSpnSAI1.Enabled = jcSpnSAI2.Enabled = true) )
	fn jcSpnSAI1GF = ( jcSpnSAI1.BackColor = jcBC2 ; DisableAccel() ) ; fn jcSpnSAI1LF = ( jcSpnSAI1.BackColor = jcBC1 ; EnableAccel() )
	fn jcSpnSAI2GF = ( jcSpnSAI2.BackColor = jcBC2 ; DisableAccel() ) ; fn jcSpnSAI2LF = ( jcSpnSAI2.BackColor = jcBC1 ; EnableAccel() )
	fn jcBtnRCFClick = ( calculateFrames jcTBoxS2 )
	fn jcBtnAFClick =
	(
		local frameNumber = jcTBoxS2.Text
		if ( frameNumber == " JamperCam Frames" or frameNumber == " Create or Select JC!" ) then (#abort)
		else ( rendPickupFrames = frameNumber ; if rendTimeType != 4 do (rendTimeType = 4) ; renderSceneDialog.update())
	)
	fn jcBtnCJCClick = ( if slidertime != 0f do slidertime = 0f ; jcListBox.Focus() ; AdvCamsBake() ; max views redraw ; createJC_List() )
/*//////////   "Tune" Panel FN   //////////*/
	fn jcComBoxJCLMH = ( jcComBoxJCL.Focus() ; print jcComBoxJCL.Items)
	fn jcComBoxJCLMD = ( createJC_List() )
	fn jcBtnSJCClick =
	(
		if jcComBoxJCL.Items.count > 0 and isValidNode (getNodeByName jcComBoxJCL.SelectedItem) do 
		(
			select (getNodeByName jcComBoxJCL.SelectedItem) ; if keyboard.controlPressed do max vpt camera
		)
	)
	fn jcBtnT1KClick =
	(
		local sc = selection[1]
		if selection.count == 1 and isKindof sc camera and sc[3].isAnimated == true do (slidertime = sc[3][1].track.keys[1].time)
	)
	fn jcBtnT2KClick =
	(
		local vptcam = try(getActiveCamera()) catch()
		if vptcam != undefined and vptcam.isSelected == false do select vptcam
		getT_Bar = maxOps.getTrackBar() ; slidertime = (at time slidertime getT_Bar.getpreviouskeytime())
	)
	fn jcBtnT3KClick =
	(
		local vptcam = try(getActiveCamera()) catch()
		if vptcam != undefined and vptcam.isSelected == false do select vptcam
		getT_Bar = maxOps.getTrackBar() ; slidertime = (at time slidertime getT_Bar.getnextkeytime())
	)
	fn jcBtnT4KClick =
	(
		local sc = selection[1]
		if selection.count == 1 and isKindof sc camera and sc[3].isAnimated == true do ( local kcnt = sc[3][1].track.keys.count ; slidertime = sc[3][1].track.keys[kcnt].time )
	)
	fn jcBtnPlayClick arg =
	(
		if jcBtnPlay.BackColor == jcBC1 and isAnimPlaying() == false then
		(
			jcBtnPlay.BackColor = jcFC ; jcBtnPlay.ForeColor = jcBC2
			if selection.count != 0 and keyboard.controlPressed then playAnimation #selOnly else playAnimation()
		)
		else (	jcBtnPlay.BackColor = jcBC1 ; jcBtnPlay.ForeColor = jcFC ; stopAnimation() )
	)
	fn animPlayState =
	(
		if isAnimPlaying() == false then (jcBtnPlay.BackColor = jcBC1 ; jcBtnPlay.ForeColor = jcFC)
		else (jcBtnPlay.BackColor = jcFC ; jcBtnPlay.ForeColor = jcBC1)
	)
	fn jcSpnNthFGF = ( jcSpnNthF.BackColor = jcBC2 ; DisableAccel() ) ; fn jcSpnNthFLF = ( jcSpnNthF.BackColor = jcBC1 ; EnableAccel() )
	fn jcBtnT1FClick = sliderTime = animationRange.start
	fn jcBtnT2FClick =
	(
		local NthF_Step = jcSpnNthF.Value
		if animationRange.start == sliderTime do
		animationRange = interval (animationRange.start - NthF_Step) (animationRange.end - NthF_Step)
		sliderTime -= NthF_Step
	)
	fn jcBtnT3FClick =
	(
		local NthF_Step = jcSpnNthF.Value
		if animationRange.end == sliderTime do
		animationRange = interval (animationRange.start + NthF_Step) (animationRange.end + NthF_Step)
		sliderTime += NthF_Step
	)
	fn jcBtnT4FClick = (sliderTime = animationRange.end)
	fn jcSpnStartVC = ( if jcSpnStart.Value >= jcSpnEnd.Value do (jcSpnStart.Value = jcSpnEnd.Value - 1) ; animationRange = interval (jcSpnStart.Value) (jcSpnEnd.Value) )
	fn jcSpnStartGF = ( jcSpnStart.BackColor = jcBC2 ; DisableAccel() ; jctimeTick.active = false ) ; fn jcSpnStartLF = ( jcSpnStart.BackColor = jcBC1 ; EnableAccel() ; jctimeTick.active = true)
	fn jcSpnEndVC = ( if jcSpnEnd.Value <= jcSpnStart.Value do (jcSpnEnd.Value = jcSpnStart.Value + 1) ; animationRange = interval (jcSpnStart.Value) (jcSpnEnd.Value) )
	fn jcSpnEndGF = ( jcSpnEnd.BackColor = jcBC2 ; DisableAccel() ; jctimeTick.active = false) ; fn jcSpnEndLF = ( jcSpnEnd.BackColor = jcBC1 ; EnableAccel() ; jctimeTick.active = true)
	fn jcSpnSlidVC =
	(
		if jcSpnSlid.Value < animationRange.start then jcSpnSlid.Value = animationRange.start
		else if jcSpnSlid.Value > animationRange.end do jcSpnSlid.Value = animationRange.end
		sliderTime = jcSpnSlid.Value
		jcLblAInf.Text = "FPS | frame | time >>>\n" + framerate as string + " | " + (jcSpnSlid.value as time) as string + " | " + (jcSpnSlid.value as float/framerate) as string + "s"
	)
	fn jcSpnSlidGF = ( jcSpnSlid.BackColor = jcBC2 ; DisableAccel() ; jctimeTick.active = false ) ; fn jcSpnSlidLF = ( jcSpnSlid.BackColor = jcBC1 ; EnableAccel() ; jctimeTick.active = true)
	fn IncrementUpToTen sender arg = if arg.keyValue == 17 do sender.Increment = 10
	fn IncrementDnToZero sender arg =
	(
		local spnCnt = (sender.Value as string).count
		if arg.keyValue == 13 do
		(
			if sender.Value > sender.Maximum then sender.Value = sender.Maximum
			else if sender.Value < sender.Minimum do sender.Value = sender.Minimum
			if sender.Focused == true do sender.Select 0 spnCnt
		)
		if arg.keyValue == 27 do ( if sender.Value != 0 and sender.Focused == true do (sender.Value = 0 ; sender.Select 0 1) )
		if arg.keyValue == 17 do sender.Increment = 1
	)
	fn IncrementDnToOne sender arg =
	(
		local spnCnt = (sender.Value as string).count
		if arg.keyValue == 13 do
		(
			if sender.Value > sender.Maximum then sender.Value = sender.Maximum
			else if sender.Value < sender.Minimum do sender.Value = sender.Minimum
			if sender.Focused == true do sender.Select 0 spnCnt
		)
		if arg.keyValue == 27 do ( if sender.Value != 1 and sender.Focused == true do (sender.Value = 1 ; sender.Select 0 1) )
		if arg.keyValue == 17 do sender.Increment = 1
	)
	fn IncrementDnRstZero sender arg =
	(
		local spnCnt = (sender.Value as string).count
		if arg.keyValue == 13 do
		(
			if sender.Value > sender.Maximum then sender.Value = sender.Maximum
			else if sender.Value < sender.Minimum do sender.Value = sender.Minimum
			if sender.Focused == true do ( sender.Value = 0 ; sender.Select 0 spnCnt )
		)
		if arg.keyValue == 27 do ( if sender.Value != 1 and sender.Focused == true do (sender.Value = 1 ; sender.Select 0 1) )
		if arg.keyValue == 17 do sender.Increment = 1
	)
	fn jcCBAnimClick =
	(
		if jcCBAnim.Checked != true then ( jcLblAnim.Text = " ANIMATE : OFF" ; jcCBAnim.ForeColor = jcFC ;  animButtonState = false)
		else ( jcLblAnim.Text = " ANIMATE : ON" ; jcCBAnim.ForeColor = jcWFC ; animButtonState = true)
		jcLblSlid_FOV.invalidate() ; jcLblSlid_TD.invalidate() ;  ; jcLblSlid_SS.invalidate() ; jcLblSlid_FS.invalidate() ; jcLblSlid_ISO.invalidate()
	)
	fn animBtnState = 
	(
		if animButtonState == false then (jcCBAnim.Checked = false ; jcLblAnim.Text = " ANIMATE : OFF" ; jcCBAnim.ForeColor = jcFC)
		else (jcCBAnim.Checked = true ; jcLblAnim.Text = " ANIMATE : ON" ; jcCBAnim.ForeColor = jcWFC)
		jcLblSlid_FOV.invalidate() ; jcLblSlid_TD.invalidate() ;  ; jcLblSlid_SS.invalidate() ; jcLblSlid_FS.invalidate() ; jcLblSlid_ISO.invalidate()
	)
	fn animBtnCheck = (if animButtonState == true then jcCBAnim.Checked = true else jcCBAnim.Checked = false ; jcCBAnimClick())
	fn jcBtnT1NClick = (max dolly mode) ; fn jcBtnT2NClick = (max persp) ; fn jcBtnT3NClick = (max roll) ; fn jcBtnT4NClick = (max fov)
	fn jcBtnT5NClick = (max accel pan) ; fn jcBtnT6NClick = (walkThroughOps.start()) ; fn jcBtnT7NClick = (max rotateview)
	fn jcBtnT8NClick = (if GetSelectFilter() != 5 then SetSelectFilter 5 else SetSelectFilter 1)
	fn jcBtnFSMClick =
	(
		state = not(timeslider.isVisible())
		trackbar.visible = state
		timeSlider.setVisible state
		if state then cui.expertModeOff() else cui.expertModeOn()
		statusPanel.visible = state
		try ( if MaxRibbon.IsRibbonOpen() == true do MaxRibbon.ShowRibbon false ) catch()
	)
	fn jcBtnVPTClick = ( actionMan.executeAction 1261319018 "Viewports" )
	fn selectionCheck =
	(
		createJC_List()
		if isCreatingObject() != true and selection.count == 1 and isKindof selection[1] camera and not isKindof selection[1] VRayDomeCamera then
		(
			local currR = (renderers.current.classid as string), nc = selection[1]
			case getClassName nc of (
				("SimpleCamera"): (
					jcComBoxLens.Enabled = jcSpn_FOV.Enabled = jcSpn_TD.Enabled = true ; jcSpn_FOV.Value = nc.fov
					if classof nc == Freecamera then try (jcSpn_TD.Value = nc.target_Distance) catch()
					else if classof nc == Targetcamera do
					(
						try(if isValidNode nc.Target.Parent then jcSpn_TD.Enabled = false else jcSpn_TD.Value = nc.targetDistance) catch()
					)
					if (currR == mrR or currR == mrIRR) and classof SceneExposureControl.exposureControl == mr_Photographic_Exposure_Control then
					(
						try (
						jcSpn_SS.Enabled = jcSpn_FS.Enabled = jcSpn_ISO.Enabled = true
						jcSpn_SS.Value = SceneExposureControl.exposureControl.shutter_speed
						jcSpn_FS.Value = SceneExposureControl.exposureControl.f_stop
						jcSpn_ISO.Value = SceneExposureControl.exposureControl.film_isoUI
						) catch()
					)
					else if (currR == vrR or currR == vrRTR) and classof SceneExposureControl.exposureControl == VRay_Exposure_Control then
					(
						try (
						jcSpn_SS.Enabled = jcSpn_FS.Enabled = jcSpn_ISO.Enabled = true
						jcSpn_SS.Value = SceneExposureControl.exposureControl.shutter
						jcSpn_FS.Value = SceneExposureControl.exposureControl.f_number
						jcSpn_ISO.Value = SceneExposureControl.exposureControl.ISO
						) catch()
					)
					else if (currR == frR and (try(nc.baseObject.ReferenceTarget.exposure_enable == on)catch()) ) then
					(
						try (
						jcSpn_SS.Enabled = jcSpn_FS.Enabled = jcSpn_ISO.Enabled = true
						jcSpn_SS.Value = nc.baseObject.ReferenceTarget.shutter_speed
						jcSpn_FS.Value = nc.baseObject.ReferenceTarget.f_number
						jcSpn_ISO.Value = nc.baseObject.ReferenceTarget.film_iso
						) catch()
					)
					else (jcSpn_SS.Enabled = jcSpn_FS.Enabled = jcSpn_ISO.Enabled = false)
				)
				("VRayPhysicalCamera"): (
					jcComBoxLens.Enabled = jcSpn_FOV.Enabled = jcSpn_SS.Enabled = jcSpn_FS.Enabled = jcSpn_ISO.Enabled = true
					if nc.targeted == on then jcSpn_TD.Enabled = false else jcSpn_TD.Enabled = true
					try(jcSpn_FOV.Value = nc.fov ; jcSpn_TD.Value = nc.target_distance)catch()
					if nc.shutter_speed >= jcSpn_SS.Minimum or nc.shutter_speed <= jcSpn_SS.MMaksimum do jcSpn_SS.Value = nc.shutter_speed
					if nc.shutter_speed >= jcSpn_FS.Minimum or nc.shutter_speed <= jcSpn_FS.MMaksimum do jcSpn_FS.Value = nc.f_number
					if nc.shutter_speed >= jcSpn_ISO.Minimum or nc.shutter_speed <= jcSpn_ISO.MMaksimum do jcSpn_ISO.Value = nc.ISO
				)
				("Main Camera"): (
					jcSpn_SS.Enabled = jcSpn_FS.Enabled = jcSpn_ISO.Enabled = false
					if classof nc.lens != Environ_Mapper_Lens then
					(
						jcComBoxLens.Enabled = jcSpn_FOV.Enabled = true ; try(jcSpn_FOV.Value = nc.lens.fov)catch()
					)
					else ( jcComBoxLens.Enabled = jcSpn_FOV.Enabled = false ; jcSpn_FOV.Value = jcSpn_FOV.Value )
					jcSpn_TD.Enabled = true ; try(jcSpn_TD.Value = nc.target_distance)catch()
				)
			)
		) else (jcComBoxLens.Enabled = jcSpn_FOV.Enabled = jcSpn_TD.Enabled = jcSpn_SS.Enabled = jcSpn_FS.Enabled = jcSpn_ISO.Enabled = false)
	)
	fn updateValue =
	(
		if isCreatingObject() != true and selection.count == 1 and isKindof selection[1] camera and not isKindof selection[1] VRayDomeCamera do
		(
			local currR = (renderers.current.classid as string), nc = selection[1]
			case getClassName nc of (
				("SimpleCamera"): (
					jcSpn_FOV.Value = nc.fov
					if classof nc == Freecamera then try (jcSpn_TD.Value = nc.target_Distance) catch()
					else if classof nc == Targetcamera do
					(
						if nc.Target.Parent != undefined then jcSpn_TD.Enabled = false else jcSpn_TD.Value = nc.targetDistance
					)
					if (currR == mrR or currR == mrIRR) and classof SceneExposureControl.exposureControl == mr_Photographic_Exposure_Control then
					(
						jcSpn_SS.Value = SceneExposureControl.exposureControl.shutter_speed
						jcSpn_FS.Value = SceneExposureControl.exposureControl.f_stop
						jcSpn_ISO.Value = SceneExposureControl.exposureControl.film_isoUI
					)
					else if (currR == vrR or currR == vrRTR) and classof SceneExposureControl.exposureControl == VRay_Exposure_Control then
					(
						jcSpn_SS.Value = SceneExposureControl.exposureControl.shutter
						jcSpn_FS.Value = SceneExposureControl.exposureControl.f_number
						jcSpn_ISO.Value = SceneExposureControl.exposureControl.ISO
					) 
					else if (currR == frR and (try(nc.baseObject.ReferenceTarget.exposure_enable == on)catch()) ) do
					(
						jcSpn_SS.Value = nc.baseObject.ReferenceTarget.shutter_speed
						jcSpn_FS.Value = nc.baseObject.ReferenceTarget.f_number
						jcSpn_ISO.Value = nc.baseObject.ReferenceTarget.film_iso
					)
				)
				("VRayPhysicalCamera"): (
					try( jcSpn_FOV.Value = nc.fov ; jcSpn_TD.Value = nc.target_distance  )catch()
					if nc.shutter_speed >= jcSpn_SS.Minimum or nc.shutter_speed <= jcSpn_SS.MMaksimum do jcSpn_SS.Value = nc.shutter_speed
					if nc.shutter_speed >= jcSpn_FS.Minimum or nc.shutter_speed <= jcSpn_FS.MMaksimum do jcSpn_FS.Value = nc.f_number
					if nc.shutter_speed >= jcSpn_ISO.Minimum or nc.shutter_speed <= jcSpn_ISO.MMaksimum do jcSpn_ISO.Value = nc.ISO
				)
				("Main Camera"): (
					try(
					if classof nc.lens != Environ_Mapper_Lens then (jcSpn_FOV.Value = nc.lens.fov) else ( jcSpn_FOV.Value = jcSpn_FOV.Value )
					jcSpn_TD.Value = nc.target_distance )catch()
				)
			)
		)
	)
	fn jcComBoxLensSIC =
	(
		local selCamFovVal
		if classof selection[1] != Main_Camera then (selCamFovVal = selection[1].fov) else (selCamFovVal = selection[1].lens.fov)
		case jcComBoxLens.SelectedIndex of (
			1:	( selCamFovVal = jcSpn_FOV.Value = 100.389 )
			2:	( selCamFovVal = jcSpn_FOV.Value = 83.9744 )
			3:	( selCamFovVal = jcSpn_FOV.Value = 73.7398 )
			4:	( selCamFovVal = jcSpn_FOV.Value = 65.4705 )
			5:	( selCamFovVal = jcSpn_FOV.Value = 54.4322 )
			6:	( selCamFovVal = jcSpn_FOV.Value = 39.5978 )
			7:	( selCamFovVal = jcSpn_FOV.Value = 23.9132 )
			8:	( selCamFovVal = jcSpn_FOV.Value = 15.1893 )
			9:	( selCamFovVal = jcSpn_FOV.Value = 10.28551 )
		)
	)
	fn jcComBoxLensMH = (jcComBoxLens.Focus() ; if (classof selection[1] == VRayPhysicalCamera and selection[1].specify_fov == off) do (selection[1].specify_fov = on))
	fn jcComBoxLensLF = (if jcComBoxLens.SelectedIndex != 0 do jcComBoxLens.SelectedIndex = 0)
	fn jcLblSlid_FOVMD argfov = ( getClickPosX jcSpn_FOV jcLblSlid_FOV Arr_FOV argfov ; followMouse = true )
	fn jcLblSlid_FOVMM argfov = ( if followMouse == true do (getClickPosX jcSpn_FOV jcLblSlid_FOV Arr_FOV argfov) )
	fn jcLblSlid_FOVMU = ( followMouse = false ; if jcSpn_FOV.Focused != true do jcSpn_FOV.Focus() ; jcClickpos = undefined )
	fn jcLblSlid_FOVPaint colfov = ( PaintSlide jcSpn_FOV jcLblSlid_FOV Arr_FOV colfov )
	fn jcSpn_FOVVC = ( jcLblSlid_FOV.invalidate() ; if classof selection[1] != Main_Camera then (selection[1].fov = jcSpn_FOV.Value) else (selection[1].lens.fov = jcSpn_FOV.Value))
	fn jcSpn_FOVGF =
	(
		selectionCheck()
		if jcCBAnim.Checked != true then jcSpn_FOV.BackColor = jcBC2 else jcSpn_FOV.BackColor = jcWMC ; DisableAccel()
		if (classof selection[1] == VRayPhysicalCamera and selection[1].specify_fov == off) do (selection[1].specify_fov = on)
	)
	fn jcSpn_FOVLF = ( jcSpn_FOV.BackColor = jcBC1 ; EnableAccel() )
	fn jcLblSlid_TDMD argtd = ( getClickPosX jcSpn_TD jcLblSlid_TD Arr_TD argtd ; followMouse = true )
	fn jcLblSlid_TDMM argtd = ( if followMouse == true do (getClickPosX jcSpn_TD jcLblSlid_TD Arr_TD argtd) )
	fn jcLblSlid_TDMU = ( followMouse = false ; if jcSpn_TD.Focused != true do jcSpn_TD.Focus() ; jcClickpos = undefined )
	fn jcLblSlid_TDPaint coltd = ( PaintSlide jcSpn_TD jcLblSlid_TD Arr_TD coltd )
	fn jcSpn_TDVC =
	(
		jcLblSlid_TD.invalidate() 
		local currR = (renderers.current.classid as string), nc = selection[1]
		case getClassName nc of (
			("SimpleCamera"): (
				if classof nc == Freecamera then (nc.target_Distance = jcSpn_TD.Value)
				else if classof nc == Targetcamera do try (nc.targetDistance = jcSpn_TD.Value) catch()
			)
			("VRayPhysicalCamera"): ( if nc.targeted == off do nc.target_distance = jcSpn_TD.Value )
			("Main Camera"): ( nc.target_distance = jcSpn_TD.Value )
		)
	)
	fn jcSpn_TDGF = ( selectionCheck() ; if jcCBAnim.Checked != true then jcSpn_TD.BackColor = jcBC2 else jcSpn_TD.BackColor = jcWMC ; DisableAccel() )
	fn jcSpn_TDLF = ( jcSpn_TD.BackColor = jcBC1 ; EnableAccel() )
	fn jcLblSlid_SSMD argss = ( getClickPosX jcSpn_SS jcLblSlid_SS Arr_SS argss ; followMouse = true )
	fn jcLblSlid_SSMM argss = ( if followMouse == true do (getClickPosX jcSpn_SS jcLblSlid_SS Arr_SS argss) )
	fn jcLblSlid_SSMU = ( followMouse = false ; if jcSpn_SS.Focused != true do jcSpn_SS.Focus() ; jcClickpos = undefined )
	fn jcLblSlid_SSPaint colss = ( PaintSlide jcSpn_SS jcLblSlid_SS Arr_SS colss )
	fn jcSpn_SSVC =
	(
		jcLblSlid_SS.invalidate() 
		local currR = (renderers.current.classid as string), nc = selection[1]
		case getClassName nc of (
			("SimpleCamera"): (
				if (currR == mrR or currR == mrIRR) and classof SceneExposureControl.exposureControl == mr_Photographic_Exposure_Control then
				(
					try ( SceneExposureControl.exposureControl.shutter_speed = jcSpn_SS.Value) catch()
				)
				else if (currR == vrR or currR == vrRTR) and classof SceneExposureControl.exposureControl == VRay_Exposure_Control then
				(
					try ( SceneExposureControl.exposureControl.shutter = jcSpn_SS.Value ) catch()
				)
				else if (currR == frR and (try(nc.baseObject.ReferenceTarget.exposure_enable == on)catch()) ) do
				(
					try ( nc.baseObject.ReferenceTarget.shutter_speed = jcSpn_SS.Value ) catch()
				)
			)
			("VRayPhysicalCamera"): ( nc.shutter_speed = jcSpn_SS.Value )
		)
	)
	fn jcSpn_SSGF = ( if jcCBAnim.Checked != true then jcSpn_SS.BackColor = jcBC2 else jcSpn_SS.BackColor = jcWMC ; DisableAccel() )
	fn jcSpn_SSLF = ( jcSpn_SS.BackColor = jcBC1 ; EnableAccel() )
	fn jcLblSlid_FSMD argfs = ( getClickPosX jcSpn_FS jcLblSlid_FS Arr_FS argfs ; followMouse = true )
	fn jcLblSlid_FSMM argfs = ( if followMouse == true do (getClickPosX jcSpn_FS jcLblSlid_FS Arr_FS argfs) )
	fn jcLblSlid_FSMU = ( followMouse = false ; if jcSpn_FS.Focused != true do jcSpn_FS.Focus() ; jcClickpos = undefined )
	fn jcLblSlid_FSPaint colfs = ( PaintSlide jcSpn_FS jcLblSlid_FS Arr_FS colfs )
	fn jcSpn_FSVC =
	(
		jcLblSlid_FS.invalidate() 
		local currR = (renderers.current.classid as string), nc = selection[1]
		case getClassName nc of (
			("SimpleCamera"): (
				if (currR == mrR or currR == mrIRR) and classof SceneExposureControl.exposureControl == mr_Photographic_Exposure_Control then
				(
					try ( SceneExposureControl.exposureControl.f_stop = jcSpn_FS.Value) catch()
				)
				else if (currR == vrR or currR == vrRTR) and classof SceneExposureControl.exposureControl == VRay_Exposure_Control then
				(
					try ( SceneExposureControl.exposureControl.f_number = jcSpn_FS.Value ) catch()
				)
				else if (currR == frR and (try(nc.baseObject.ReferenceTarget.exposure_enable == on)catch()) ) do
				(
					try ( nc.baseObject.ReferenceTarget.f_number = jcSpn_FS.Value ) catch()
				)
			)
			("VRayPhysicalCamera"): ( nc.f_number = jcSpn_FS.Value )
		)
	)
	fn jcSpn_FSGF = ( if jcCBAnim.Checked != true then jcSpn_FS.BackColor = jcBC2 else jcSpn_FS.BackColor = jcWMC ; DisableAccel() )
	fn jcSpn_FSLF = ( jcSpn_FS.BackColor = jcBC1 ; EnableAccel() )
	fn jcLblSlid_ISOMD argiso = ( getClickPosX jcSpn_ISO jcLblSlid_ISO Arr_ISO argiso ; followMouse = true )
	fn jcLblSlid_ISOMM argiso = ( if followMouse == true do (getClickPosX jcSpn_ISO jcLblSlid_ISO Arr_ISO argiso) )
	fn jcLblSlid_ISOMU = ( followMouse = false ; if jcSpn_ISO.Focused != true do jcSpn_ISO.Focus() ; jcClickpos = undefined )
	fn jcLblSlid_ISOPaint coliso = ( PaintSlide jcSpn_ISO jcLblSlid_ISO Arr_ISO coliso )
	fn jcSpn_ISOVC =
	(
		jcLblSlid_ISO.invalidate() 
		local currR = (renderers.current.classid as string), nc = selection[1]
		case getClassName nc of (
			("SimpleCamera"): (
				if (currR == mrR or currR == mrIRR) and classof SceneExposureControl.exposureControl == mr_Photographic_Exposure_Control then
				(
					try ( SceneExposureControl.exposureControl.film_isoUI = jcSpn_ISO.Value) catch()
				)
				else if (currR == vrR or currR == vrRTR) and classof SceneExposureControl.exposureControl == VRay_Exposure_Control then
				(
					try ( SceneExposureControl.exposureControl.ISO = jcSpn_ISO.Value ) catch()
				)
				else if (currR == frR and (try(nc.baseObject.ReferenceTarget.exposure_enable == on)catch()) ) do
				(
					try ( nc.baseObject.ReferenceTarget.film_iso = jcSpn_ISO.Value ) catch()
				)
			)
			("VRayPhysicalCamera"): ( nc.ISO = jcSpn_ISO.Value )
		)
	)
	fn jcSpn_ISOGF = ( if jcCBAnim.Checked != true then jcSpn_ISO.BackColor = jcBC2 else jcSpn_ISO.BackColor = jcWMC ; DisableAccel() )
	fn jcSpn_ISOLF = ( jcSpn_ISO.BackColor = jcBC1 ; EnableAccel() )
	fn create_JC_Callbacks =
	(
		callbacks.addScript #selectionSetChanged "jcRoll.selectionCheck()" id:#JamperCam
		callbacks.addScript #nodeLayerChanged "jcRoll.selectionCheck()" id:#JamperCam
		if selection.count == 1 then select $ else clearSelection()
	)
	fn remove_JC_Callbacks = ( callbacks.removeScripts id:#JamperCam )
/*//////////   "Jump" Panel FN   //////////*/
	fn jcSpnXYKD arg = if arg.keyValue == 17 and jcComBoxJCG.SelectedIndex == 5 do jcSpnX.Increment = jcSpnY.Increment = 10
	fn jcSpnXYKU arg = 
	(
		if arg.keyValue == 13 do
		(
			if jcSpnX.Value > jcSpnX.Maximum do jcSpnX.Value = jcSpnX.Maximum
			if jcSpnY.Value > jcSpnY.Maximum do jcSpnY.Value = jcSpnY.Maximum	
			if jcSpnX.Focused == true do jcSpnX.Select 0 3 ; if jcSpnY.Focused == true do jcSpnY.Select 0 3 
		)
		if arg.keyValue == 27 do
		( 
			if jcSpnX.Value != 1 and jcSpnX.Focused == true do (jcSpnX.Value = 1 ; jcSpnX.Select 0 1)
			if jcSpnY.Value != 1 and jcSpnY.Focused == true do (jcSpnY.Value = 1 ; jcSpnY.Select 0 1 )
		)
		if arg.keyValue == 17 and jcComBoxJCG.SelectedIndex == 5 do jcSpnX.Increment = jcSpnY.Increment = 1
	)
	fn jcComBoxJCGMH = (jcComBoxJCG.Focus())
	fn jcComBoxJCGSIC =
	(
		RedrawActiveView() ; onRefresh = true
		if jcComBoxJCG.SelectedIndex == 4 or jcComBoxJCG.SelectedIndex == 5 then 
		(jcSpnX.Enabled = jcSpnY.Enabled = true ; jcLblX.ForeColor = jcLblY.ForeColor = jcFC)
		else (jcSpnX.Enabled = jcSpnY.Enabled = false ; jcLblX.ForeColor = jcLblY.ForeColor = jcBC2)
		if jcComBoxJCG.SelectedIndex == 6 or jcComBoxJCG.SelectedIndex == 7 then 
		(jcCBtbg.Enabled = true ; jcCBtbg.FlatStyle = jcFS3) else (jcCBtbg.Enabled = false ; jcCBtbg.FlatStyle = jcFS2)
		if jcComBoxJCG.SelectedIndex == 4 then (jcSpnX.Maximum = jcSpnY.Maximum = 500 ; jcSpnX.Value = jcSpnY.Value = 3)
		else if jcComBoxJCG.SelectedIndex == 5 do (jcSpnX.Value = jcSpnY.Value = 3) ; RefreshOnce jcComBoxJCG
	)
	fn colorDialogCol sender col =
	(
		jcColDial.ShowDialog()
		col = (dotNetClass "System.Drawing.Color").fromARGB jcColDiaL.Color.r jcColDiaL.Color.g jcColDiaL.Color.b
		sender.BackColor = col ; mCol = sender.BackColor
		maxColor = color (mCol.r) (mCol.g) (mCol.b) ; RedrawActiveView()
	)
	fn CamInfoGridView =
	(
		local vpSizeX = gw.getWinSizeX(), vpSizeY = gw.getWinSizeY(), imgSizeX = RenderWidth, imgSizeY = RenderHeight
		local actCam = selection[1], currR = renderers.current.classid as string, GR = 0.5 * (1.0 + (sqrt 5.0))
		local vpAspect = vpSizeX as float / vpSizeY as float, imgAspect = imgSizeX as float / imgSizeY as float
		local bCL = jcBtnClrL.BackColor, bCT = jcBtnClrT.BackColor, lineCol = (color bCL.r bCL.g bCL.b), textCol = white, textInfoCol = (color bCT.r bCT.g bCT.b)
		local n = (jcComBoxJCG.SelectedIndex + 1), gridName = GridTypeArr[n]+" mode >>>"	; gw.setColor #line lineCol
		if lineCol.r > 200 or lineCol.g > 200 or lineCol.b > 200 then textCol = black else textCol = white
		if classof actCam == VRayPhysicalCamera then (rectCol1 = (color 220 90 100))
		else if classof actCam == Targetcamera then (rectCol1 = (color 100 150 200))
		else if classof actCam == Freecamera then (rectCol1 = (color 50 150 110))
		else if classof actCam == Main_Camera do (rectCol1 = (color 220 140 70))
		if (DisplaySafeFrames == true) then
		(
			if vpAspect > imgAspect then
			(
				sfAspect = vpSizeY as float / imgSizeY as float
				sfSizeX = imgSizeX * sfAspect ; sfSizeY = vpSizeY
				vpOffsetX = (vpSizeX - sfSizeX)/2 ; vpOffsetY = 0
			)
			else
			(
				sfAspect = vpSizeX as float / imgSizeX as float
				sfSizeX = vpSizeX ; sfSizeY = imgSizeY * sfAspect
				vpOffsetY = (vpSizeY - sfSizeY)/2 ; vpOffsetX = 0
			)
			rotSizeX = sfSizeX / 3 ; rotSizeY = sfSizeY / 3
			qSizeX = sfSizeX / 2 ; qSizeY = sfSizeY / 2
			crosX = qSizeX-25 ; crosY = qSizeY-25
			grSizeX = sfSizeX as float / GR ; grSizeY = sfSizeY as float / GR
		)
		else
		(
			vpOffsetX = 0 ; vpOffsetY = 0 ; sfSizeX = vpSizeX ; sfSizeY = vpSizeY
			rotSizeX = vpSizeX / 3 ; rotSizeY = vpSizeY / 3
			qSizeX = vpSizeX / 2 ; qSizeY = vpSizeY / 2
			crosX = qSizeX-25 ; crosY = qSizeY-25
			grSizeX = vpSizeX as float / GR ; grSizeY = vpSizeY as float / GR
		)
		case jcComBoxJCG.SelectedIndex of (
		0:	(
				gw.wPolyline #([1+vpOffsetX, rotSizeY+vpOffsetY, 0], [3*rotSizeX+vpOffsetX, rotSizeY+vpOffsetY, 0]) false
				gw.wPolyline #([1+vpOffsetX, 2*rotSizeY+vpOffsetY, 0], [3*rotSizeX+vpOffsetX, 2*rotSizeY+vpOffsetY, 0]) false
				gw.wPolyline #([rotSizeX+vpOffsetX, 1+vpOffsetY, 0], [rotSizeX+vpOffsetX, 3*rotSizeY+vpOffsetY, 0]) false
				gw.wPolyline #([2*rotSizeX+vpOffsetX, 1+vpOffsetY, 0], [2*rotSizeX+vpOffsetX, 3*rotSizeY+vpOffsetY, 0]) false
			)
		1:	(
				gw.wPolyline #([1+vpOffsetX, qSizeY+vpOffsetY, 0], [sfSizeX+vpOffsetX, qSizeY+vpOffsetY, 0]) false
				gw.wPolyline #([qSizeX+vpOffsetX, 1+vpOffsetY, 0], [qSizeX+vpOffsetX, sfSizeY+vpOffsetY, 0]) false
			)
		2:	(
				gw.wPolyline #([1+vpOffsetX, sfSizeY-grSizeY+vpOffsetY, 0], [sfSizeX+vpOffsetX, sfSizeY-grSizeY+vpOffsetY, 0]) false
				gw.wPolyline #([1+vpOffsetX, grSizeY+vpOffsetY, 0], [sfSizeX+vpOffsetX, grSizeY+vpOffsetY, 0]) false
				gw.wPolyline #([sfSizeX-grSizeX+vpOffsetX, 1+vpOffsetY, 0], [sfSizeX-grSizeX+vpOffsetX, sfSizeY+vpOffsetY, 0]) false
				gw.wPolyline #([grSizeX+vpOffsetX, 1+vpOffsetY, 0], [grSizeX+vpOffsetX, sfSizeY+vpOffsetY, 0]) false
			)
		3:	(
				gw.wPolyline #([1+vpOffsetX, sfSizeY+vpOffsetY, 0], [sfSizeX+vpOffsetX, vpOffsetY, 0]) false
				gw.wPolyline #([1+vpOffsetX, vpOffsetY, 0], [sfSizeX+vpOffsetX, sfSizeY+vpOffsetY, 0]) false
			)
		4:	(
				spnX = sfSizeX / (jcSpnX.Value+1) as float
				for i=1 to jcSpnX.value do ( gw.wPolyline #([i*spnX+vpOffsetX, 1+vpOffsetY, 0], [i*spnX+vpOffsetX,sfSizeY+vpOffsetY, 0]) false )
				spnY = sfSizeY / (jcSpnY.Value+1) as float
				for i=1 to jcSpnY.value do (	gw.wPolyline #([1+vpOffsetX, i*spnY+vpOffsetY, 0], [sfSizeX+vpOffsetX, i*spnY+vpOffsetY, 0]) false )
			)
		5:	(
				spnXLimit = (sfSizeX/2)-85 ; spnYLimit = (sfSizeY/2)-85
				jcSpnX.Maximum = spnXLimit ; jcSpnY.Maximum = spnYLimit
				offCrosX = qSizeX-50 ; offCrosY = qSizeY-50
				M1 = [1+vpOffsetX+offCrosX-jcSpnX.Value, 1+vpOffsetY+offCrosY-jcSpnY.Value, 0]
				M2 = [(sfSizeX+vpOffsetX-offCrosX)+jcSpnX.Value, 1+vpOffsetY+offCrosY-jcSpnY.Value, 0]
				M3 = [1+vpOffsetX+offCrosX-jcSpnX.Value, (sfSizeY+vpOffsetY-offCrosY)+jcSpnY.Value, 0]
				M4 = [(sfSizeX+vpOffsetX-offCrosX)+jcSpnX.Value, (sfSizeY+vpOffsetY-offCrosY)+jcSpnY.Value, 0]
				LM1 = [1+vpOffsetX+25, 1+vpOffsetY+25, 0]
				LM2 = [sfSizeX+vpOffsetX-25, 1+vpOffsetY+25, 0]
				LM3 = [1+vpOffsetX+25, sfSizeY+vpOffsetY-25, 0]
				LM4 = [sfSizeX+vpOffsetX-25, sfSizeY+vpOffsetY-25, 0]
				gw.wPolyline #([1+vpOffsetX+crosX, qSizeY+vpOffsetY, 0], [sfSizeX+vpOffsetX-crosX, qSizeY+vpOffsetY, 0]) false
				gw.wPolyline #([qSizeX+vpOffsetX, 1+vpOffsetY+crosY, 0], [qSizeX+vpOffsetX, sfSizeY+vpOffsetY-crosY, 0]) false
				gw.wPolyline #(LM1, [LM1.x+80, LM1.y, 0]) false ; gw.wPolyline #([LM1.x, LM1.y+1, 0], [LM1.x, LM1.y+80, 0]) false
				gw.wPolyline #(LM2, [LM2.x-80, LM2.y, 0]) false ; gw.wPolyline #([LM2.x, LM2.y+1, 0], [LM2.x, LM2.y+80, 0]) false
				gw.wPolyline #(LM3, [LM3.x+80, LM3.y, 0]) false ; gw.wPolyline #([LM3.x, LM3.y-80, 0], [LM3.x, LM3.y+1, 0]) false
				gw.wPolyline #(LM4, [LM4.x-80, LM4.y, 0]) false ; gw.wPolyline #([LM4.x, LM4.y-80, 0], [LM4.x, LM4.y+1, 0]) false
				gw.wPolyline #(M1, [M1.x+40, M1.y, 0]) false ; gw.wPolyline #([M1.x, M1.y+1, 0], [M1.x, M1.y+40, 0]) false
				gw.wPolyline #(M2, [M2.x-40, M2.y, 0]) false ; gw.wPolyline #([M2.x, M2.y+1, 0], [M2.x, M2.y+40, 0]) false
				gw.wPolyline #(M3, [M3.x+40, M3.y, 0]) false ; gw.wPolyline #([M3.x, M3.y-40, 0], [M3.x, M3.y+1, 0]) false
				gw.wPolyline #(M4, [M4.x-40, M4.y, 0]) false ; gw.wPolyline #([M4.x, M4.y-40, 0], [M4.x, M4.y+1, 0]) false
			)
		6:	(
				if (selection.count == 1 and camNoteFilter selection[1]) then
				(
					local cam = selection[1], camName = cam.name, un = maxunits(), RM = [5, 23, 0], TM = [10, 40, 0]
					local rectCol2 = (color 80 80 80), labelCol = (color 220 220 220)
					case getClassName cam of (
						("VRayPhysicalCamera"): (
							infoArr = #("Type: "+(classof cam) as string, "Film Gate: "+(cam.film_width) as string+" mm", \
							"Focal Lenght: "+(cam.focal_length)as string+ " mm", "FOV: "+(cam.fov) as string+"", "Target Distance: "+(cam.target_distance) as string+" "+un,\
							"Shuter Speed: 1 / "+(cam.shutter_speed) as string+" sec.", "Aperture (f-stop): f / "+(cam.f_number) as string, "Film Speed (ISO): "+(cam.ISO) as string, \
							"Output Size: "+(RenderWidth) as string+" x "+(RenderHeight) as string+" px", "Image Aspect: "+imgAspect as string)
						)
						("Main Camera"): (
							local mcFL = "Focal Lenght: N/A", mcFGS = "Filmgate Size: N/A", mcFOV = "FOV: N/A", mcLT = "Lens: "+(cleanString ((classof cam.lens) as string))
							if classof cam.lens == Perspective_Lens then
							(
								mcFL = "Focal Lenght: "+(cam.lens.focal_length) as string+" mm"
								mcFGS = "Filmgate Size: "+(cam.lens.filmgate) as string+" mm"
								mcFOV = "FOV: "+(cam.lens.fov) as string+""
							)
							else ( if classof cam.lens != Environ_Mapper_Lens do mcFOV = "FOV: "+(cam.lens.fov) as string+"")
							infoArr = #("Type: "+(classof cam) as string, mcFL, mcFGS, mcFOV, mcLT, "Target Distance: "+(cam.target_distance) as string+" "+un, \
							"Output Size: "+(RenderWidth) as string+" x "+(RenderHeight) as string+" px", "Image Aspect: "+imgAspect as string)
						)
						("SimpleCamera"): (
							local ShSpd = "Shuter Speed: N/A", fStop = "Aperture (f-stop): N/A", fISO = "Film Speed (ISO): N/A"
							if (currR == mrR or currR == mrIRR) and classof SceneExposureControl.exposureControl == mr_Photographic_Exposure_Control then
							(
								try (
								ShSpd = "Shuter Speed: 1 / "+(SceneExposureControl.exposureControl.shutter_speed) as string+" sec."
								fStop = "Aperture (f-stop): f / "+(SceneExposureControl.exposureControl.f_stop) as string
								fISO = "Film Speed (ISO): "+(SceneExposureControl.exposureControl.film_isoUI) as string
								) catch()
							)
							else if (currR == vrR or currR == vrRTR) and classof SceneExposureControl.exposureControl == VRay_Exposure_Control then
							(
								try (
								ShSpd = "Shuter Speed: 1 / "+(SceneExposureControl.exposureControl.shutter) as string+" sec."
								fStop = "Aperture (f-stop): f / "+(SceneExposureControl.exposureControl.f_number) as string
								fISO = "Film Speed (ISO): "+(SceneExposureControl.exposureControl.ISO) as string
								) catch()
							)
							else if (currR == frR and (try(cam.baseObject.ReferenceTarget.exposure_enable == on)catch())) do
							(
								try (
								ShSpd = "Shuter Speed: 1 / "+(cam.baseObject.ReferenceTarget.shutter_speed) as string+" sec."
								fStop = "Aperture (f-stop): f / "+(cam.baseObject.ReferenceTarget.f_number) as string
								fISO = "Film Speed (ISO): "+(cam.baseObject.ReferenceTarget.film_iso) as string
								) catch()
							)
							local cd = if classof cam == Targetcamera then (cam.TargetDistance as string)
							else if classof cam == Freecamera then (cam.Target_Distance as string)
							infoArr = #("Type: "+(classof cam) as string, "Lens: "+(cameraFOV.FOVtoMM cam.fov) as string+" mm", \
							"FOV: "+(cam.fov) as string+"", "Target Distance: "+cd+" "+un, ShSpd, fStop, fISO, \
							"Output Size: "+(RenderWidth) as string+" x "+(RenderHeight) as string+" px", "Image Aspect: "+imgAspect as string)
						)
					)
					if jcCBtbg.Checked == true do
					(
						local lettcount = for lett in infoArr collect lett.count
						tallR = infoArr.count ; wideR = (amax lettcount)+1
						if wideR < camName.count do wideR = camName.count
						local bordCol = #((color 20 20 20), (color 20 20 20))
						gw.wrect ( box2 RM.x RM.y (wideR*5.4) 17 ) rectCol1
						gw.wrect ( box2 RM.x (RM.y+17) (wideR*5.4) (tallR*16.3) ) rectCol2
					)
					gw.wtext TM camName color:labelCol
					for s = 1 to infoArr.count do gw.wtext [TM.x, TM.y+(s*16), 0] infoArr[s] color:textInfoCol
				)
				else
				(
					jcBtnJOn.Text = "ON" ; jcBtnJOn.BackColor = jcBC1 ; jcBtnJOn.ForeColor = jcFC
					unregisterRedrawViewsCallback CamInfoGridView ; RedrawActiveView()
				)
			)
		7:	(
				if (selection.count == 1 and camNoteFilter selection[1]) then
				(
					local cam = selection[1], emptyNote = "Write some Notes first!"
					local camName = cam.name, camNoteArr = #(), camNoteTxt = "", tallTB = 1; wideTB = emptyNote.count
					local rectCol2 = (color 80 80 80), labelCol = (color 220 220 220)
					RM = [5, 23, 0] ; TM = [10, 40, 0] ; camNoteTxt = getUserPropBuffer selection[1]
					if camNoteTxt.count == 0 do (camNoteTxt = emptyNote)
					camNoteArr = filterString	camNoteTxt "\r\n"
					if camNoteArr.count == 0 do camNoteArr = #(emptyNote)
					if jcCBtbg.Checked == true do
					(
						local txtcount = #(), bordCol = #((color 20 20 20), (color 20 20 20))
						txtcount = for txt in camNoteArr collect txt.count
						tallTB = camNoteArr.count ; wideTB = ((amax txtcount)*1.2)
						if wideTB < camName.count do (wideTB = (camName.count)*1.2)
						gw.wrect ( box2 RM.x RM.y (wideTB*5.5) 17 ) rectCol1
						gw.wrect ( box2 RM.x (RM.y+17) (wideTB*5.5) (tallTB*16.3) ) rectCol2
					)
					gw.wtext TM camName color:labelCol
					for s = 1 to camNoteArr.count do gw.wtext [TM.x, TM.y+(s*16), 0] camNoteArr[s] color:textInfoCol
				)
				else
				(
					jcBtnJOn.Text = "ON" ; jcBtnJOn.BackColor = jcBC1 ; jcBtnJOn.ForeColor = jcFC
					unregisterRedrawViewsCallback CamInfoGridView ; RedrawActiveView()
				)
			)
		)
		gw.hrect ( box2 2 3 ((gridName.count+1)*5.5) 15 ) lineCol 
		gw.htext [1, 1, 0] gridName color:textCol
		gw.enlargeUpdateRect #whole
		gw.updateScreen()
		redrawViews()
	)
	fn jcBtnJOnClick =
	(
		if ( gw.isPerspView() == true ) and jcBtnJOn.Text == "ON" then
		(
			jcBtnJOn.Text = "OFF" ; jcBtnJOn.BackColor = jcFC ; jcBtnJOn.ForeColor = jcBC2
			unregisterRedrawViewsCallback CamInfoGridView
			registerRedrawViewsCallback CamInfoGridView ; RedrawActiveView()
		)
		else
		(
			jcBtnJOn.Text = "ON" ; jcBtnJOn.BackColor = jcBC1 ; jcBtnJOn.ForeColor = jcFC
			unregisterRedrawViewsCallback CamInfoGridView ; RedrawActiveView()
		)
	)
	fn jcSpnXGF = ( jcSpnX.BackColor = jcBC2 ; DisableAccel() ) ; fn jcSpnXLF = ( jcSpnX.BackColor = jcBC1 ; EnableAccel())
	fn jcSpnYGF = ( jcSpnY.BackColor = jcBC2 ; DisableAccel() ) ; fn jcSpnYLF = ( jcSpnY.BackColor = jcBC1 ; EnableAccel())
	fn jcBtnRWNClick =
	(
		local scriptMTE = ((getDir #Scripts) + "\\bgaTools\\3inCamPack\\bga_monoTextEdit.ms")
		if not doesFileExist scriptMTE then #abort else ( filein scriptMTE )
	)
/*///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   OPEN ROLL ACTION   //////////*/
	on jcRoll open do
	(
/*//////////   dnOBJECT's   //////////*/	
		/*//////////   "Tune" Panel   //////////*/						/*//////////   "Setup" Panel   //////////*/						/*//////////   "Jump" Panel   //////////*/
		jcLblT1 = dotNetObject "Label" ;					jcLbl1 = dotNetObject "Label" ;						jcLblJ1 = dotNetObject "Label"
		jcLblT2 = dotNetObject "Label" ;					jcBtn1 = dotNetObject "Button" ;					jcBtnRWN = dotNetObject "Button"
		jcLblT3 = dotNetObject "Label" ;					jcLbl2 = dotNetObject "Label" ;					jcComBoxJCG = dotNetObject "ComboBox"
		jcLblT4 = dotNetObject "Label" ;					jcBtnSetup = dotNetObject "Button" ;				jcBtnJOn = dotNetObject "Button"
		jcComBoxJCL = dotNetObject "ComboBox" ;			jcBtnTune = dotNetObject "Button" ;				jcLblX = dotNetObject "Label"
		jcBtnSJC = dotNetObject "Button" ;				jcBtnJump = dotNetObject "Button" ;				jcLblY = dotNetObject "Label"
		jcBtnT1K = dotNetObject "Button" ;				jcListBox = dotNetObject "ListBox" ;				jcSpnX = dotNetObject "NumericUpDown"
		jcBtnT2K = dotNetObject "Button" ;				jcLblS1 = dotNetObject "Label" ;					jcSpnY = dotNetObject "NumericUpDown"
		jcBtnT3K = dotNetObject "Button" ;				jcLblS2 = dotNetObject "Label" ;					jcBtnClrL = dotNetObject "Button"
		jcBtnT4K = dotNetObject "Button" ;				jcLblS1h = dotNetObject "Label" ;					jcBtnClrT = dotNetObject "Button"
		jcLblAInf = dotNetObject "Label" ;					jcLblSJC = dotNetObject "Label"; 					jcCBtbg = dotNetObject "CheckBox"
		jcBtnPlay = dotNetObject "Button" ;				jcTBoxS1 = dotNetObject "TextBox" ;				jcColDial = dotNetObject "ColorDialog"
		jcLblNthF = dotNetObject "Label" ;					jcBtnWC = dotNetObject "Button"
		jcSpnNthF = dotNetObject "NumericUpDown" ;		jcCB1 = dotNetObject "CheckBox"
		jcBtnT1F = dotNetObject "Button" ;				jcCB2 = dotNetObject "CheckBox"
		jcBtnT2F = dotNetObject "Button" ;				jcCB3 = dotNetObject "CheckBox"
		jcBtnT3F = dotNetObject "Button" ;				jcCB4 = dotNetObject "CheckBox"
		jcBtnT4F = dotNetObject "Button" ;				jcLblS3 = dotNetObject "Label"
		jcSpnStart = dotNetObject "NumericUpDown" ;		jcLblS4 = dotNetObject "Label"
		jcSpnSlid = dotNetObject "NumericUpDown" ;		jcBtnCCFV = dotNetObject "Button"
		jcSpnEnd = dotNetObject "NumericUpDown" ;		jcBtnSwC = dotNetObject "Button"
		jcLblT5 = dotNetObject "Label" ;					jcBtnRV = dotNetObject "Button"
		jcLblAnim = dotNetObject "Label" ;					jcBtnSvC = dotNetObject "Button"
		jcCBAnim = dotNetObject "CheckBox" ;				jcBtnSpV = dotNetObject "Button"
		jcLblT6 = dotNetObject "Label" ;					jcBtnSpC = dotNetObject "Button"
		jcBtnT1N = dotNetObject "Button" ;				jcLblAS = dotNetObject "Label"
		jcBtnT2N = dotNetObject "Button" ;				jcSpnAng = dotNetObject "NumericUpDown"
		jcBtnT3N = dotNetObject "Button" ;				jcSpnSpd = dotNetObject "NumericUpDown"
		jcBtnT4N = dotNetObject "Button" ;				jcCB5 = dotNetObject "CheckBox"
		jcBtnT5N = dotNetObject "Button" ;				jcCB6 = dotNetObject "CheckBox"
		jcBtnT6N = dotNetObject "Button" ;				jcCB7 = dotNetObject "CheckBox"
		jcBtnT7N = dotNetObject "Button" ;				jcCB8 = dotNetObject "CheckBox"
		jcBtnT8N = dotNetObject "Button" ;				jcCB9 = dotNetObject "CheckBox"
		jcBtnFSM = dotNetObject "Button" ;				jcSpnSAI1 = dotNetObject "NumericUpDown"
		jcBtnVPT = dotNetObject "Button" ;				jcSpnSAI2 = dotNetObject "NumericUpDown"
		jcLblT7 = dotNetObject "Label" ;					jcSpnACS = dotNetObject "NumericUpDown"
		jcLblTLens = dotNetObject "Label" ;				jcLblACS = dotNetObject "Label"
		jcComBoxLens = dotNetObject "ComboBox" ;     	jcSpnSCS = dotNetObject "NumericUpDown"
		jcLblT_FOV = dotNetObject "Label" ;				jcLblSCS = dotNetObject "Label"
		jcLblT_TD = dotNetObject "Label" ;				jcTBoxS2 = dotNetObject "TextBox"
		jcLblT_SS = dotNetObject "Label" ;				jcBtnRCF = dotNetObject "Button"
		jcLblT_FS = dotNetObject "Label" ;				jcBtnAF = dotNetObject "Button"
		jcLblT_ISO = dotNetObject "Label" ;				jcBtnCJC = dotNetObject "Button"
		jcLblSlid_FOV = dotNetObject "Label"
		jcLblSlid_TD = dotNetObject "Label"
		jcLblSlid_SS = dotNetObject "Label"
		jcLblSlid_FS = dotNetObject "Label"
		jcLblSlid_ISO = dotNetObject "Label"
		jcSpn_FOV = dotNetObject "NumericUpDown"
		jcSpn_TD = dotNetObject "NumericUpDown"
		jcSpn_SS = dotNetObject "NumericUpDown"
		jcSpn_FS = dotNetObject "NumericUpDown"
		jcSpn_ISO = dotNetObject "NumericUpDown"
/*//////////   dnToolTip's Options   //////////*/
		jcToolTip = dotNetObject "ToolTip" ; jcTTb1 = dotNetObject "ToolTip"
		jcTTb1.SetToolTip jcBtn1 "\t\t\t\t\n\r\n\t\r\n" ; jcToolTip.OwnerDraw = jcTTb1.OwnerDraw = true
		jcTTb1.InitialDelay = jcToolTip.InitialDelay = jcToolTip.ReshowDelay = 2000 ; jcTTb1.AutoPopDelay = 15000
/*//////////   dnToolTip's   on "Setup" Panel   //////////*/
		jcToolTip.SetToolTip jcBtnCCFV "Create Camera From View+\t"
		jcToolTip.SetToolTip jcBtnSwC "Switch Between Cameras\t"
		jcToolTip.SetToolTip jcBtnRV "Reset View (HOME)\t"
		jcToolTip.SetToolTip jcBtnSvC "Select The Active View Camera\t"
		jcToolTip.SetToolTip jcBtnSpV "Spin View About World\t"
		jcToolTip.SetToolTip jcBtnSpC "Spin Camera About Target\t"
		jcToolTip.SetToolTip jcBtnRCF "Recalculate JC Frames\t"
		jcToolTip.SetToolTip jcBtnAF "Set Pickup Frames\t"
/*//////////   dnToolTip's   on "Tune" Panel   //////////*/
		jcToolTip.SetToolTip jcBtnSJC "Select JC From List\r\n[+Ctrl KeyDown] Look Through JC\t"
		jcToolTip.SetToolTip jcBtnT1K "First Key\t"
		jcToolTip.SetToolTip jcBtnT2K "Previous Key\t"
		jcToolTip.SetToolTip jcBtnT3K "Next Key\t"
		jcToolTip.SetToolTip jcBtnT4K "Last Key\t"
		jcToolTip.SetToolTip jcBtnPlay "Play Animation\r\n[+Ctrl KeyDown] Play Selected \t"
		jcToolTip.SetToolTip jcBtnT1F "First Frame\t"
		jcToolTip.SetToolTip jcBtnT2F "Previous Frame\t"
		jcToolTip.SetToolTip jcBtnT3F "Next Frame\t"
		jcToolTip.SetToolTip jcBtnT4F "Last Frame\t"
		jcToolTip.SetToolTip jcCBAnim "Toggle Auto Key Mode\t"
/*//////////   dnToolTip's   on "Jump" Panel   //////////*/
		jcToolTip.SetToolTip jcBtnJOn "Turn On/Off Info-Grid\t"
		jcToolTip.SetToolTip jcBtnClrL "Line/Grid Color\t"
		jcToolTip.SetToolTip jcBtnClrT "Text/Info Color\t"
/*//////////   dnOBJECT's Options on "Setup" Panel   //////////*/
/*//////////   jcPnl1 & jcPnl2   //////////*/
		jcPnl1.BackColor = jcPnl2.BackColor = jcBC2 ; jcPnl1.Width = 164 ; jcPnl1.Height = 62 ; jcPnl2.Width = 492 ; jcPnl2.Height = 457
/*//////////   jcLbl1 & jcLbl2   //////////*/
		jcLbl1.BackColor = jcLbl2.BackColor = jcBC1 ; jcLbl1.ForeColor = jcLbl2.ForeColor = jcBC2 ; jcLbl1.Font = jcLbl2.Font = jcFont3
		jcLbl1.Width = jcLbl2.Width = 160 ; jcLbl1.Height = jcLbl2.Height = 10 ; jcLbl1.Text = jcLbl2.Text = "|||||||||||||||||||||||||||||||||||"
		jcLbl1.Location = dotNetObject "System.Drawing.Point" (jcPnl1.pos.x + 2) (jcPnl1.pos.y + 2) ; jcLbl1.Padding = jcLbl2.Padding = jcPadd1
		jcLbl2.Location = dotNetObject "System.Drawing.Point" (jcPnl1.pos.x + 2) (jcPnl1.pos.y + 32) ; jcLbl1.TextAlign = jcLbl2.TextAlign = jcAlign2
/*//////////   jcBtn1   //////////*/
		jcBtn1.Font = jcFont2 ; jcBtn1.Text = "JUMPER*CAM" ; jcBtn1.BackColor = jcFC ; jcBtn1.ForeColor = jcBC2 ; jcBtn1.TextAlign = jcAlign1
		jcBtn1.Location = dotNetObject "System.Drawing.Point" (jcPnl1.pos.x + 1) (jcPnl1.pos.y + 12) ; jcBtn1.FlatStyle = jcFS2
		jcBtn1.Width = 162 ; jcBtn1.Height = 20 ; jcBtn1.Padding = jcPadd2 ; jcBtn1.Cursor = jcCurs
/*//////////   jcBtnSetup   //////////*/
		jcBtnSetup.Font = jcFont1 ; jcBtnSetup.Text = "Setup" ; jcBtnSetup.BackColor = jcBC1 ; jcBtnSetup.ForeColor = jcFC
		jcBtnSetup.Location = dotNetObject "System.Drawing.Point" (jcPnl1.pos.x + 1) (jcPnl1.pos.y + 43) ; jcBtnSetup.FlatStyle = jcFS1
		jcBtnSetup.Width = 54 ; jcBtnSetup.Height = 18 ; jcBtnSetup.Padding = jcPadd2 ; jcBtnSetup.Cursor = jcCurs ; jcBtnSetup.TextAlign = jcAlign2
/*//////////   jcBtnTune  //////////*/
		jcBtnTune.Font = jcFont1 ; jcBtnTune.Text = "Tune" ; jcBtnTune.BackColor = jcBC1 ; jcBtnTune.ForeColor = jcFC
		jcBtnTune.Location = dotNetObject "System.Drawing.Point" (jcPnl1.pos.x + 55) (jcPnl1.pos.y + 43) ; jcBtnTune.FlatStyle = jcFS1
		jcBtnTune.Width = 54 ; jcBtnTune.Height = 18 ; jcBtnTune.Padding = jcPadd2 ; jcBtnTune.Cursor = jcCurs ; jcBtnTune.TextAlign = jcAlign2
/*//////////   jcBtnTune   //////////*/
		jcBtnJump.Font = jcFont1 ; jcBtnJump.Text = "Jump" ; jcBtnJump.BackColor = jcBC1 ; jcBtnJump.ForeColor = jcFC
		jcBtnJump.Location = dotNetObject "System.Drawing.Point" (jcPnl1.pos.x + 109) (jcPnl1.pos.y + 43) ; jcBtnJump.FlatStyle = jcFS1
		jcBtnJump.Width = 54 ; jcBtnJump.Height = 18 ; jcBtnJump.Padding = jcPadd2 ; jcBtnJump.Cursor = jcCurs ; jcBtnJump.TextAlign = jcAlign2
/*//////////   jcListBox   //////////*/
		jcListBox.Font = jcFont1 ; jcListBox.BackColor = jcBC1 ; jcListBox.ForeColor = jcFC
		jcListBox.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 2) (jcPnl2.pos.y - 48) ; jcListBox.BorderStyle = jcBS1
		jcListBox.Width = 160 ; jcListBox.Height = 130 ; jcListBox.SelectionMode = jcSM
/*//////////   jcLblS1 & jcLblS2  //////////*/
		jcLblS1.BackColor = jcLblS2.BackColor = jcFC ; jcLblS1.ForeColor = jcLblS2.ForeColor = jcBC2 ; jcLblS1.Font = jcLblS2.Font = jcFont1 ; jcLblS1.Width = 148
		jcLblS2.Width = 160 ; jcLblS1.Height = jcLblS2.Height = 12 ; jcLblS1.Text = "Collect Scene Cameras" ; jcLblS2.Text = "Name  Wirecolor  Type"
		jcLblS1.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 2) (jcPnl2.pos.y - 61) ; jcLblS1.Padding = jcLblS2.Padding = jcPadd2
		jcLblS2.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 2) (jcPnl2.pos.y + 73) ; jcLblS1.TextAlign = jcLblS2.TextAlign = jcAlign2
/*//////////   jcLblS1h  //////////*/
		jcLblS1h.BackColor = jcFC ; jcLblS1h.ForeColor = jcBC2 ; jcLblS1h.Font = jcFont1 ; jcLblS1h.Width = jcLblS1h.Height = 12
		jcLblS1h.Text = "?" ; jcLblS1h.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 150) (jcPnl2.pos.y - 61)
		jcLblS1h.Padding = jcPadd2 ; jcLblS1h.TextAlign = jcAlign2 ; jcLblS1h.Cursor = jcCurs1
/*//////////   jcLblSJC  //////////*/	
		jcLblSJC.BackColor = jcBC1 ; jcLblSJC.ForeColor = jcFC ; jcLblSJC.Font = jcFont1 ; jcLblSJC.Width = 25 ; jcLblSJC.Height = 12 ; jcLblSJC.Text = "JC_"
		jcLblSJC.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 2) (jcPnl2.pos.y + 86) ; jcLblSJC.TextAlign = jcAlign2 ; jcLblSJC.Padding = jcPadd2
/*//////////   jcTBoxS1   //////////*/
		jcTBoxS1.BackColor = jcBC1 ; jcTBoxS1.ForeColor = jcFC ; jcTBoxS1.Font = jcFont1 ; jcTBoxS1.Width = 122 ; jcTBoxS1.Height = 12
		jcTBoxS1.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 27) (jcPnl2.pos.y + 86) ; jcTBoxS1.AutoSize = true
		jcTBoxS1.Multiline = false ; jcTBoxS1.Padding = jcPadd2 ; jcTBoxS1.BorderStyle = jcBS1 ; jcTBoxS1.Text = "JamperCam"
/*//////////   jcBtnWC   //////////*/
		jcBtnWC.BackColor = jcCWC ; jcBtnWC.Width = jcBtnWC.Height = 13 ; jcBtnWC.FlatStyle = jcFS1
		jcBtnWC.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 150) (jcPnl2.pos.y + 86)
/*//////////   jcCB1, jcCB2, jcCB3, jcCB4   //////////*/
		jcCB1.Font = jcCB2.Font = jcCB3.Font = jcCB4.Font = jcFont1 ; jcCB1.BackColor = jcCB2.BackColor = jcCB3.BackColor = jcCB4.BackColor = jcBC1
		jcCB1.ForeColor = jcCB2.ForeColor = jcCB3.ForeColor = jcCB4.ForeColor = jcFC ; jcCB1.Checked = true ; jcCB2.Enabled =  jcCB3.Enabled =  jcCB4.Enabled = false
		jcCB1.Text = " StandardCamera" ; jcCB2.Text = " VRayPhysicalCamera" ; jcCB3.Text = " FinalRenderPhysCamera" ; jcCB4.Text = " Brazil2MainCamera"
		jcCB1.FlatStyle = jcFS3 ; jcCB2.FlatStyle = jcCB3.FlatStyle = jcCB4.FlatStyle = jcFS2 ; jcCB1.TextAlign = jcCB2.TextAlign = jcCB3.TextAlign = jcCB4.TextAlign = jcAlign3
		jcCB1.Width = jcCB2.Width = jcCB3.Width = jcCB4.Width = 160 ; jcCB1.Height = jcCB2.Height = jcCB3.Height = jcCB4.Height = 12
		jcCB1.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 2) (jcPnl2.pos.y + 99)
		jcCB2.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 2) (jcPnl2.pos.y + 112)
		jcCB3.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 2) (jcPnl2.pos.y + 125)
		jcCB4.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 2) (jcPnl2.pos.y + 138)
/*//////////   jcLblS3 & jcLblS4  //////////*/
		jcLblS3.BackColor = jcLblS4.BackColor = jcFC ; jcLblS3.ForeColor = jcLblS4.ForeColor = jcBC2 ; jcLblS3.Font = jcLblS4.Font = jcFont1
		jcLblS3.Width = jcLblS4.Width = 160 ; jcLblS3.Height = jcLblS4.Height = 12 ; jcLblS3.Text = "Add More Cameras" ; jcLblS4.Text = "Creation Options"
		jcLblS3.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 2) (jcPnl2.pos.y + 151) ; jcLblS3.Padding = jcLblS4.Padding = jcPadd2
		jcLblS4.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 2) (jcPnl2.pos.y + 248) ; jcLblS3.TextAlign = jcLblS4.TextAlign = jcAlign2
/*//////////   jcBtnCCFV  //////////*/
		jcBtnCCFV.Font = jcFont1 ; jcBtnCCFV.Text = "CCFV +" ; jcBtnCCFV.BackColor = jcBC1 ; jcBtnCCFV.ForeColor = jcFC
		jcBtnCCFV.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 1) (jcPnl2.pos.y + 164) ; jcBtnCCFV.FlatStyle = jcFS1
		jcBtnCCFV.Width = 81 ; jcBtnCCFV.Height = 18 ; jcBtnCCFV.Padding = jcPadd2 ; jcBtnCCFV.Cursor = jcCurs ; jcBtnCCFV.TextAlign = jcAlign2
/*//////////   jcBtnSwC  //////////*/
		jcBtnSwC.Font = jcFont1 ; jcBtnSwC.Text = "Switch Cam" ; jcBtnSwC.BackColor = jcBC1 ; jcBtnSwC.ForeColor = jcFC
		jcBtnSwC.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 82) (jcPnl2.pos.y + 164) ; jcBtnSwC.FlatStyle = jcFS1
		jcBtnSwC.Width = 81 ; jcBtnSwC.Height = 18 ; jcBtnSwC.Padding = jcPadd2 ; jcBtnSwC.Cursor = jcCurs ; jcBtnSwC.TextAlign = jcAlign2
/*//////////   jcBtnRV  //////////*/
		jcBtnRV.Font = jcFont1 ; jcBtnRV.Text = "Reset View" ; jcBtnRV.BackColor = jcBC1 ; jcBtnRV.ForeColor = jcFC
		jcBtnRV.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 1) (jcPnl2.pos.y + 182) ; jcBtnRV.FlatStyle = jcFS1
		jcBtnRV.Width = 81 ; jcBtnRV.Height = 18 ; jcBtnRV.Padding = jcPadd2 ; jcBtnRV.Cursor = jcCurs ; jcBtnRV.TextAlign = jcAlign2
/*//////////   jcBtnSvC  //////////*/
		jcBtnSvC.Font = jcFont1 ; jcBtnSvC.Text = "STAVC" ; jcBtnSvC.BackColor = jcBC1 ; jcBtnSvC.ForeColor = jcFC
		jcBtnSvC.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 82) (jcPnl2.pos.y + 182) ; jcBtnSvC.FlatStyle = jcFS1
		jcBtnSvC.Width = 81 ; jcBtnSvC.Height = 18 ; jcBtnSvC.Padding = jcPadd2 ; jcBtnSvC.Cursor = jcCurs ; jcBtnSvC.TextAlign = jcAlign2
/*//////////   jcBtnSpV  //////////*/
		jcBtnSpV.Font = jcFont1 ; jcBtnSpV.Text = "Spin View" ; jcBtnSpV.BackColor = jcBC1 ; jcBtnSpV.ForeColor = jcFC
		jcBtnSpV.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 1) (jcPnl2.pos.y + 200) ; jcBtnSpV.FlatStyle = jcFS1
		jcBtnSpV.Width = 81 ; jcBtnSpV.Height = 18 ; jcBtnSpV.Padding = jcPadd2 ; jcBtnSpV.Cursor = jcCurs ; jcBtnSpV.TextAlign = jcAlign2
/*//////////   jcBtnSpC  //////////*/
		jcBtnSpC.Font = jcFont1 ; jcBtnSpC.Text = "Spin Cam" ; jcBtnSpC.BackColor = jcBC1 ; jcBtnSpC.ForeColor = jcFC
		jcBtnSpC.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 82) (jcPnl2.pos.y + 200) ; jcBtnSpC.FlatStyle = jcFS1
		jcBtnSpC.Width = 81 ; jcBtnSpC.Height = 18 ; jcBtnSpC.Padding = jcPadd2 ; jcBtnSpC.Cursor = jcCurs ; jcBtnSpC.TextAlign = jcAlign2
/*//////////   jcLblAS  //////////*/
		jcLblAS.BackColor = jcBC1 ; jcLblAS.ForeColor = jcFC ; jcLblAS.Font = jcFont1 ; jcLblAS.Width = 79 ; jcLblAS.Height = 15 ; jcLblAS.Text = "Angle/Speed:"
		jcLblAS.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 2) (jcPnl2.pos.y + 219) ; jcLblAS.TextAlign = jcAlign3 ; jcLblAS.Padding = jcPadd2
/*//////////   jcSpnAng  //////////*/
		jcSpnAng.Font = jcFont1 ; jcSpnAng.BackColor = jcBC1 ; jcSpnAng.ForeColor = jcFC ; jcSpnAng.Width = 54 ; jcSpnAng.Height = 15
		jcSpnAng.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 82) (jcPnl2.pos.y + 219) ; jcSpnAng.BorderStyle = jcBS1 ; 
		jcSpnAng.Increment = 1 ; jcSpnAng.DecimalPlaces = 2 ; jcSpnAng.Value = 90 ; jcSpnAng.Minimum = -360 ; jcSpnAng.Maximum = 360 ; jcSpnAng.TextAlign = jcHorizA
/*//////////   jcSpnSpd   //////////*/
		jcSpnSpd.Font = jcFont1 ; jcSpnSpd.BackColor = jcBC1 ; jcSpnSpd.ForeColor = jcFC ; jcSpnSpd.Width = 25 ; jcSpnSpd.Height = 15
		jcSpnSpd.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 137) (jcPnl2.pos.y + 219) ; jcSpnSpd.BorderStyle = jcBS1 ; 
		jcSpnSpd.Increment = 1 ; jcSpnSpd.DecimalPlaces = 0 ; jcSpnSpd.Value = 2 ; jcSpnSpd.Minimum = 1 ; jcSpnSpd.Maximum = 3 ; jcSpnSpd.TextAlign = jcHorizA
/*//////////   jcCB5, jcCB6, jcCB7, jcCB8, jcCB9   //////////*/
		jcCB5.Font = jcCB6.Font = jcCB7.Font = jcCB8.Font = jcCB9.Font = jcFont1
		jcCB5.BackColor = jcCB6.BackColor = jcCB7.BackColor = jcCB8.BackColor = jcCB9.BackColor = jcBC1
		jcCB5.ForeColor = jcCB6.ForeColor = jcCB7.ForeColor = jcCB8.ForeColor = jcCB9.ForeColor = jcFC ; jcCB8.Checked = true
		jcCB5.FlatStyle = jcCB6.FlatStyle = jcCB7.FlatStyle = jcCB8.FlatStyle = jcCB9.FlatStyle = jcFS3
		jcCB5.TextAlign = jcCB6.TextAlign = jcCB7.TextAlign = jcCB8.TextAlign = jcCB9.TextAlign = jcAlign3
		jcCB5.Text = " Add Camera To ListBox" ; jcCB6.Text = " Look Through JC" ; jcCB7.Text = " Show/Hide JC Label"
		jcCB8.Text = " Get Cam's Animation" ; jcCB9.Text = " Find Interval In Range:"
		jcCB5.Width = jcCB6.Width = jcCB7.Width = jcCB8.Width = jcCB9.Width = 160
		jcCB5.Height = jcCB6.Height = jcCB7.Height = jcCB8.Height = jcCB9.Height = 12
		jcCB5.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 2) (jcPnl2.pos.y + 235)
		jcCB6.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 2) (jcPnl2.pos.y + 261)
		jcCB7.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 2) (jcPnl2.pos.y + 274)
		jcCB8.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 2) (jcPnl2.pos.y + 287)
		jcCB9.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 2) (jcPnl2.pos.y + 300)
/*//////////   jcSpnSAI1, jcSpnSAI2   //////////*/
		jcSpnSAI1.Font = jcSpnSAI2.Font = jcFont1 ; jcSpnSAI1.BackColor = jcSpnSAI2.BackColor = jcBC1 ; jcSpnSAI1.ForeColor = jcSpnSAI2.ForeColor = jcFC
		jcSpnSAI1.Width = jcSpnSAI2.Width = 80 ; jcSpnSAI1.Height = jcSpnSAI2.Height = 15 ; jcSpnSAI1.TextAlign = jcSpnSAI2.TextAlign = jcHorizA
		jcSpnSAI1.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 2) (jcPnl2.pos.y + 313) ; jcSpnSAI1.BorderStyle = jcBS1
		jcSpnSAI2.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 82) (jcPnl2.pos.y + 313) ; jcSpnSAI2.BorderStyle = jcBS1
		jcSpnSAI1.Increment = jcSpnSAI2.Increment = 1 ; jcSpnSAI1.DecimalPlaces = jcSpnSAI2.DecimalPlaces = 0 ; jcSpnSAI1.Minimum = jcSpnSAI2.Minimum = -1e5
		jcSpnSAI1.Maximum = jcSpnSAI2.Maximum = 1e5 ; jcSpnSAI1.Value = -1e3 ; jcSpnSAI2.Value = 1e3 ; jcSpnSAI1.Enabled = jcSpnSAI2.Enabled = false
/*//////////   jcLblACS  //////////*/
		jcLblACS.BackColor = jcBC1 ; jcLblACS.ForeColor = jcFC ; jcLblACS.Font = jcFont1 ; jcLblACS.Width = 109 ; jcLblACS.Height = 15 ; jcLblACS.Text = " Anim. Cam's Step:"
		jcLblACS.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 2) (jcPnl2.pos.y + 329) ; jcLblACS.TextAlign = jcAlign3 ; jcLblACS.Padding = jcPadd2
/*//////////   jcSpnACS   //////////*/
		jcSpnACS.Font = jcFont1 ; jcSpnACS.BackColor = jcBC1 ; jcSpnACS.ForeColor = jcFC ; jcSpnACS.Width = 50 ; jcSpnACS.Height = 15
		jcSpnACS.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 112) (jcPnl2.pos.y + 329) ; jcSpnACS.BorderStyle = jcBS1 ; 
		jcSpnACS.Increment = 1 ; jcSpnACS.DecimalPlaces = 0 ; jcSpnACS.Minimum = 1 ; jcSpnACS.Maximum = 100000 ; jcSpnACS.Value = 1 ; jcSpnACS.TextAlign = jcHorizA
/*//////////   jcLblSCS  //////////*/
		jcLblSCS.BackColor = jcBC1 ; jcLblSCS.ForeColor = jcFC ; jcLblSCS.Font = jcFont1 ; jcLblSCS.Width = 109 ; jcLblSCS.Height = 15 ; jcLblSCS.Text = " Still Cam's Step:"
		jcLblSCS.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 2) (jcPnl2.pos.y + 345) ; jcLblSCS.TextAlign = jcAlign3 ; jcLblSCS.Padding = jcPadd2
/*//////////   jcSpnSCS   //////////*/
		jcSpnSCS.Font = jcFont1 ; jcSpnSCS.BackColor = jcBC1 ; jcSpnSCS.ForeColor = jcFC ; jcSpnSCS.Width = 50 ; jcSpnSCS.Height = 15
		jcSpnSCS.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 112) (jcPnl2.pos.y + 345) ; jcSpnSCS.BorderStyle = jcBS1
		jcSpnSCS.Increment = 1 ; jcSpnSCS.DecimalPlaces = 0 ; jcSpnSCS.Value = jcSpnSCS.Minimum = 1 ; jcSpnSCS.Maximum = 100 ; jcSpnSCS.TextAlign = jcHorizA
/*//////////   jcTBoxS2   //////////*/
		jcTBoxS2.BackColor = jcBC1 ; jcTBoxS2.ForeColor = jcBC2 ; jcTBoxS2.Font = jcFont1 ; jcTBoxS2.Width = 134 ; jcTBoxS2.Height = 12
		jcTBoxS2.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 2) (jcPnl2.pos.y + 361) ; jcTBoxS2.AutoSize = false
		jcTBoxS2.Multiline = false ; jcTBoxS2.Padding = jcPadd2 ; jcTBoxS2.BorderStyle = jcBS1 ; jcTBoxS2.ReadOnly = true ; jcTBoxS2.Text = " JamperCam Frames"
/*//////////   jcBtnRCF, jcBtnAF   //////////*/
		jcBtnRCF.BackColor = jcBtnAF.BackColor = jcBC1 ; jcBtnRCF.ForeColor = jcBtnAF.ForeColor = jcFC
		jcBtnRCF.Width = jcBtnRCF.Height = jcBtnAF.Width = jcBtnAF.Height = 13 ; jcBtnRCF.Font = jcBtnAF.Font = jcFont1
		jcBtnRCF.FlatStyle = jcBtnAF.FlatStyle = jcFS1 ; jcBtnRCF.Text = "^" ; jcBtnAF.Text = "|" ; jcBtnRCF.Cursor = jcBtnAF.Cursor = jcCurs
		jcBtnRCF.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 137) (jcPnl2.pos.y + 361)
		jcBtnAF.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 150) (jcPnl2.pos.y + 361)
/*//////////   jcBtnCJC  //////////*/
		jcBtnCJC.Font = jcFont1 ; jcBtnCJC.Text = "CREATE  JUMPERCAM" ; jcBtnCJC.BackColor = jcFC ; jcBtnCJC.ForeColor = jcBC2
		jcBtnCJC.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 1) (jcPnl2.pos.y + 374) ; jcBtnCJC.FlatStyle = jcFS1
		jcBtnCJC.Width = 162 ; jcBtnCJC.Height = 18 ; jcBtnCJC.Padding = jcPadd2 ; jcBtnCJC.Cursor = jcCurs ; jcBtnCJC.TextAlign = jcAlign1
/*//////////   dnOBJECT's Options on "Tune" Panel   //////////*/
/*//////////   jcLblT1, jcLblT2, jcLblT3, jcLblT4  //////////*/
		jcLblT1.BackColor = jcLblT2.BackColor = jcLblT3.BackColor = jcLblT4.BackColor = jcLblT5.BackColor = jcLblT6.BackColor = jcLblT7.BackColor = jcFC
		jcLblT1.ForeColor = jcLblT2.ForeColor = jcLblT3.ForeColor = jcLblT4.ForeColor = jcLblT5.ForeColor = jcLblT6.ForeColor = jcLblT7.ForeColor = jcBC2
		jcLblT1.Font = jcLblT2.Font = jcLblT3.Font = jcLblT4.Font = jcLblT5.Font = jcLblT6.Font = jcLblT7.Font = jcFont1
		jcLblT1.Padding = jcLblT2.Padding = jcLblT3.Padding = jcLblT4.Padding = jcLblT5.Padding = jcLblT6.Padding = jcLblT7.Padding = jcPadd2
		jcLblT1.Width = jcLblT2.Width = jcLblT3.Width = jcLblT4.Width = jcLblT5.Width = jcLblT6.Width = jcLblT7.Width = 160
		jcLblT1.Height = jcLblT2.Height = jcLblT3.Height = jcLblT4.Height = jcLblT5.Height = jcLblT6.Height = jcLblT7.Height = 12
		jcLblT1.TextAlign = jcLblT2.TextAlign = jcLblT3.TextAlign = jcLblT4.TextAlign = jcLblT5.TextAlign = jcLblT6.TextAlign = jcLblT7.TextAlign = jcAlign2
		jcLblT1.Text = "JamperCam List" ; jcLblT2.Text = "Jump On Every Key" ; jcLblT3.Text = "Jump On Every Nth Frame" ; jcLblT4.Text = "Start  Slider  End"
		jcLblT5.Text = "JamperCam Animate" ; jcLblT6.Text = "JamperCam Navigation" ; jcLblT7.Text = "JamperCam Parameters"
		jcLblT1.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y - 61)
		jcLblT2.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y - 27)
		jcLblT3.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y + 31)
		jcLblT4.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y + 79)
		jcLblT5.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y + 108)
		jcLblT6.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y + 147)
		jcLblT7.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y + 215)
/*//////////   jcComBoxJCL  //////////*/
		jcComBoxJCL.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y - 48) ; jcComBoxJCL.Width = 139 ; jcComBoxJCL.Height = 21
		jcComBoxJCL.Backcolor = jcBC1 ; jcComBoxJCL.Forecolor = jcFC ; jcComBoxJCL.FlatStyle = jcFS2 ; jcComBoxJCL.DropDownStyle = jcCBS ; jcComBoxJCL.Font = jcFont1
/*//////////   jcBtnSJC  //////////*/
		jcBtnSJC.Font = jcFont6 ; jcBtnSJC.Text = "" ; jcBtnSJC.BackColor = jcBC1 ; jcBtnSJC.ForeColor = jcFC
		jcBtnSJC.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 306) (jcPnl2.pos.y - 48) ; jcBtnSJC.FlatStyle = jcFS1
		jcBtnSJC.Width = jcBtnSJC.Height = 21 ; jcBtnSJC.Padding = jcPadd2 ; jcBtnSJC.Cursor = jcCurs ; jcBtnSJC.TextAlign = jcAlign1
/*//////////   jcBtnT1K, jcBtnT2K, jcBtnT3K, jcBtnT4K   //////////*/
		jcBtnT1K.Font = jcBtnT2K.Font = jcBtnT3K.Font = jcBtnT4K.Font = jcFont4
		jcBtnT1K.BackColor = jcBtnT2K.BackColor = jcBtnT3K.BackColor = jcBtnT4K.BackColor = jcBC1
		jcBtnT1K.ForeColor = jcBtnT2K.ForeColor = jcBtnT3K.ForeColor = jcBtnT4K.ForeColor = jcWBC
		jcBtnT1K.FlatStyle = jcBtnT2K.FlatStyle = jcBtnT3K.FlatStyle = jcBtnT4K.FlatStyle = jcFS1
		jcBtnT1K.TextAlign = jcBtnT2K.TextAlign = jcBtnT3K.TextAlign = jcBtnT4K.TextAlign = jcAlign1
		jcBtnT1K.Padding = jcBtnT2K.Padding = jcBtnT3K.Padding = jcBtnT4K.Padding = jcPadd2
		jcBtnT1K.Cursor = jcBtnT2K.Cursor = jcBtnT3K.Cursor = jcBtnT4K.Cursor = jcCurs
		jcBtnT1K.Width = jcBtnT4K.Width = 41 ; jcBtnT2K.Width = jcBtnT3K.Width = 40 ; jcBtnT1K.Height = jcBtnT2K.Height = jcBtnT3K.Height = jcBtnT4K.Height = 18
		jcBtnT1K.Text = "7" ; jcBtnT2K.Text = "3" ; jcBtnT3K.Text = "4" ; jcBtnT4K.Text = "8"
		jcBtnT1K.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 165) (jcPnl2.pos.y - 14)
		jcBtnT2K.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 206) (jcPnl2.pos.y - 14)
		jcBtnT3K.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 246) (jcPnl2.pos.y - 14)
		jcBtnT4K.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 286) (jcPnl2.pos.y - 14)
/*//////////   jcLblAInf  //////////*/	
		jcLblAInf.BackColor = jcBC1 ; jcLblAInf.ForeColor = jcFC ; jcLblAInf.Font = jcFont1 ; jcLblAInf.Width = 134 ; jcLblAInf.Height = 25
		jcLblAInf.Text = AnimInfo ; jcLblAInf.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y + 5)
		jcLblAInf.TextAlign = jcAlign3 ; jcLblAInf.Padding = jcPadd2
/*//////////   jcBtnPlay  //////////*/
		jcBtnPlay.Font = jcFont5 ; jcBtnPlay.Text = "" ; jcBtnPlay.BackColor = jcBC1 ; jcBtnPlay.ForeColor = jcFC
		jcBtnPlay.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 301) (jcPnl2.pos.y + 5) ; jcBtnPlay.FlatStyle = jcFS1
		jcBtnPlay.Width = jcBtnPlay.Height = 26 ; jcBtnPlay.Padding = jcPadd2 ; jcBtnPlay.Cursor = jcCurs ; jcBtnPlay.TextAlign = jcBtnPlay.TextAlign.TopCenter
/*//////////   jcLblNthF  //////////*/
		jcLblNthF.BackColor = jcBC1 ; jcLblNthF.ForeColor = jcFC ; jcLblNthF.Font = jcFont1 ; jcLblNthF.Width = 109 ; jcLblNthF.Height = 15
		jcLblNthF.Text = " Nth Frame Step:" ; jcLblNthF.TextAlign = jcAlign3 ; jcLblNthF.Padding = jcPadd2
		jcLblNthF.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y + 44)
/*//////////   jcSpnNthF   //////////*/
		jcSpnNthF.Font = jcFont1 ; jcSpnNthF.BackColor = jcBC1 ; jcSpnNthF.ForeColor = jcFC ; jcSpnNthF.Width = 50 ; jcSpnNthF.Height = 15
		jcSpnNthF.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 276) (jcPnl2.pos.y + 44) ; jcSpnNthF.BorderStyle = jcBS1
		jcSpnNthF.Increment = 1 ; jcSpnNthF.DecimalPlaces = 0 ; jcSpnNthF.Value = jcSpnNthF.Minimum = 1 ; jcSpnNthF.Maximum = 100 ; jcSpnNthF.TextAlign = jcHorizA
/*//////////   jcBtnT1F, jcBtnT2F, jcBtnT3F, jcBtnT4F   //////////*/
		jcBtnT1F.Font = jcBtnT2F.Font = jcBtnT3F.Font = jcBtnT4F.Font = jcFont4
		jcBtnT1F.BackColor = jcBtnT2F.BackColor = jcBtnT3F.BackColor = jcBtnT4F.BackColor = jcBC1
		jcBtnT1F.ForeColor = jcBtnT2F.ForeColor = jcBtnT3F.ForeColor = jcBtnT4F.ForeColor = jcWGC
		jcBtnT1F.FlatStyle = jcBtnT2F.FlatStyle = jcBtnT3F.FlatStyle = jcBtnT4F.FlatStyle = jcFS1
		jcBtnT1F.TextAlign = jcBtnT2F.TextAlign = jcBtnT3F.TextAlign = jcBtnT4F.TextAlign = jcAlign2
		jcBtnT1F.Padding = jcBtnT2F.Padding = jcBtnT3F.Padding = jcBtnT4F.Padding = jcPadd2
		jcBtnT1F.Cursor = jcBtnT2F.Cursor = jcBtnT3F.Cursor = jcBtnT4F.Cursor = jcCurs
		jcBtnT1F.Width = jcBtnT4F.Width = 41 ; jcBtnT2F.Width = jcBtnT3F.Width = 40 ; jcBtnT1F.Height = jcBtnT2F.Height = jcBtnT3F.Height = jcBtnT4F.Height = 18
		jcBtnT1F.Text = "9" ; jcBtnT2F.Text = "3" ; jcBtnT3F.Text = "4" ; jcBtnT4F.Text = ":"
		jcBtnT1F.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 165) (jcPnl2.pos.y + 60)
		jcBtnT2F.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 206) (jcPnl2.pos.y + 60)
		jcBtnT3F.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 246) (jcPnl2.pos.y + 60)
		jcBtnT4F.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 286) (jcPnl2.pos.y + 60)
/*//////////   jcSpnStart, jcSpnSlid, jcSpnEnd   //////////*/
		jcSpnStart.Font = jcSpnSlid.Font = jcSpnEnd.Font = jcFont1 ; jcSpnStart.TextAlign = jcSpnSlid.TextAlign = jcSpnEnd.TextAlign = jcHorizA
		jcSpnStart.BackColor = jcSpnSlid.BackColor = jcSpnEnd.BackColor = jcBC1 ; jcSpnStart.ForeColor = jcSpnSlid.ForeColor = jcSpnEnd.ForeColor = jcFC
		jcSpnStart.Width = jcSpnEnd.Width = 53 ; jcSpnSlid.Width = 52; jcSpnStart.Height = jcSpnSlid.Height = jcSpnEnd.Height = 15
		jcSpnStart.Increment = jcSpnSlid.Increment = jcSpnEnd.Increment = 1 ; jcSpnStart.DecimalPlaces = jcSpnSlid.DecimalPlaces = jcSpnEnd.DecimalPlaces = 0
		jcSpnStart.Minimum = jcSpnSlid.Minimum = jcSpnEnd.Minimum = -999999 ; jcSpnStart.Maximum = jcSpnSlid.Maximum = jcSpnEnd.Maximum = 999999
		jcSpnStart.Value = animationrange.start ; jcSpnSlid.Value = sliderTime ; jcSpnEnd.Value = animationrange.end
		jcSpnStart.BorderStyle = jcSpnSlid.BorderStyle = jcSpnEnd.BorderStyle = jcBS1
		jcSpnStart.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y + 92)
		jcSpnSlid.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 220) (jcPnl2.pos.y + 92)
		jcSpnEnd.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 273) (jcPnl2.pos.y + 92)
/*//////////   jcLblAnim  //////////*/
		jcLblAnim.BackColor = jcBC1 ; jcLblAnim.ForeColor = jcFC ; jcLblAnim.Font = jcFont1 ; jcLblAnim.Width = 98 ; jcLblAnim.Height = 25
		jcLblAnim.Text = " ANIMATE : OFF" ; jcLblAnim.TextAlign = jcAlign3 ; jcLblAnim.Padding = jcPadd2
		jcLblAnim.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y + 121)
/*//////////   jcCBAnim  //////////*/
		jcCBAnim.Font = jcFont7 ; jcCBAnim.BackColor = jcBC1 ; jcCBAnim.ForeColor = jcFC ; jcCBAnim.Text = "REC" ; jcCBAnim.Appearance = jcCBA
		jcCBAnim.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 265) (jcPnl2.pos.y + 121) ; jcCBAnim.FlatStyle = jcFS2 ; jcCBAnim.TextAlign = jcAlign3
		jcCBAnim.Width = 61 ; jcCBAnim.Height = 25 ; jcCBAnim.Padding = jcPadd2 ; animBtnCheck()
/*//////////   jcBtnT1N, jcBtnT2N, jcBtnT3N, jcBtnT4N, jcBtnT5N, jcBtnT6N, jcBtnT7N, jcBtnT8N , jcBtnFSM,  jcBtnVPT   //////////*/
		jcBtnT1N.Font = jcBtnT2N.Font = jcBtnT3N.Font = jcBtnT4N.Font = jcBtnT5N.Font = jcBtnT6N.Font = jcFont1
		jcBtnT7N.Font = jcBtnT8N.Font = jcBtnFSM.Font = jcBtnVPT.Font = jcFont1
		jcBtnT1N.BackColor = jcBtnT2N.BackColor = jcBtnT6N.BackColor = jcBtnT7N.BackColor = jcBtnT8N.BackColor = jcBC1
		jcBtnT3N.BackColor = jcBtnT4N.BackColor = jcBtnT5N.BackColor = jcBtnFSM.BackColor = jcBtnVPT.BackColor = jcBC1
		jcBtnT1N.ForeColor = jcBtnT2N.ForeColor = jcBtnT3N.ForeColor = jcBtnT4N.ForeColor = jcBtnT5N.ForeColor = jcFC
		jcBtnT6N.ForeColor = jcBtnT7N.ForeColor = jcBtnT8N.ForeColor = jcBtnFSM.ForeColor = jcBtnVPT.ForeColor = jcFC
		jcBtnT1N.FlatStyle = jcBtnT2N.FlatStyle = jcBtnT3N.FlatStyle = jcBtnT4N.FlatStyle = jcBtnT5N.FlatStyle = jcFS1
		jcBtnT6N.FlatStyle = jcBtnT7N.FlatStyle = jcBtnT8N.FlatStyle = jcBtnFSM.FlatStyle = jcBtnVPT.FlatStyle = jcFS1
		jcBtnT1N.TextAlign = jcBtnT2N.TextAlign = jcAlign1 ; jcBtnT3N.TextAlign = jcBtnT4N.TextAlign = jcBtnT5N.TextAlign = jcAlign2
		jcBtnT6N.TextAlign = jcBtnT7N.TextAlign = jcBtnT8N.TextAlign = jcBtnFSM.TextAlign = jcBtnVPT.TextAlign = jcAlign2
		jcBtnT1N.Padding = jcBtnT2N.Padding = jcBtnT3N.Padding = jcBtnT4N.Padding = jcBtnT5N.Padding = jcPadd2
		jcBtnT6N.Padding = jcBtnT7N.Padding = jcBtnT8N.Padding = jcBtnFSM.Padding = jcBtnVPT.Padding = jcPadd2
		jcBtnT1N.Cursor = jcBtnT2N.Cursor = jcBtnT3N.Cursor = jcBtnT4N.Cursor = jcBtnT5N.Cursor = jcCurs
		jcBtnT6N.Cursor = jcBtnT7N.Cursor = jcBtnT8N.Cursor = jcBtnFSMCursor = jcBtnVPT.Cursor = jcCurs
		jcBtnT1N.Width = jcBtnT4N.Width = jcBtnT5N.Width = jcBtnT8N.Width = 41 ; jcBtnT2N.Width = jcBtnT3N.Width = jcBtnT6N.Width = jcBtnT7N.Width = 40
		jcBtnFSM.Width = jcBtnVPT.Width = 81 ; jcBtnFSM.Height = jcBtnVPT.Height = 18
		jcBtnT1N.Height = jcBtnT2N.Height = jcBtnT3N.Height = jcBtnT4N.Height = jcBtnT5N.Height = jcBtnT6N.Height = jcBtnT7N.Height = jcBtnT8N.Height = 18
		jcBtnT1N.Text = "dolly" ; jcBtnT2N.Text = "pers." ; jcBtnT3N.Text = "roll" ; jcBtnT4N.Text = "fov" ; jcBtnT5N.Text = "truck" ; jcBtnT6N.Text = "walk"
		jcBtnT7N.Text = "orbit" ; jcBtnT8N.Text = "filter" ; jcBtnFSM.Text = "full - screen" ; jcBtnVPT.Text = "viewports"
		jcBtnT1N.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 165) (jcPnl2.pos.y + 160)
		jcBtnT2N.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 206) (jcPnl2.pos.y + 160)
		jcBtnT3N.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 246) (jcPnl2.pos.y + 160)
		jcBtnT4N.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 286) (jcPnl2.pos.y + 160)
		jcBtnT5N.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 165) (jcPnl2.pos.y + 178)
		jcBtnT6N.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 206) (jcPnl2.pos.y + 178)
		jcBtnT7N.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 246) (jcPnl2.pos.y + 178)
		jcBtnT8N.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 286) (jcPnl2.pos.y + 178)
		jcBtnFSM.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 165) (jcPnl2.pos.y + 196)
		jcBtnVPT.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 246) (jcPnl2.pos.y + 196)
/*//////////   jcLblTLens  //////////*/
		jcLblTLens.Text = " P r e s e t:" ; jcLblTLens.TextAlign = jcAlign3 ; jcLblTLens.Padding = jcPadd2
		jcLblTLens.BackColor = jcBC1 ; jcLblTLens.ForeColor = jcFC ; jcLblTLens.Font = jcFont1 ; jcLblTLens.Width = 80 ; jcLblTLens.Height = 20
		jcLblTLens.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y + 228) ; jcComBoxLens.Enabled = false
/*//////////   jcComBoxLens  //////////*/
		jcComBoxLens.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 247) (jcPnl2.pos.y + 228) ; jcComBoxLens.Width = 79 ; jcComBoxLens.Height = 21
		jcComBoxLens.Backcolor = jcBC1 ; jcComBoxLens.Forecolor = jcFC ; jcComBoxLens.FlatStyle = jcFS2 ; jcComBoxLens.DropDownStyle = jcCBS
		jcComBoxLens.Font = jcFont1 ; AddRangeFn jcComBoxLens LensesTypeArr ; jcComBoxLens.SelectedIndex = 0
/*//////////   jcLblT_FOV, jcLblT_TD, jcLblT_SS, jcLblT_FS, jcLblT_ISO   //////////*/
		jcLblT_FOV.BackColor = jcLblT_TD.BackColor = jcLblT_SS.BackColor = jcLblT_FS.BackColor = jcLblT_ISO.BackColor = jcBC1
		jcLblT_FOV.ForeColor = jcLblT_TD.ForeColor = jcLblT_SS.ForeColor = jcLblT_FS.ForeColor = jcLblT_ISO.ForeColor = jcFC
		jcLblT_FOV.Font = jcLblT_TD.Font = jcLblT_SS.Font = jcLblT_FS.Font = jcLblT_ISO.Font = jcFont1
		jcLblT_FOV.Text = " F O V:" ; jcLblT_TD.Text = " Target D.:" ; jcLblT_SS.Text = " Shutter S.:"
		jcLblT_FS.Text = " f - stop:" ; jcLblT_ISO.Text = " I S O:"
		jcLblT_FOV.TextAlign = jcLblT_TD.TextAlign = jcLblT_SS.TextAlign = jcLblT_FS.TextAlign = jcLblT_ISO.TextAlign = jcAlign3
		jcLblT_FOV.Width = jcLblT_TD.Width = jcLblT_SS.Width = jcLblT_FS.Width = jcLblT_ISO.Width = 80
		jcLblT_FOV.Height = jcLblT_TD.Height = jcLblT_SS.Height = jcLblT_FS.Height = jcLblT_ISO.Height = 15
		jcLblT_FOV.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y + 249)
		jcLblT_TD.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y + 278)
		jcLblT_SS.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y + 307)
		jcLblT_FS.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y + 336)
		jcLblT_ISO.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y + 365)
/*//////////   jcLblSlid_FOV, jcLblSlid_TD, jcLblSlid_SS, jcLblSlid_FS, jcLblSlid_ISO   //////////*/
		jcLblSlid_FOV.BackColor = jcLblSlid_TD.BackColor = jcLblSlid_SS.BackColor = jcLblSlid_FS.BackColor = jcLblSlid_ISO.BackColor = jcBC1
		jcLblSlid_FOV.Width = jcLblSlid_TD.Width = jcLblSlid_SS.Width = jcLblSlid_FS.Width = jcLblSlid_ISO.Width = 160
		jcLblSlid_FOV.Height = jcLblSlid_TD.Height = jcLblSlid_SS.Height = jcLblSlid_FS.Height = jcLblSlid_ISO.Height = 12
		jcLblSlid_FOV.Cursor = jcLblSlid_TD.Cursor = jcLblSlid_SS.Cursor = jcLblSlid_FS.Cursor = jcLblSlid_ISO.Cursor = jcCurs
		jcLblSlid_FOV.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y + 265)
		jcLblSlid_TD.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y + 294)
		jcLblSlid_SS.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y + 323)
		jcLblSlid_FS.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y + 352)
		jcLblSlid_ISO.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 166) (jcPnl2.pos.y + 381)
/*//////////   jcSpn_FOV, jcSpn_TD, jcSpn_SS, jcSpn_FS, jcSpn_ISO   //////////*/	
		jcSpn_FOV.Font = jcSpn_TD.Font = jcSpn_SS.Font = jcSpn_FS.Font = jcSpn_ISO.Font = jcFont1
		jcSpn_FOV.BackColor = jcSpn_TD.BackColor = jcSpn_SS.BackColor = jcSpn_FS.BackColor = jcSpn_ISO.BackColor = jcBC1
		jcSpn_FOV.ForeColor = jcSpn_TD.ForeColor = jcSpn_SS.ForeColor = jcSpn_FS.ForeColor = jcSpn_ISO.ForeColor = jcFC
		jcSpn_FOV.Width = jcSpn_TD.Width = jcSpn_SS.Width = jcSpn_FS.Width = jcSpn_ISO.Width = 79
		jcSpn_FOV.Height = jcSpn_TD.Height = jcSpn_SS.Height = jcSpn_FS.Height = jcSpn_ISO.Height = 15
		jcSpn_FOV.TextAlign = jcSpn_TD.TextAlign = jcSpn_SS.TextAlign = jcSpn_FS.TextAlign = jcSpn_ISO.TextAlign = jcHorizA
		jcSpn_FOV.BorderStyle = jcSpn_TD.BorderStyle = jcSpn_SS.BorderStyle = jcSpn_FS.BorderStyle = jcSpn_ISO.BorderStyle = jcBS1
		jcSpn_FOV.Enabled = false ; jcSpn_TD.Enabled = false ; jcSpn_SS.Enabled = false ; jcSpn_FS.Enabled = false ; jcSpn_ISO.Enabled = false
		jcSpn_FOV.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 247) (jcPnl2.pos.y + 249) 
		jcSpn_TD.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 247) (jcPnl2.pos.y + 278) 
		jcSpn_SS.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 247) (jcPnl2.pos.y + 307) 
		jcSpn_FS.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 247) (jcPnl2.pos.y + 336) 
		jcSpn_ISO.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 247) (jcPnl2.pos.y + 365) 
		jcSpn_FOV.Increment = 1 ; jcSpn_FOV.DecimalPlaces = 3 ; jcSpn_FOV.Minimum = 0 ; jcSpn_FOV.Maximum = 175 ; jcSpn_FOV.Value = 45
		jcSpn_TD.Increment = 1 ; jcSpn_TD.DecimalPlaces = 1 ; jcSpn_TD.Minimum = 1 ; jcSpn_TD.Maximum = 10000 ; jcSpn_TD.Value = 200
		jcSpn_SS.Increment = 1 ; jcSpn_SS.DecimalPlaces = 1 ; jcSpn_SS.Minimum = 0 ; jcSpn_SS.Maximum = 5000 ; jcSpn_SS.Value = 512
		jcSpn_FS.Increment = 1 ; jcSpn_FS.DecimalPlaces = 1 ; jcSpn_FS.Minimum = 1 ; jcSpn_FS.Maximum = 128 ; jcSpn_FS.Value = 16
		jcSpn_ISO.Increment = 1 ; jcSpn_ISO.DecimalPlaces = 1 ; jcSpn_ISO.Minimum = 10 ; jcSpn_ISO.Maximum = 10000 ; jcSpn_ISO.Value = 100
/*//////////   dnOBJECT's Options on "Jump" Panel   //////////*/
/*//////////   jcColDial  //////////*/
		jcColDial.Color = bCL ; jcColDial.AllowFullOpen = false
/*//////////   jcLblJ1  //////////*/
		jcLblJ1.BackColor = jcFC ; jcLblJ1.ForeColor = jcBC2 ; jcLblJ1.Font = jcFont1
		jcLblJ1.Width = 160 ; jcLblJ1.Height = 12 ; jcLblJ1.Text = "JamperCam Info-Grid" ; jcLblJ1.TextAlign = jcAlign2
		jcLblJ1.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 330) (jcPnl2.pos.y + 31) ; jcLblJ1.Padding = jcPadd2
/*//////////   jcComBoxJCG  //////////*/
		jcComBoxJCG.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 330) (jcPnl2.pos.y + 44) ; jcComBoxJCG.Width = 127 ; jcComBoxJCG.Height = 21
		jcComBoxJCG.Backcolor = jcBC1 ; jcComBoxJCG.Forecolor = jcFC ; jcComBoxJCG.FlatStyle = jcFS2 ; jcComBoxJCG.DropDownStyle = jcCBS
		AddRangeFn jcComBoxJCG GridTypeArr ; jcComBoxJCG.SelectedIndex = 0 ;  jcComBoxJCG.Font = jcFont1
/*//////////   jcBtnJOn   //////////*/
		jcBtnJOn.Padding = jcPadd2 ; jcBtnJOn.Text = "ON" ; jcBtnJOn.TextAlign = jcAlign1 ; jcBtnJOn.Font = jcFont1
		jcBtnJOn.BackColor = jcBC1 ; jcBtnJOn.ForeColor = jcFC ; jcBtnJOn.FlatStyle = jcFS1 ; jcBtnJOn.Width = 33 ; jcBtnJOn.Height = 21
		jcBtnJOn.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 458) (jcPnl2.pos.y + 44) ; jcBtnJOn.Cursor = jcCurs
/*//////////   jcLblX, jcLblY   //////////*/
		jcLblX.BackColor = jcLblY.BackColor = jcBC1 ; jcLblX.ForeColor = jcLblY.ForeColor = jcBC2 ; jcLblX.Font = jcLblY.Font = jcFont1
		jcLblX.Width = jcLblY.Width = 20 ; jcLblX.Height = jcLblY.Height = 15 ; jcLblX.Text = "X:" ; jcLblY.Text = "Y:" 
		jcLblX.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 330) (jcPnl2.pos.y + 65) ; jcLblX.Padding = jcLblY.Padding = jcPadd2
		jcLblY.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 394) (jcPnl2.pos.y + 65) ; jcLblX.TextAlign = jcLblY.TextAlign = jcAlign1
/*//////////   jcSpnX, jcSpnY   //////////*/
		jcSpnX.Font = jcSpnY.Font = jcFont1 ; jcSpnX.BackColor = jcSpnY.BackColor = jcBC1 ; jcSpnX.ForeColor = jcSpnY.ForeColor = jcFC
		jcSpnX.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 351) (jcPnl2.pos.y + 65) ; jcSpnX.BorderStyle = jcSpnY.BorderStyle = BS
		jcSpnY.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 415) (jcPnl2.pos.y + 65) ; jcSpnX.Width = jcSpnY.Width = 42
		jcSpnX.Increment = jcSpnY.Increment = jcSpnX.Minimum = jcSpnY.Minimum = 1 ; jcSpnX.Maximum = 500 ; jcSpnY.Maximum = 500
		jcSpnX.Value = 3 ; jcSpnY.Value = 3 ; jcSpnX.Height = jcSpnY.Height = 15 ; jcSpnX.TextAlign = jcSpnY.TextAlign = jcHorizA
		jcSpnX.Enabled = jcSpnY.Enabled = false
/*//////////   jcBtnClrL, jcBtnClrT  //////////*/
		jcBtnClrL.BackColor = jcWBC ; jcBtnClrT.BackColor = jcWGC ; jcBtnClrL.Width = jcBtnClrT.Width = 16 ; jcBtnClrL.Height = jcBtnClrT.Height = 15
		jcBtnClrL.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 458) (jcPnl2.pos.y + 65) ; jcBtnClrL.FlatStyle = jcBtnClrT.FlatStyle = FS1
		jcBtnClrT.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 475) (jcPnl2.pos.y + 65)
/*//////////   jcCBtbg   //////////*/
		jcCBtbg.Font = jcFont1 ; jcCBtbg.BackColor = jcBC1 ; jcCBtbg.ForeColor = jcFC ; jcCBtbg.Text = " Show Text Background"
		jcCBtbg.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 330) (jcPnl2.pos.y + 81) ; jcCBtbg.FlatStyle = jcFS2 ; jcCBtbg.TextAlign = jcAlign3
		jcCBtbg.Width = 160 ; jcCBtbg.Height = 12 ; jcCBtbg.Padding = jcPadd2 ; jcCBtbg.Enabled = false ; jcCBtbg.Checked = true
/*//////////   jcBtnRWN   //////////*/
		jcBtnRWN.Font = jcFont1 ; jcBtnRWN.Text = "Read / Write Cam Note" ; jcBtnRWN.BackColor = jcFC ; jcBtnRWN.ForeColor = jcBC2
		jcBtnRWN.Location = dotNetObject "System.Drawing.Point" (jcPnl2.pos.x + 329) (jcPnl2.pos.y + 94) ; jcBtnRWN.FlatStyle = jcFS1
		jcBtnRWN.Width = 162 ; jcBtnRWN.Height = 18 ; jcBtnRWN.Padding = jcPadd2 ; jcBtnRWN.Cursor = jcCurs ; jcBtnRWN.TextAlign = jcAlign2
/*//////////   ASSIGN THE EVENTS   //////////*/
		dotnet.addEventHandler jcTTb1 "Draw" jcTTb1Draw
		dotnet.addEventHandler jcToolTip "Draw" jcToolTipDraw
		dotNet.AddEventHandler jcBtn1 "Click" jcBtn1Click
		dotNet.AddEventHandler jcBtnSetup "Click" jcBtnSetupClick
		dotNet.AddEventHandler jcBtnTune "Click" jcBtnTuneClick
		dotNet.AddEventHandler jcBtnJump "Click" jcBtnJumpClick
		dotNet.addEventHandler jcLblS1h "MouseHover" jcLblS1hMH
		dotNet.addEventHandler jcLblS1h "MouseLeave" jcLblS1hML
		dotnet.AddEventHandler jcListBox "DoubleClick" jcListBoxDC
		dotnet.AddEventHandler jcListBox "GotFocus" jcListBoxGF
 		dotnet.AddEventHandler jcListBox "LostFocus" jcListBoxLF
		dotnet.AddEventHandler jcListBox "KeyDown" jcListBoxKD
 		dotnet.AddEventHandler jcListBox "KeyUp" jcListBoxKU
		dotnet.AddEventHandler jcTBoxS1 "GotFocus" jcTBoxS1GF
 		dotnet.AddEventHandler jcTBoxS1 "LostFocus" jcTBoxS1LF
		dotNet.AddEventHandler jcBtnWC "MouseClick" colorDialogCol
		dotnet.AddEventHandler jcCB1 "Click" jcCB1Click
		dotnet.AddEventHandler jcCB2 "Click" jcCB2Click
		dotnet.AddEventHandler jcCB3 "Click" jcCB3Click
		dotnet.AddEventHandler jcCB4 "Click" jcCB4Click
		dotNet.AddEventHandler jcBtnCCFV "Click" jcBtnCCFVClick
		dotNet.addEventHandler jcBtnCCFV "MouseHover" getjcTTMH
		dotNet.AddEventHandler jcBtnSwC "Click" jcBtnSwCClick
		dotNet.addEventHandler jcBtnSwC "MouseHover" getjcTTMH
		dotNet.AddEventHandler jcBtnRV "Click" jcBtnRVClick
		dotNet.addEventHandler jcBtnRV "MouseHover" getjcTTMH
		dotNet.AddEventHandler jcBtnSvC "Click" jcBtnSvCClick
		dotNet.addEventHandler jcBtnSvC "MouseHover" getjcTTMH
		dotNet.AddEventHandler jcBtnSpV "Click" jcBtnSpVClick
		dotNet.addEventHandler jcBtnSpV "MouseHover" getjcTTMH
		dotNet.AddEventHandler jcBtnSpC "Click" jcBtnSpCClick
		dotNet.addEventHandler jcBtnSpC "MouseHover" getjcTTMH
		dotNet.AddEventHandler jcSpnAng "GotFocus" jcSpnAngGF
		dotNet.AddEventHandler jcSpnAng "LostFocus" jcSpnAngLF
		dotNet.AddEventHandler jcSpnSpd "GotFocus" jcSpnSpdGF
		dotNet.AddEventHandler jcSpnSpd "LostFocus" jcSpnSpdLF
		dotnet.AddEventHandler jcCB7 "Click" jcCB7Click
		dotnet.AddEventHandler jcCB8 "Click" jcCB8Click
		dotnet.AddEventHandler jcCB9 "Click" jcCB9Click
		dotNet.AddEventHandler jcSpnSAI1 "GotFocus" jcSpnSAI1GF
		dotNet.AddEventHandler jcSpnSAI1 "LostFocus" jcSpnSAI1LF
		dotnet.AddEventHandler jcSpnSAI1 "KeyDown" IncrementUpToTen
		dotnet.AddEventHandler jcSpnSAI1 "KeyUp" IncrementDnToZero
		dotNet.AddEventHandler jcSpnSAI2 "GotFocus" jcSpnSAI2GF
		dotNet.AddEventHandler jcSpnSAI2 "LostFocus" jcSpnSAI2LF
		dotnet.AddEventHandler jcSpnSAI2 "KeyDown" IncrementUpToTen
		dotnet.AddEventHandler jcSpnSAI2 "KeyUp" IncrementDnToZero
		dotNet.AddEventHandler jcSpnACS "GotFocus" jcSpnACSGF
		dotNet.AddEventHandler jcSpnACS "LostFocus" jcSpnACSLF
		dotNet.AddEventHandler jcSpnSCS "GotFocus" jcSpnSCSGF
		dotNet.AddEventHandler jcSpnSCS "LostFocus" jcSpnSCSLF
		dotnet.AddEventHandler jcBtnRCF "Click" jcBtnRCFClick
		dotNet.addEventHandler jcBtnRCF "MouseHover" getjcTTMH
		dotnet.AddEventHandler jcBtnAF "Click" jcBtnAFClick
		dotNet.addEventHandler jcBtnAF "MouseHover" getjcTTMH
		dotnet.AddEventHandler jcBtnCJC "Click" jcBtnCJCClick

		dotNet.AddEventHandler jcComBoxJCL "MouseHover" jcComBoxJCLMH
		dotNet.AddEventHandler jcComBoxJCL "MouseDown" jcComBoxJCLMD
		dotnet.AddEventHandler jcBtnSJC "Click" jcBtnSJCClick
		dotNet.addEventHandler jcBtnSJC "MouseHover" getjcTTMH
		dotnet.AddEventHandler jcBtnT1K "Click" jcBtnT1KClick
		dotNet.addEventHandler jcBtnT1K "MouseHover" getjcTTMH
		dotnet.AddEventHandler jcBtnT2K "Click" jcBtnT2KClick
		dotNet.addEventHandler jcBtnT2K "MouseHover" getjcTTMH
		dotnet.AddEventHandler jcBtnT3K "Click" jcBtnT3KClick
		dotNet.addEventHandler jcBtnT3K "MouseHover" getjcTTMH
		dotnet.AddEventHandler jcBtnT4K "Click" jcBtnT4KClick
		dotNet.addEventHandler jcBtnT4K "MouseHover" getjcTTMH
		dotnet.AddEventHandler jcBtnPlay "Click" jcBtnPlayClick
		dotNet.addEventHandler jcBtnPlay "MouseHover" getjcTTMH
		dotNet.AddEventHandler jcSpnNthF "GotFocus" jcSpnNthFGF
		dotNet.AddEventHandler jcSpnNthF "LostFocus" jcSpnNthFLF
		dotnet.AddEventHandler jcBtnT1F "Click" jcBtnT1FClick
		dotNet.addEventHandler jcBtnT1F "MouseHover" getjcTTMH
		dotnet.AddEventHandler jcBtnT2F "Click" jcBtnT2FClick
		dotNet.addEventHandler jcBtnT2F "MouseHover" getjcTTMH
		dotnet.AddEventHandler jcBtnT3F "Click" jcBtnT3FClick
		dotNet.addEventHandler jcBtnT3F "MouseHover" getjcTTMH
		dotnet.AddEventHandler jcBtnT4F "Click" jcBtnT4FClick
		dotNet.addEventHandler jcBtnT4F "MouseHover" getjcTTMH
		dotNet.AddEventHandler jcSpnStart "ValueChanged" jcSpnStartVC
		dotnet.AddEventHandler jcSpnStart "GotFocus" jcSpnStartGF
 		dotnet.AddEventHandler jcSpnStart "LostFocus" jcSpnStartLF
		dotnet.AddEventHandler jcSpnStart "KeyDown" IncrementUpToTen
		dotnet.AddEventHandler jcSpnStart "KeyUp" IncrementDnToZero
		dotNet.AddEventHandler jcSpnEnd "ValueChanged" jcSpnEndVC
		dotnet.AddEventHandler jcSpnEnd "GotFocus" jcSpnEndGF
 		dotnet.AddEventHandler jcSpnEnd "LostFocus" jcSpnEndLF
		dotnet.AddEventHandler jcSpnEnd "KeyDown" IncrementUpToTen
		dotnet.AddEventHandler jcSpnEnd "KeyUp" IncrementDnToOne
		dotNet.AddEventHandler jcSpnSlid "ValueChanged" jcSpnSlidVC
		dotnet.AddEventHandler jcSpnSlid "GotFocus" jcSpnSlidGF
 		dotnet.AddEventHandler jcSpnSlid "LostFocus" jcSpnSlidLF
		dotnet.AddEventHandler jcSpnSlid "KeyDown" IncrementUpToTen
		dotnet.AddEventHandler jcSpnSlid "KeyUp" IncrementDnToZero
		dotnet.AddEventHandler jcCBAnim "Click" jcCBAnimClick
		dotNet.addEventHandler jcCBAnim "MouseHover" getjcTTMH
		dotnet.AddEventHandler jcBtnT1N "Click" jcBtnT1NClick
		dotnet.AddEventHandler jcBtnT2N "Click" jcBtnT2NClick
		dotnet.AddEventHandler jcBtnT3N "Click" jcBtnT3NClick
		dotnet.AddEventHandler jcBtnT4N "Click" jcBtnT4NClick
		dotnet.AddEventHandler jcBtnT5N "Click" jcBtnT5NClick
		dotnet.AddEventHandler jcBtnT6N "Click" jcBtnT6NClick
		dotnet.AddEventHandler jcBtnT7N "Click" jcBtnT7NClick
		dotnet.AddEventHandler jcBtnT8N "Click" jcBtnT8NClick
		dotnet.AddEventHandler jcBtnFSM "Click" jcBtnFSMClick
		dotnet.AddEventHandler jcBtnVPT "Click" jcBtnVPTClick
		dotNet.AddEventHandler jcComBoxLens "SelectedIndexChanged" jcComBoxLensSIC
		dotNet.AddEventHandler jcComBoxLens "MouseHover" jcComBoxLensMH
		dotNet.AddEventHandler jcComBoxLens "LostFocus" jcComBoxLensLF
		dotNet.AddEventHandler jcLblSlid_FOV "MouseDown" jcLblSlid_FOVMD
		dotNet.AddEventHandler jcLblSlid_FOV "MouseMove" jcLblSlid_FOVMM
		dotNet.AddEventHandler jcLblSlid_FOV "MouseUp" jcLblSlid_FOVMU
		dotNet.AddEventHandler jcLblSlid_FOV "Paint" jcLblSlid_FOVPaint
		dotNet.AddEventHandler jcSpn_FOV "ValueChanged" jcSpn_FOVVC
		dotnet.AddEventHandler jcSpn_FOV "GotFocus" jcSpn_FOVGF
 		dotnet.AddEventHandler jcSpn_FOV "LostFocus" jcSpn_FOVLF
		dotnet.AddEventHandler jcSpn_FOV "KeyDown" IncrementUpToTen
		dotnet.AddEventHandler jcSpn_FOV "KeyUp" IncrementDnToZero
		dotNet.AddEventHandler jcLblSlid_TD "MouseDown" jcLblSlid_TDMD
		dotNet.AddEventHandler jcLblSlid_TD "MouseMove" jcLblSlid_TDMM
		dotNet.AddEventHandler jcLblSlid_TD "MouseUp" jcLblSlid_TDMU
		dotNet.AddEventHandler jcLblSlid_TD "Paint" jcLblSlid_TDPaint
		dotNet.AddEventHandler jcSpn_TD "ValueChanged" jcSpn_TDVC
		dotnet.AddEventHandler jcSpn_TD "GotFocus" jcSpn_TDGF
 		dotnet.AddEventHandler jcSpn_TD "LostFocus" jcSpn_TDLF
		dotnet.AddEventHandler jcSpn_TD "KeyDown" IncrementUpToTen
		dotnet.AddEventHandler jcSpn_TD "KeyUp" IncrementDnToZero
		dotNet.AddEventHandler jcLblSlid_SS "MouseDown" jcLblSlid_SSMD
		dotNet.AddEventHandler jcLblSlid_SS "MouseMove" jcLblSlid_SSMM
		dotNet.AddEventHandler jcLblSlid_SS "MouseUp" jcLblSlid_SSMU
		dotNet.AddEventHandler jcLblSlid_SS "Paint" jcLblSlid_SSPaint
		dotNet.AddEventHandler jcSpn_SS "ValueChanged" jcSpn_SSVC
		dotnet.AddEventHandler jcSpn_SS "GotFocus" jcSpn_SSGF
 		dotnet.AddEventHandler jcSpn_SS "LostFocus" jcSpn_SSLF
		dotnet.AddEventHandler jcSpn_SS "KeyDown" IncrementUpToTen
		dotnet.AddEventHandler jcSpn_SS "KeyUp" IncrementDnToZero
		dotNet.AddEventHandler jcLblSlid_FS "MouseDown" jcLblSlid_FSMD
		dotNet.AddEventHandler jcLblSlid_FS "MouseMove" jcLblSlid_FSMM
		dotNet.AddEventHandler jcLblSlid_FS "MouseUp" jcLblSlid_FSMU
		dotNet.AddEventHandler jcLblSlid_FS "Paint" jcLblSlid_FSPaint
		dotNet.AddEventHandler jcSpn_FS "ValueChanged" jcSpn_FSVC
		dotnet.AddEventHandler jcSpn_FS "GotFocus" jcSpn_FSGF
 		dotnet.AddEventHandler jcSpn_FS "LostFocus" jcSpn_FSLF
		dotnet.AddEventHandler jcSpn_FS "KeyDown" IncrementUpToTen
		dotnet.AddEventHandler jcSpn_FS "KeyUp" IncrementDnToZero
		dotNet.AddEventHandler jcLblSlid_ISO "MouseDown" jcLblSlid_ISOMD
		dotNet.AddEventHandler jcLblSlid_ISO "MouseMove" jcLblSlid_ISOMM
		dotNet.AddEventHandler jcLblSlid_ISO "MouseUp" jcLblSlid_ISOMU
		dotNet.AddEventHandler jcLblSlid_ISO "Paint" jcLblSlid_ISOPaint
		dotNet.AddEventHandler jcSpn_ISO "ValueChanged" jcSpn_ISOVC
		dotnet.AddEventHandler jcSpn_ISO "GotFocus" jcSpn_ISOGF
 		dotnet.AddEventHandler jcSpn_ISO "LostFocus" jcSpn_ISOLF
		dotnet.AddEventHandler jcSpn_ISO "KeyDown" IncrementUpToTen
		dotnet.AddEventHandler jcSpn_ISO "KeyUp" IncrementDnToZero

		dotNet.AddEventHandler jcComBoxJCG "SelectedIndexChanged" jcComBoxJCGSIC
		dotNet.AddEventHandler jcComBoxJCG "MouseHover" jcComBoxJCGMH
		dotNet.AddEventHandler jcBtnJOn "Click" jcBtnJOnClick
		dotNet.addEventHandler jcBtnJOn "MouseHover" getjcTTMH
		dotNet.AddEventHandler jcCBtbg "CheckStateChanged" RedrawActiveView
		dotnet.AddEventHandler jcSpnX "GotFocus" jcSpnXGF
 		dotnet.AddEventHandler jcSpnX "LostFocus" jcSpnXLF
		dotNet.AddEventHandler jcSpnX "ValueChanged" RedrawActiveView
		dotNet.AddEventHandler jcSpnX "KeyUp" jcSpnXYKU
		dotNet.AddEventHandler jcSpnX "KeyDown" jcSpnXYKD
		dotnet.AddEventHandler jcSpnY "GotFocus" jcSpnYGF
 		dotnet.AddEventHandler jcSpnY "LostFocus" jcSpnYLF
		dotNet.AddEventHandler jcSpnY "ValueChanged" RedrawActiveView
		dotNet.AddEventHandler jcSpnY "KeyUp" jcSpnXYKU
		dotNet.AddEventHandler jcSpnY "KeyDown" jcSpnXYKD
		dotNet.AddEventHandler jcBtnClrL "Click" colorDialogCol
		dotNet.addEventHandler jcBtnClrL "MouseHover" getjcTTMH
		dotNet.AddEventHandler jcBtnClrT "Click" colorDialogCol
		dotNet.addEventHandler jcBtnClrT "MouseHover" getjcTTMH
		dotNet.AddEventHandler jcBtnRWN "Click" jcBtnRWNClick
/*//////////   ADD dotNET OBJECTS TO PANEL1  //////////*/
		jcPnl1.Controls.Add(jcBtn1) ; jcPnl1.Controls.Add(jcLbl1) ; jcPnl1.Controls.Add(jcLbl2)
		jcPnl1.Controls.Add(jcBtnSetup) ; jcPnl1.Controls.Add(jcBtnTune) ; jcPnl1.Controls.Add(jcBtnJump)
/*//////////   ADD dotNET OBJECTS TO PANEL2  //////////*/
		jcPnl2.Controls.Add(jcListBox) ; jcPnl2.Controls.Add(jcLblS1) ; jcPnl2.Controls.Add(jcLblS2) ; jcPnl2.Controls.Add(jcLblS1h) ; jcPnl2.Controls.Add(jcLblSJC)
		jcPnl2.Controls.Add(jcTBoxS1) ; jcPnl2.Controls.Add(jcBtnWC) ; jcPnl2.Controls.Add(jcCB1) ; jcPnl2.Controls.Add(jcCB2) ; jcPnl2.Controls.Add(jcCB3)
		jcPnl2.Controls.Add(jcCB4) ; jcPnl2.Controls.Add(jcLblS3) ; jcPnl2.Controls.Add(jcLblS4) ; jcPnl2.Controls.Add(jcBtnCCFV) ; jcPnl2.Controls.Add(jcBtnSwC)
		jcPnl2.Controls.Add(jcBtnRV) ; jcPnl2.Controls.Add(jcBtnSvC) ; jcPnl2.Controls.Add(jcLblAS) ; jcPnl2.Controls.Add(jcSpnAng) ; jcPnl2.Controls.Add(jcSpnSpd)
		jcPnl2.Controls.Add(jcBtnSpV) ; jcPnl2.Controls.Add(jcBtnSpC) ; jcPnl2.Controls.Add(jcCB5) ; jcPnl2.Controls.Add(jcCB6) ; jcPnl2.Controls.Add(jcCB7)
		jcPnl2.Controls.Add(jcCB8) ; jcPnl2.Controls.Add(jcCB9) ; jcPnl2.Controls.Add(jcSpnSAI1) ; jcPnl2.Controls.Add(jcSpnSAI2) ; jcPnl2.Controls.Add(jcLblACS)
		jcPnl2.Controls.Add(jcSpnACS) ; jcPnl2.Controls.Add(jcLblSCS) ; jcPnl2.Controls.Add(jcSpnSCS) ; jcPnl2.Controls.Add(jcTBoxS2) ; jcPnl2.Controls.Add(jcBtnRCF)
		jcPnl2.Controls.Add(jcBtnAF) ; jcPnl2.Controls.Add(jcBtnCJC)

		jcPnl2.Controls.Add(jcLblT1) ; jcPnl2.Controls.Add(jcLblT2) ; jcPnl2.Controls.Add(jcLblT3) ; jcPnl2.Controls.Add(jcLblT4) ; jcPnl2.Controls.Add(jcComBoxJCL)
		jcPnl2.Controls.Add(jcBtnSJC) ; jcPnl2.Controls.Add(jcBtnT1K) ; jcPnl2.Controls.Add(jcBtnT2K) ; jcPnl2.Controls.Add(jcBtnT3K) ; jcPnl2.Controls.Add(jcBtnT4K)
		jcPnl2.Controls.Add(jcLblAInf) ; jcPnl2.Controls.Add(jcBtnPlay) ; jcPnl2.Controls.Add(jcLblNthF) ; jcPnl2.Controls.Add(jcSpnNthF) ; jcPnl2.Controls.Add(jcBtnT1F)
		jcPnl2.Controls.Add(jcBtnT2F) ; jcPnl2.Controls.Add(jcBtnT3F) ; jcPnl2.Controls.Add(jcBtnT4F) ; jcPnl2.Controls.Add(jcSpnStart) ; jcPnl2.Controls.Add(jcSpnSlid)
		jcPnl2.Controls.Add(jcSpnEnd) ; jcPnl2.Controls.Add(jcLblT5) ; jcPnl2.Controls.Add(jcLblAnim) ; jcPnl2.Controls.Add(jcCBAnim) ; jcPnl2.Controls.Add(jcLblT6)
		jcPnl2.Controls.Add(jcBtnT1N) ; jcPnl2.Controls.Add(jcBtnT2N) ; jcPnl2.Controls.Add(jcBtnT3N) ; jcPnl2.Controls.Add(jcBtnT4N) ; jcPnl2.Controls.Add(jcBtnT5N)
		jcPnl2.Controls.Add(jcBtnT6N) ; jcPnl2.Controls.Add(jcBtnT7N) ; jcPnl2.Controls.Add(jcBtnT8N) ; jcPnl2.Controls.Add(jcBtnFSM) ; jcPnl2.Controls.Add(jcBtnVPT) 
		jcPnl2.Controls.Add(jcLblT7) ; jcPnl2.Controls.Add(jcLblTLens) ; jcPnl2.Controls.Add(jcComBoxLens) ; jcPnl2.Controls.Add(jcLblT_FOV) ; jcPnl2.Controls.Add(jcLblT_TD)
		jcPnl2.Controls.Add(jcLblT_SS) ; jcPnl2.Controls.Add(jcLblT_FS) ; jcPnl2.Controls.Add(jcLblT_ISO) ; jcPnl2.Controls.Add(jcLblSlid_FOV) ; jcPnl2.Controls.Add(jcLblSlid_TD)
		jcPnl2.Controls.Add(jcLblSlid_SS) ; jcPnl2.Controls.Add(jcLblSlid_FS) ; jcPnl2.Controls.Add(jcLblSlid_ISO) ; jcPnl2.Controls.Add(jcSpn_FOV) ; jcPnl2.Controls.Add(jcSpn_TD)
		jcPnl2.Controls.Add(jcSpn_SS) ; jcPnl2.Controls.Add(jcSpn_FS) ; jcPnl2.Controls.Add(jcSpn_ISO)

		jcPnl2.Controls.Add(jcLblJ1) ; jcPnl2.Controls.Add(jcComBoxJCG) ; jcPnl2.Controls.Add(jcBtnJOn) ; jcPnl2.Controls.Add(jcLblX) ; jcPnl2.Controls.Add(jcLblY)
		jcPnl2.Controls.Add(jcSpnX) ; jcPnl2.Controls.Add(jcSpnY) ; jcPnl2.Controls.Add(jcBtnClrL) ; jcPnl2.Controls.Add(jcBtnClrT) ; jcPnl2.Controls.Add(jcCBtbg)
		jcPnl2.Controls.Add(jcBtnRWN)
/*//////////   "ON ROLLOUT OPEN" FUNCTIONS   //////////*/
		rendererCheck() ; createJC_List() ; create_JC_Callbacks() ; if jcComBoxJCL.items.count > 0 do jcComBoxJCL.SelectedIndex = 0 ; if slidertime != 0f do slidertime = 0f
		defineSliderPaint jcSpn_FOV jcLblSlid_FOV Arr_FOV ; defineSliderPaint jcSpn_TD jcLblSlid_TD Arr_TD ; defineSliderPaint jcSpn_SS jcLblSlid_SS Arr_SS
		defineSliderPaint jcSpn_FS jcLblSlid_FS Arr_FS ; defineSliderPaint jcSpn_ISO jcLblSlid_ISO Arr_ISO
	)
/*///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   TIMER ACTION   //////////*/
	on jctimeTick tick do
	(
		local ARS = animationRange.start, ARE = animationRange.end, nc = selection[1]
		if jcBtnTune.ForeColor == jcFC or jcBtnJump.ForeColor == jcFC do (animPlayState() ; animBtnState())
		if jcSpnStart.value != ARS do jcSpnStart.value = ARS
		if jcSpnSlid.value != sliderTime do
		(
			jcSpnSlid.value = sliderTime
			jcLblAInf.Text = "FPS | frame | time >>>\n" + framerate as string + " | " + (jcSpnSlid.value as time) as string + " | " + (round (jcSpnSlid.value as float/framerate) 3) + "s"
		)
		if jcSpnEnd.value != aRangeEnd do jcSpnEnd.value = ARE ; updateValue()
		if jcComBoxJCL.items.count > 0 do
		(
			for i = 1 to jcComBoxJCL.items.count where (nc != undefined and jcComBoxJCL.Items.item[i-1] == nc.name) do ( jcComBoxJCL.SelectedIndex = (i-1) )
		)
		if jcBtnSetup.BackColor == jcFC do
		(
			if jcListBox.items.count > 0 do
			(
				local new_jcLB_Items = #() ; onRefresh = true
				new_jcLB_Items = for i in 1 to jcListBox.Items.Count where isValidNode (getNodeByName jcListBox.Items.item[i-1]) collect jcListBox.Items.item[i-1]
				if jcListBox.Items.Count == new_jcLB_Items.count then #abort else (jcListBox.items.Clear() ; RefreshOnce jcListBox ; AddRangeFn jcListBox new_jcLB_Items)
				for i = 1 to jcListBox.items.count where (nc != undefined and jcListBox.Items.item[i-1] == nc.name) do
				(  jcListBox.ClearSelected() ; jcListBox.SelectedIndex = (i-1) )
			)
		)		
	)
/*///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   CLOSE ROLL ACTION   //////////*/
	on jcRoll close do
	(
		unregisterRedrawViewsCallback JC_Labels ; unregisterRedrawViewsCallback CamInfoGridView ; max views redraw
		remove_JC_Callbacks() ; jcGC.collect() ; gc light:true ; clearListener()
	)
)
createDialog jcRoll 164 62 10 110 style:#(#style_titlebar, #style_sysmenu, #style_toolwindow) 
)