/*//////////   SCRIPT:   Spirofly  Cam v1.0   //////////*/
/*//////////   WRITTEN BY:   Branko Zivkovic   //////////*/
/*//////////   EMAIL:   barigazy@hotmail.com   //////////*/
(
global scRoll, defCamPos
if scRoll != undefined do try (destroyDialog scRoll) catch()
rollout scRoll "   Spirofly  Cam v1.0 "
(
	dotNetControl scPnl "Panel" pos:[0,0]
/*///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   LOCALS   //////////*/
	local scTTb1, scLbl1, scBtn1, scLbl2, scLblTitl1, scLblTitl2, scLblTitl3, scBtnTarg, scBtnSour, scLblRad, scSpnRad, scLblRad, scLblEle, \
	scLblTargEle, scLblHelpEle, scSpnRad, scSpnEle, scSpnTargEle, scSpnHelpEle, scLblTurn, scSpnTurn, scLblStep, scSpnStep, scBtnRTH, scBtnRevA, \
	scBtnRemA, scBtnCSC, scComBox, scCB1, scCB2, scCB3, scBtnATC

	local scFont1 = dotNetObject "System.Drawing.Font" "Verdana" 7 ((dotNetClass "System.Drawing.FontStyle").bold)
	local scFont2 = dotNetObject "System.Drawing.Font" "ISOCTEUR" 12 ((dotNetClass "System.Drawing.FontStyle").bold)
	local scFont3 = dotNetObject "System.Drawing.Font" "ArialBlack" 18 ((dotNetClass "System.Drawing.FontStyle").bold)
	local scFont4 = dotNetObject "System.Drawing.Font" "ISOCPEUR" 12 ((dotNetClass "System.Drawing.FontStyle").bold)
	local scCurs = (dotNetClass "System.Windows.Forms.Cursors").Hand
	local scCurs1 = (dotNetClass "System.Windows.Forms.Cursors").Help
	local scAlign1 = (dotNetClass "System.Drawing.ContentAlignment").MiddleCenter
	local scAlign2 = (dotNetClass "System.Drawing.ContentAlignment").BottomCenter
	local scAlign3 = (dotNetClass "System.Drawing.ContentAlignment").MiddleLeft
	local scAlign4 = (dotNetClass "System.Drawing.ContentAlignment").TopLeft
	local scHorizA = (dotNetClass "System.Windows.Forms.HorizontalAlignment").center
	local scFS1 = (dotNetClass "System.Windows.Forms.FlatStyle").Popup
	local scFS2 = (dotNetClass "System.Windows.Forms.FlatStyle").Flat
	local scFS3 = (dotNetClass "System.Windows.Forms.FlatStyle").Standard
	local scBS1 = (dotNetClass "System.Windows.Forms.BorderStyle").None
	local scCBS = (dotNetClass "System.Windows.Forms.ComboBoxStyle").DropDownList
	local scBC = (dotNetClass "System.Drawing.Color").FromArgb 100 100 100
	local scBC1 = (dotNetClass "System.Drawing.Color").FromArgb 80 80 80
	local scBC2 = (dotNetClass "System.Drawing.Color").FromArgb 40 40 40
	local scBC3 = (dotNetClass "System.Drawing.Color").FromArgb 60 60 60
	local scBC4 = (dotNetClass "System.Drawing.Color").FromArgb 20 20 20
	local scFC = (dotNetClass "System.Drawing.Color").FromArgb 200 200 200
	local scFC1 = (dotNetClass "System.Drawing.Color").FromArgb 140 140 140
	local scBC5 = (dotNetClass "System.Drawing.Color").FromArgb 80 0 0
	local scGM = (dotNetClass "System.Drawing.Drawing2D.LinearGradientMode").Vertical
	local scF_HCT = dotNet.CombineEnums (dotNetClass "TextFormatFlags").HorizontalCenter (dotNetClass "TextFormatFlags").Top
	local scF_HCB = dotNet.CombineEnums (dotNetClass "TextFormatFlags").HorizontalCenter (dotNetClass "TextFormatFlags").Bottom
	local scF_HCVC = dotNet.CombineEnums (dotNetClass "TextFormatFlags").HorizontalCenter (dotNetClass "TextFormatFlags").VerticalCenter
	local scTxtR = dotNetClass "TextRenderer"
	local scGC = dotNetClass "System.GC"
	local scPadd1 = dotNetObject "Padding" 1 2 1 1
	local scPadd2 = dotNetObject "Padding" 0 0 0 0

	local PathTypeArr = #(" C i r c u l a r", " E c l i p s e", " T r e f o i l", " F l o w e r", " G o l d   F i s h", " R o u n d   C o r n e r", " S h a r p   C o r n e r s", " C y c l o p   E y e", " C o s m o s   E y e", " H e l i x   T w i s t e r")
	local Targ_Obj, S_Cam, S_Cam_Targ, S_Cam_Helper, dist1, dist2, SC_Layer, Tstart, Tend, r
/*///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   FUNCTION DEFINITIONS   //////////*/
	fn filterObj o = isKindof o geometryClass and not isKindof o camera and not isKindOf o targetObject
	fn filterCam c = isKindof c camera and isValidNode c.Target and substring c.name 1 3 != "SC_"
	fn DisableAccel = (enableAccelerators = false) ; fn EnableAccel = (enableAccelerators = true)
	fn RefreshOnce scObject = (if onRefresh == true do ( onRefresh = false ; scObject.Refresh() ; onRefresh = true ))
	fn AddRangeFn scObj mxsArr = (for i in 1 to mxsArr.count do scObj.Items.Add (dotNetObject "System.String" mxsArr[i]) )
	fn newUniqueName true obj strA strR =
	(
		local strNum = "0123456789"
		local newnamearr = #()
		if true then ( newnamearr = filterstring obj.name strNum ; uniquename (strA+newnamearr[1]) )
		else ( newnamearr = filterstring obj.name strNum ; uniquename (replace newnamearr[1] 1 strR.count strA ))
	)
	fn Fill_SC_Layer Arr =
	(
		SC_Layer = LayerManager.getLayerFromName "#[SPIROFLYCAM]"
		if SC_Layer == undefined then
		(
			SC_Layer = LayerManager.newLayerFromName "#[SPIROFLYCAM]"
			SC_Layer.current = true ; SC_Layer.wireColor = [255,165,0]
		) else (SC_Layer.current = true)
		if Arr.count > 0 do ( for n in 1 to Arr.count where isValidNode Arr[n] do SC_Layer.addNode Arr[n] )
	)
	fn changeCamSelection = (
		local selcam = getNodeByName scBtnSour.Text
		if isValidNode selcam then
		(
			scSpnRad.Value = sqrt( (selcam.TargetDistance)^2 - (selcam.pos.z - selcam.target.pos.z)^2)
			scSpnEle.Value = selcam.pos.z ; scSpnTargEle.Value = selcam.target.pos.z
			if selcam.parent != undefined do scSpnHelpEle.Value = selcam.parent.pos.z
			if selcam.isAnimated == false do defCamPos = S_Cam.pos
		)
	)
	fn checkSC = 
	(
		local selcam = getNodeByName scBtnSour.Text
		local selobj = getNodeByName scBtnTarg.Text
		if (not isValidNode selcam) do
		(
			scBtnSour.Text = "Target > Camera" ; S_Cam = undefined ; S_Cam_Targ = undefined ; S_Cam_Helper = undefined
			scBtnSour.BackColor = scBC1 ; scBtnSour.ForeColor = scBC2 ; scRoll.height = 103
		)
		if (not isValidNode selobj) do
		(
			scBtnTarg.Text = "Target > Object" ; Targ_Obj = undefined
			scBtnTarg.BackColor = scBC1 ; scBtnTarg.ForeColor = scBC2 ; scRoll.height = 103
		)
	)
	fn create_SC_Callbacks =
	(
		callbacks.addScript #viewportChange "scRoll.changeCamSelection()" id:#SpiroflyCam1
		callbacks.addScript #viewportChange "scRoll.checkSC()" id:#SpiroflyCam2
	)
	fn remove_SC_Callback1 = ( try (callbacks.removeScripts id:#SpiroflyCam1 ) catch() )
	fn remove_SC_Callback2 = ( try (callbacks.removeScripts id:#SpiroflyCam2 ) catch() )
	fn scTTb1Draw ttsc =
	(
  		local ttscTitle = "Spirofly * Cam v1.0", ttscSize = ttsc.Bounds, ttscBO = 3
		local ttsctxt = "created by: Branko Zivkovic\r\nemail: barigazy@hotmail.com"
		rectttsc = dotNetObject "System.Drawing.Rectangle" (ttscSize.x + ttscBO) (ttscSize.y + ttscBO) (ttscSize.Width - 2*ttscBO) (ttscSize.Height - 2*ttscBO)
		ttscGBrush = dotnetobject "System.Drawing.Drawing2D.LinearGradientBrush" ttscSize scBC scBC2 scGM
		ttscGBrush1 = dotnetobject "System.Drawing.Drawing2D.LinearGradientBrush" ttscSize scBC4 scBC3 scGM
  		ttsc.Graphics.FillRectangle ttscGBrush ttscSize ; ttsc.Graphics.FillRectangle ttscGBrush1 rectttsc
		scTxtR.DrawText ttsc.Graphics ttscTitle scFont4 rectttsc scFC scF_HCT
		scTxtR.DrawText ttsc.Graphics ttsctxt scFont1 rectttsc scFC1 scF_HCB
	)
	fn scSpnTargEleGF sender col = ( if animButtonState != true then sender.BackColor = scBC2 else sender.BackColor = scBC5 ; DisableAccel() )
	fn scSpnHelpEleGF sender col =
	(
		if animButtonState != true then sender.BackColor = scBC2 else sender.BackColor = scBC5
		if S_Cam_Helper != undefined do sender.Value = S_Cam_Helper.pos.z ; DisableAccel()
	)
	fn scSpnGF sender col = ( sender.BackColor = scBC2 ; DisableAccel() )
	fn scSpnLF sender col = ( sender.BackColor = scBC1 ; EnableAccel() )
	fn IncrementUpToTen sender arg = if arg.keyValue == 17  do sender.Increment = 10
	fn IncrementDnToZero sender arg =
	(
		local spnCnt = (sender.Value as string).count
		if arg.keyValue == 13 do
		(
			if sender.Value > sender.Maximum then sender.Value = sender.Maximum
			else if sender.Value < sender.Minimum do sender.Value = sender.Minimum
			if sender.Focused == true do sender.Select 0 spnCnt
		)
		if arg.keyValue == 27 do ( if sender.Value != 0 and sender.Focused == true do (sender.Value = 0 ; sender.Select 0 1) )
		if arg.keyValue == 17 do sender.Increment = 1
	)
	fn IncrementDnToOne sender arg =
	(
		local spnCnt = (sender.Value as string).count
		if arg.keyValue == 13 do
		(
			if sender.Value > sender.Maximum then sender.Value = sender.Maximum
			else if sender.Value < sender.Minimum do sender.Value = sender.Minimum
			if sender.Focused == true do sender.Select 0 spnCnt
		)
		if arg.keyValue == 27 do ( if sender.Value != 1 and sender.Focused == true do (sender.Value = 1 ; sender.Select 0 1) )
		if arg.keyValue == 17 do sender.Increment = 1
	)
	fn scBtn1Click =
	(
		if scRoll.height != 43 and scBtn1.BackColor != scBC1 then	( scRoll.height = 43 ; scBtn1.BackColor = scBC1	)
		else
		(
			if (scBtnTarg.ForeColor == scFC and scBtnSour.ForeColor == scFC) then (scRoll.height = 363 ; scBtn1.BackColor = scFC)
			else (scRoll.height = 103 ; scBtn1.BackColor = scFC)
		)
	)
	fn calculateRadius =
	(
		if (isValidNode S_Cam and dist1 != undefined and dist2 != undefined) then
		(
			if dist2 < dist1 then ( S_Cam.pos.x = dist1*2 ; S_Cam.pos.z = S_Cam_Targ.pos.z ; scSpnRad.Value = S_Cam.TargetDistance )
			else
			(
				if S_Cam.pos.z == S_Cam_Targ.pos.z then (scSpnRad.Value = S_Cam.TargetDistance)
				else (scSpnRad.Value = sqrt( (S_Cam.TargetDistance)^2 - (S_Cam.pos.z - S_Cam_Targ.pos.z)^2) )
			)
		) else scSpnRad.Value = 1
	)
	fn calculateElevation =
	(
		local st, et, mixHeight, maxHeight, hArr = #(1,2)
		st = S_Cam[3][1].track.keys[1].time ; et = S_Cam[3][1].track.keys[S_Cam[3][1].track.keys.count].time
		minHeight = at time st S_Cam.pos.z ; maxHeight = at time et S_Cam.pos.z ; hArr = #(abs minHeight, abs maxHeight)
		amax hArr
	)
	fn calculateStartEndTime =
	(
		local stf = S_Cam[3][1].track.keys[1].time.frame, etf = S_Cam[3][1].track.keys[S_Cam[3][1].track.keys.count].time.frame
		Tstart = animationRange.start.frame ; Tend = animationRange.end.frame
		if Tstart != stf then Tstart = stf else if Tend != etf do Tend = etf ; r = 360/Tend
 	)
	fn removeSpiroCamAnim =
	(
		if isValidNode S_Cam and S_Cam.isAnimated == true do
		(
			sliderTime = Tstart ; if S_Cam.isSelected != true do (select S_Cam) ; maxOps.deleteSelectedAnimation()
			setTransformLockFlags S_Cam #none ; setTransformLockFlags S_Cam.target #none ; S_Cam.pos = defCamPos
		)
	)
	fn scBtnTargClick obj =
	(
		scBtnTarg.BackColor = scBC2 ; scBtnTarg.ForeColor = scBC1
		if scBtnTarg.BackColor == scBC2 do (obj = pickObject filter:filterObj obj)
		if isValidNode obj then
		(
			local TargObjSiz = #(), TargPosArr = #() ; clearSelection() ; scSpnRad.Enabled == false
			if isValidNode S_Cam and substring S_Cam.name 1 3 == "SC_" do
			(
				scBtnSour.Text = "Target > Camera" ; S_Cam = undefined ; S_Cam_Targ = undefined ; S_Cam_Helper = undefined
				scBtnSour.BackColor = scBC1 ; scBtnSour.ForeColor = scBC2 ; create_SC_Callbacks()
			)
			Targ_Obj = obj ; scBtnTarg.Text = Targ_Obj.name
			local bbTO = (nodeLocalBoundingBox Targ_Obj), tempsize = (bbTO[1] - bbTO[2])
			TargObjSiz = [(abs tempsize.x), (abs tempsize.y),(abs tempsize.z)]
			TargPosArr = #(TargObjSiz.x, TargObjSiz.y, TargObjSiz.z)
			dist1 = amax targPosArr ; calculateRadius()
			scBtnTarg.BackColor = scBC1 ; scBtnTarg.ForeColor = scFC
			if (isValidNode S_Cam and isValidNode S_Cam_Targ and isValidNode S_Cam_Helper) do
			(
				S_Cam_Targ.pos = S_Cam_Helper.pos = Targ_Obj.center ; S_Cam_Helper.parent = Targ_Obj
				S_Cam.parent = S_Cam_Helper ; S_Cam_Targ.parent = S_Cam_Helper
			)
		)
		else (scBtnTarg.Text = "Target > Object" ; Targ_Obj = undefined ; scBtnTarg.BackColor = scBC1 ; scBtnTarg.ForeColor = scBC2)
		if (scBtnTarg.ForeColor == scFC and scBtnSour.ForeColor == scFC) then (scRoll.height = 363) else (scRoll.height = 103)
	)
	fn scBtnSourClick cam =
	(
		scBtnSour.BackColor = scBC2 ; scBtnSour.ForeColor = scBC1
		if scBtnSour.BackColor == scBC2 do (cam = pickObject filter:filterCam cam)
		if isValidNode cam then
		(
			local tempArr = #()
			S_Cam = cam ; scBtnSour.Text = S_Cam.name ; select S_Cam ; S_Cam_Targ = S_Cam.Target
			defCamPos = S_Cam.pos ; if (S_Cam.parent != undefined and substring S_Cam.parent.name 1 3 != "SC_") do delete S_Cam.parent
			S_Cam_Helper = Point isSelected:off cross:off Box:on axistripod:on drawontop:on size:20 constantscreensize:on wirecolor:(color 87 120 204)
			S_Cam_Helper.name = uniquename "Cam_Helper" ; tempArr = #(S_Cam, S_Cam_Targ, S_Cam_Helper) ; Fill_SC_Layer tempArr
			if (isValidNode Targ_Obj) then
			(
				S_Cam_Helper.pos = Targ_Obj.center ; S_Cam_Helper.parent = Targ_Obj
				S_Cam.parent = S_Cam_Helper ; S_Cam.target.pos = S_Cam_Helper.pos ; S_Cam_Targ.parent = S_Cam_Helper
			)
			else (S_Cam_Helper.pos = S_Cam_Targ.pos)
			dist2 = S_Cam.TargetDistance ; calculateRadius()
			scBtnSour.BackColor = scBC1 ; scBtnSour.ForeColor = scFC
		)
		else
		(
			scBtnSour.Text = "Target > Camera" ; S_Cam = undefined ; S_Cam_Targ = undefined
			try(delete S_Cam_Helper)catch() ; S_Cam_Helper = undefined
			scBtnSour.BackColor = scBC1 ; scBtnSour.ForeColor = scBC2
		)
		if (scBtnTarg.ForeColor == scFC and scBtnSour.ForeColor == scFC) then (scRoll.height = 363 ; changeCamSelection()) else (scRoll.height = 103)
	)
	fn makeSpiroPath Rad Elev Turn =
	(
		local SC_xpos, SC_ypos, SC_zpos, cw, hlxRad
		if Tstart < 0 do maxOps.autoKeyDefaultKeyOn = false
		cw = case of (
			(scCB2.Checked == true): ( 1 )
			(scCB3.Checked == true): ( -1 )
		)
		maxops.setDefaultTangentType #smooth #smooth
		animate on
		(
			for i = Tstart to Tend by scSpnStep.value do at time i
			(
				case scComBox.SelectedIndex of (
					0:	(
						SC_xpos = S_Cam_Helper.pos.x + Rad*cos(i*r*Turn)
						SC_ypos = S_Cam_Helper.pos.y + cw*Rad*sin(i*r*Turn)
					)
					1:	(
							SC_xpos = S_Cam_Helper.pos.x + (((Rad/3) * cos(i*r*Turn)) - (Rad * cos(2*(i*r*Turn))))
							SC_ypos = S_Cam_Helper.pos.y + cw*(((Rad/3) * sin(i*r*Turn)) - (Rad * sin(2*(i*r*Turn))))
					)
					2:	(
							SC_xpos = S_Cam_Helper.pos.x + (((Rad/2) * sin(i*r*Turn)) + ((Rad/2) * sin(-3*(i*r*Turn))))
							SC_ypos = S_Cam_Helper.pos.y + cw*(((Rad/2) * cos(i*r*Turn)) + ((Rad/2) * cos(-3*(i*r*Turn))))
					)
					3:	(
							SC_xpos = S_Cam_Helper.pos.x + (((Rad*0.85) * cos(i*r*Turn)) + ((Rad/8) * cos(5*(i*r*Turn))))
							SC_ypos = S_Cam_Helper.pos.y + (cw)*(((Rad*0.85) * sin(i*r*Turn)) + ((Rad/8) * sin(5*(i*r*Turn))))
					)
					4:	(
							SC_xpos = S_Cam_Helper.pos.x + (((Rad/3) * sin(i*r*Turn)) + ((Rad/1.5) * sin(-2*(i*r*Turn))))
							SC_ypos = S_Cam_Helper.pos.y + cw*(((Rad/3) * cos(i*r*Turn)) + ((Rad/1.5) * cos(-2*(i*r*Turn))))
					)
					5:	(
							SC_xpos = S_Cam_Helper.pos.x + (((Rad*0.9) * cos(i*r*Turn)) + ((Rad/10) * cos(-3* (i*r*Turn))))
							SC_ypos = S_Cam_Helper.pos.y + cw*(((Rad*0.9) * sin(i*r*Turn)) + ((Rad/10) * sin(-3* (i*r*Turn))))
					)
					6:	(
							SC_xpos = S_Cam_Helper.pos.x + (((Rad*0.75) * cos(i*r*Turn)) + ((Rad/4) * cos(-3*(i*r*Turn))))
							SC_ypos = S_Cam_Helper.pos.y + cw*(((Rad*0.75) * sin(i*r*Turn)) + ((Rad/4) * sin(-3*(i*r*Turn))))
					)
					7:	(
							SC_xpos = S_Cam_Helper.pos.x + (((Rad/3) * cos(i*r*Turn)) - (Rad * cos(3*(i*r*Turn))))
							SC_ypos = S_Cam_Helper.pos.y + cw*(((Rad/3) * sin(i*r*Turn)) - (Rad * sin(3*(i*r*Turn))))
					)
					8:	(
							SC_xpos = S_Cam_Helper.pos.x + (((Rad/3) * sin(i*r*Turn)) - (Rad * sin(-3*(i*r*Turn))))
							SC_ypos = S_Cam_Helper.pos.y + cw*(((Rad/3) * cos(i*r*Turn)) - (Rad * cos(-3*(i*r*Turn))))
					)
					9:	(
							hlxRad = (Rad/2) + ((i/(Tend/2))*(Rad/2))
							if hlxRad >= Rad do hlxRad -= (((i-(Tend/2))/(Tend/2))*Rad)
							SC_xpos = S_Cam_Helper.pos.x + (hlxRad*cos(i*r*Turn))
							SC_ypos = S_Cam_Helper.pos.y + cw*(hlxRad*sin(i*r*Turn))
					)
				)
				case scCB1.Checked of (
					(false): ( SC_zpos = Elev )
					(true): ( SC_zpos = (i*( abs (Elev-S_Cam_Helper.pos.z)/Tend))+S_Cam_Helper.pos.z )
				)
				S_Cam.pos = [SC_xpos, SC_ypos, SC_zpos]
			)
		) ; maxOps.autoKeyDefaultKeyOn = true
	)
	fn refreshAnimation =
	(
		if (not isValidNode S_Cam and not isValidNode S_Cam_Helper) then #abort else
		(
			if S_Cam.isAnimated == true do
			(
				local spnRAD = scSpnRad.Value, spnELEV = scSpnEle.Value, spnTURN = scSpnTurn.Value
				if S_Cam.isSelected != true do (select S_Cam) ; maxOps.deleteSelectedAnimation()
				makeSpiroPath spnRAD spnELEV spnTURN
			)
		)
	)
	fn scSpnRadVC sender rarg =
	(
		if (not isValidNode S_Cam and not isValidNode S_Cam_Helper) then #abort else
		(
			if (S_Cam != undefined and S_Cam.isAnimated == true) do
			(
				scSpnEle.Value = calculateElevation()
				local spnRAD = sender.Value, spnELEV = scSpnEle.Value, spnTURN = scSpnTurn.Value
				if S_Cam.isSelected != true do (select S_Cam) ; maxOps.deleteSelectedAnimation()
				makeSpiroPath spnRAD spnELEV spnTURN
			)
		)
	)
	fn scSpnEleVC sender earg =
	(
		if (not isValidNode S_Cam and not isValidNode S_Cam_Helper) then #abort else
		(
			if S_Cam.isAnimated == true then 
			( 
				local spnRAD = scSpnRad.Value, spnELEV = sender.Value, spnTURN = scSpnTurn.Value
				if S_Cam.isSelected != true do (select S_Cam) ; maxOps.deleteSelectedAnimation()
				makeSpiroPath spnRAD spnELEV spnTURN 
			) else S_Cam.pos.z = sender.Value
			defCamPos = S_Cam.pos
		)
	)
	fn scSpnTargEleVC sender tearg = ( if (not isValidNode S_Cam and not isValidNode S_Cam_Targ) then #abort else S_Cam_Targ.pos.z = sender.Value )
	fn scSpnHelpEleVC sender hearg =
	(
		if (not isValidNode S_Cam and not isValidNode S_Cam_Helper) then #abort else
		(
			S_Cam_Helper.pos.z = sender.Value ; scSpnTargEle.Value = S_Cam_Targ.pos.z
			if S_Cam.isAnimated == true then
			(
				local et = S_Cam[3][1].track.keys[S_Cam[3][1].track.keys.count].time
				scSpnEle.Value = at time et (S_Cam.pos.z)
			) else scSpnEle.Value = S_Cam.pos.z
		)
	)
	fn scBtnRTHClick =
	(
		if (not isValidNode S_Cam_Targ and not isValidNode S_Cam_Helper) then #abort else
		(
			S_Cam_Helper.pos = Targ_Obj.center ; S_Cam_Targ.pos = S_Cam_Helper.center
			if S_Cam.isAnimated == true do
			(scSpnHelpEle.Value = S_Cam_Helper.pos.z ; scSpnTargEle.Value = S_Cam_Targ.pos.z ; scSpnEle.Value = calculateElevation())
			S_Cam_Targ.pos = S_Cam_Helper.center
		)
	)
	fn scComBoxSIC =
	(
		if scComBox.SelectedIndex != 9 then ( scCB1.Checked = false ; scSpnTurn.Value = 1 )
		else (	scCB1.Checked = true ; scSpnTurn.Value = 2	) ; refreshAnimation()
	)
	fn scCB1Click = (refreshAnimation())
	fn scCB2Click =
	(
		(refreshAnimation())
		if scCB2.Checked == true then ( scCB3.Checked = false)
		else if (scCB2.Checked == false and scCB3.Checked == false) do scCB2.Checked = true
	)
	fn scCB3Click =
	(
		if scCB3.Checked == true then ( scCB2.Checked = false)
		else if (scCB3.Checked == false and scCB2.Checked == false) do scCB3.Checked = true
		(refreshAnimation())
	)
	fn scSpnTurnVC sender targ =
	(
		if (not isValidNode S_Cam and not isValidNode S_Cam_Helper) then #abort else
		(
			if S_Cam.isAnimated == true do
			(
				local spnRAD = scSpnRad.Value, spnELEV = scSpnEle.Value, spnTURN = sender.Value
				if S_Cam.isSelected != true do (select S_Cam) ; maxOps.deleteSelectedAnimation()
				makeSpiroPath spnRAD spnELEV spnTURN
			)
		)
	)
	fn scSpnStepVC =
	(
		if (not isValidNode S_Cam and not isValidNode S_Cam_Helper) then #abort else
		(
			if S_Cam.isAnimated == true do
			(
				local spnRAD = scSpnRad.Value, spnELEV = scSpnEle.Value, spnTURN = scSpnTurn.Value
				if S_Cam.isSelected != true do (select S_Cam) ; maxOps.deleteSelectedAnimation()
				Tstart = animationRange.start.frame ; Tend = animationRange.end.frame ; r = 360/Tend
				makeSpiroPath spnRAD spnELEV spnTURN ; calculateStartEndTime()
			)
		)
	)
	fn scBtnRevAClick =
	(
		local animRange = interval animationRange.start.frame animationRange.end.frame
		local curSelObjs = selection as array
		if selection.count != 0 and keyboard.controlPressed then
		(
			if curSelObjs[3][1].isAnimated == true do (reverseTime curSelObjs[3].controller animRange #incLeft #incRight)
		) else ( if isValidNode S_Cam and S_Cam[3][1].isAnimated == true do (reverseTime S_Cam[3].controller animRange #incLeft #incRight) )
	)
	fn scBtnRemAClick =
	(
		if selection.count != 0 and keyboard.controlPressed then
		(
			local curSelObjs = selection as array
			if slidertime != Tstart do slidertime = Tstart ; maxOps.deleteSelectedAnimation()
			for o in curSelObjs do setTransformLockFlags o #none
		)
		else
		(
			removeSpiroCamAnim()
			if substring S_Cam.name 1 3 == "SC_" do
			(
				S_Cam.name = newUniqueName false S_Cam "" "SC_" ; S_Cam_Helper.name = newUniqueName false S_Cam_Helper "Cam_" "SC_"
				S_Cam.wirecolor = S_Cam_Helper.wirecolor = [87,120,204]
				scBtnSour.Text = S_Cam.name ; if S_Cam.isAnimated != true do (scSpnRad.Enabled = false ; create_SC_Callbacks())
			)
		)
	)
	fn scBtnATCClick =
	(
		local scriptTC = ((getDir #Scripts) + "\\bgaTools\\3inCamPack\\bga_TrajectoryColor.ms")
		if not doesFileExist scriptTC then #abort else filein scriptTC
	)
	fn scBtnCSCClick =
	(
		if (not isValidNode S_Cam and not isValidNode Targ_Obj) then #abort else
		(
			if S_Cam.isAnimated == true do ( removeSpiroCamAnim() ) ; defCamPos = S_Cam.pos ; remove_SC_Callback1()
			local spnRAD = scSpnRad.Value, spnELEV = S_Cam.pos.z, spnTURN = scSpnTurn.Value
			Tstart = animationRange.start.frame ; Tend = animationRange.end.frame ; r = 360/Tend
			makeSpiroPath spnRAD spnELEV spnTURN ; calculateStartEndTime()
			setTransformLockFlags S_Cam #all ; setTransformLockFlags S_Cam.Target #all
			if substring scBtnSour.Text 1 3 != "SC_" do
			(
				S_Cam.name = newUniqueName true S_Cam "SC_" "" ; S_Cam_Helper.name = newUniqueName false S_Cam_Helper "SC_" "Cam_"
				S_Cam.wirecolor = S_Cam_Helper.wirecolor = [255,165,0] ; scBtnSour.Text = S_Cam.name ; scSpnRad.Enabled = true ; S_Cam.showTrajectory = on
			)
		)
	)
/*///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   OPEN / CLOSE ROLL ACTION   //////////*/
	on scRoll open do
	(
/*//////////   dnOBJECT's   //////////*/
		scTTb1 = dotNetObject "ToolTip" ; scLbl1 = dotNetObject "Label" ; scBtn1 = dotNetObject "Button" ; scLbl2 = dotNetObject "Label"
		scLblTitl1 = dotNetObject "Label" ; scBtnTarg = dotNetObject "Button" ; scBtnSour = dotNetObject "Button"
		scLblTitl2 = dotNetObject "Label" ; scLblRad = dotNetObject "Label" ; scSpnRad = dotNetObject "NumericUpDown"
		scLblEle = dotNetObject "Label" ; scSpnEle = dotNetObject "NumericUpDown" ; scLblTargEle = dotNetObject "Label"
		scSpnTargEle = dotNetObject "NumericUpDown" ; scLblHelpEle = dotNetObject "Label" ; scSpnHelpEle = dotNetObject "NumericUpDown"
		scBtnRTH = dotNetObject "Button" ; scLblTitl3 = dotNetObject "Label" ; scComBox = dotNetObject "ComboBox"
		scCB1 = dotNetObject "CheckBox" ; scCB2 = dotNetObject "CheckBox" ; scCB3 = dotNetObject "CheckBox" ; scLblTurn = dotNetObject "Label"
		scSpnTurn = dotNetObject "NumericUpDown" ; scLblStep = dotNetObject "Label" ; scSpnStep = dotNetObject "NumericUpDown"
		scBtnRevA = dotNetObject "Button" ; scBtnRemA = dotNetObject "Button" ; scBtnCSC = dotNetObject "Button" ; scBtnATC = dotNetObject "Button"
/*//////////   scTTb1   //////////*/
		scTTb1.SetToolTip scBtn1 "\t\t\t\t\n\r\n\t\r\n" ; scTTb1.OwnerDraw = true
		scTTb1.InitialDelay = 2000 ; scTTb1.AutoPopDelay = 15000 ; scTTb1.UseFading = true
/*//////////   scPnl   //////////*/
		scPnl.BackColor = scBC2 ; scPnl.Width = 164 ; scPnl.Height = 363
/*//////////   scLbl1, scLbl2   //////////*/
		scLbl1.BackColor = scLbl2.BackColor = scBC1 ; scLbl1.ForeColor = scLbl2.ForeColor = scBC2 ; scLbl1.Font = scLbl2.Font = scFont3
		scLbl1.Width = scLbl2.Width = 160 ; scLbl1.Height = scLbl2.Height = 10 ; scLbl1.Text = scLbl2.Text = "|||||||||||||||||||||||||||||||||||"
		scLbl1.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 2) (scPnl.pos.y + 2) ; scLbl1.Padding = scLbl2.Padding = scPadd1
		scLbl2.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 2) (scPnl.pos.y + 32) ; scLbl1.TextAlign = scLbl2.TextAlign = scAlign2
/*//////////   scBtn1   //////////*/
		scBtn1.Font = scFont2 ; scBtn1.Text = "SPIROFLY*CAM" ; scBtn1.BackColor = scFC ; scBtn1.ForeColor = scBC2 ; scBtn1.TextAlign = scAlign1
		scBtn1.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 1) (scPnl.pos.y + 12) ; scBtn1.FlatStyle = scFS2
		scBtn1.Width = 162 ; scBtn1.Height = 20 ; scBtn1.Padding = scPadd2 ; scBtn1.Cursor = scCurs
/*//////////   scLblTitl1, scLblTitl2, scLblTitl3  //////////*/
		scLblTitl1.BackColor = scLblTitl2.BackColor = scLblTitl3.BackColor = scFC
		scLblTitl1.ForeColor = scLblTitl2.ForeColor = scLblTitl3.ForeColor = scBC2
		scLblTitl1.Font = scLblTitl2.Font = scLblTitl3.Font = scFont1
		scLblTitl1.Width = scLblTitl2.Width = scLblTitl3.Width = 160 ; scLblTitl1.Height = scLblTitl2.Height = scLblTitl3.Height = 12
		scLblTitl1.Text = "Pick Target and Source" ; scLblTitl2.Text = "SpiroflyCam Setup" ; scLblTitl3.Text = "SpiroflyCam Trajectory"
		scLblTitl1.TextAlign = scLblTitl2.TextAlign = scLblTitl3.TextAlign = scAlign2
		scLblTitl1.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 2) (scPnl.pos.y + 44)
		scLblTitl2.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 2) (scPnl.pos.y + 103)
		scLblTitl3.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 2) (scPnl.pos.y + 198)
/*//////////   scBtnTarg, scBtnSour  //////////*/
		scBtnTarg.BackColor = scBtnSour.BackColor = scBC1 ; scBtnTarg.ForeColor = scBtnSour.ForeColor = scBC2 ; scBtnTarg.Font = scBtnSour.Font = scFont1
		scBtnTarg.Width = scBtnSour.Width = 160 ; scBtnTarg.Height = scBtnSour.Height = 22 ; scBtnTarg.Text = "Target > Object" ; scBtnSour.Text = "Source > Camera"
		scBtnTarg.FlatStyle = scBtnSour.FlatStyle = scFS2 ; scBtnTarg.Cursor = scBtnSour.Cursor = scCurs ; scBtnTarg.TextAlign = scBtnSour.TextAlign = scAlign1
		scBtnTarg.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 2) (scPnl.pos.y + 57)
		scBtnSour.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 2) (scPnl.pos.y + 80)
/*//////////   scLblRad, scLblEle, scLblTargEle , scLblHelpEle, scLblTurn, scLblStep  //////////*/
		scLblRad.BackColor = scLblEle.BackColor = scLblTargEle.BackColor = scLblHelpEle.BackColor = scLblTurn.BackColor = scLblStep.BackColor = scBC1
		scLblRad.ForeColor = scLblEle.ForeColor = scLblTargEle.ForeColor = scLblHelpEle.ForeColor = scLblTurn.ForeColor = scLblStep.ForeColor = scFC
		scLblRad.Font = scLblEle.Font = scLblTargEle.Font = scLblHelpEle.Font = scLblTurn.Font = scLblStep.Font = scFont1
		scLblRad.Text = " SC Radius:" ; scLblEle.Text = " SC Elevetion:" ; scLblTargEle.Text = " SCT Elevetion:"
		scLblHelpEle.Text = " SCH Elevetion:" ; scLblTurn.Text = " Turns Number:" ; scLblStep.Text = " Frame Step:"
		scLblRad.Width = scLblEle.Width = scLblTargEle.Width = scLblHelpEle.Width = scLblTurn.Width = scLblStep.Width = 100
		scLblRad.Height = scLblEle.Height = scLblTargEle.Height = scLblHelpEle.Height = scLblTurn.Height = scLblStep.Height = 15
		scLblRad.TextAlign = scLblEle.TextAlign = scLblTargEle.TextAlign = scLblHelpEle.TextAlign = scLblTurn.TextAlign = scLblStep.TextAlign = scAlign3
		scLblRad.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 2) (scPnl.pos.y + 116)
		scLblEle.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 2) (scPnl.pos.y + 132)
		scLblTargEle.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 2) (scPnl.pos.y + 148)
		scLblHelpEle.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 2) (scPnl.pos.y + 164)
		scLblTurn.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 2) (scPnl.pos.y + 258)	
		scLblStep.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 2) (scPnl.pos.y + 274)
/*//////////   scSpnRad, scSpnEle, scSpnTargEle, scSpnHelpEle, scSpnTurn, scSpnStep   //////////*/
		scSpnRad.Font = scSpnEle.Font = scSpnTargEle.Font = scSpnHelpEle.Font = scSpnTurn.Font = scSpnStep.Font = scFont1
		scSpnRad.BackColor = scSpnEle.BackColor = scSpnTargEle.BackColor = scSpnHelpEle.BackColor = scSpnTurn.BackColor = scSpnStep.BackColor = scBC1
		scSpnRad.ForeColor = scSpnEle.ForeColor = scSpnTargEle.ForeColor = scSpnHelpEle.ForeColor = scSpnTurn.ForeColor = scSpnStep.ForeColor = scFC
		scSpnRad.TextAlign = scSpnEle.TextAlign = scSpnTargEle.TextAlign = scSpnHelpEle.TextAlign = scSpnTurn.TextAlign = scSpnStep.TextAlign = scHorizA
		scSpnRad.Width = scSpnEle.Width = scSpnTargEle.Width = scSpnHelpEle.Width = scSpnTurn.Width = scSpnStep.Width = 59
		scSpnRad.Height = scSpnEle.Height = scSpnTargEle.Height = scSpnHelpEle.Height = scSpnTurn.Height = scSpnStep.Height = 15
		scSpnRad.BorderStyle = scSpnEle.BorderStyle = scSpnTargEle.BorderStyle = scSpnHelpEle.BorderStyle = scSpnTurn.BorderStyle = scSpnStep.BorderStyle = scBS1
		scSpnRad.Increment = scSpnEle.Increment = scSpnTargEle.Increment = scSpnHelpEle.Increment = scSpnTurn.Increment = scSpnStep.Increment = 1
		scSpnRad.DecimalPlaces = scSpnEle.DecimalPlaces = scSpnTargEle.DecimalPlaces = scSpnHelpEle.DecimalPlaces = 2 ; scSpnTurn.DecimalPlaces = scSpnStep.DecimalPlaces = 0
		scSpnRad.Minimum = 0 ; scSpnEle.Minimum = scSpnTargEle.Minimum = scSpnHelpEle.Minimum = -100000 ; scSpnTurn.Minimum = scSpnStep.Minimum = 1
		scSpnRad.Maximum = scSpnEle.Maximum = scSpnTargEle.Maximum = scSpnHelpEle.Maximum = 100000 ; scSpnTurn.Maximum = 100 ; scSpnStep.Maximum = 1000
		scSpnRad.Value = 1 ; scSpnEle.Value = scSpnTargEle.Value = scSpnHelpEle.Value = 0 ; scSpnTurn.Value = scSpnStep.Value = 1
		scSpnRad.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 103) (scPnl.pos.y + 116) ; scSpnRad.Enabled = false
		scSpnEle.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 103) (scPnl.pos.y + 132)
		scSpnTargEle.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 103) (scPnl.pos.y + 148)
		scSpnHelpEle.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 103) (scPnl.pos.y + 164)
		scSpnTurn.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 103) (scPnl.pos.y + 258)
		scSpnStep.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 103) (scPnl.pos.y + 274)
/*//////////   scBtnRTH, scBtnRevA, scBtnRemA, scBtnCSC, scBtnATC    //////////*/
		scBtnRTH.Text = "Reset SCT && SCH" ; scBtnRevA.Text = "Reverse SC Animation" ; scBtnRemA.Text = "Remove SC Animation"
		scBtnCSC.Text = "CREATE SPIROFLYCAM" ; scBtnATC.Text = "Adjust Trajectory Color"
		scBtnRTH.Font = scBtnRevA.Font = scBtnRemA.Font = scBtnCSC.Font = scBtnATC.Font = scFont1
		scBtnRTH.BackColor = scBtnRevA.BackColor = scBtnRemA.BackColor = scBtnATC.BackColor = scBC1 ; scBtnCSC.BackColor = scFC
		scBtnRTH.ForeColor = scBtnRevA.ForeColor = scBtnRemA.ForeColor = scBtnATC.ForeColor = scFC ; scBtnCSC.ForeColor = scBC2
		scBtnRTH.FlatStyle = scBtnRevA.FlatStyle = scBtnRemA.FlatStyle = scBtnCSC.FlatStyle = scBtnATC.FlatStyle = scFS1
		scBtnRTH.Width = scBtnRevA.Width = scBtnRemA.Width = scBtnCSC.Width = scBtnATC.Width = 162
		scBtnRTH.Height = scBtnRevA.Height = scBtnRemA.Height = scBtnCSC.Height = scBtnATC.Height = 18
		scBtnRTH.Cursor = scBtnRevA.Cursor = scBtnRemA.Cursor = scBtnCSC.Cursor = scBtnATC.Cursor = scCurs
		scBtnRTH.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 1) (scPnl.pos.y + 179)
		scBtnRevA.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 1) (scPnl.pos.y + 290)
		scBtnRemA.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 1) (scPnl.pos.y + 308)
		scBtnATC.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 1) (scPnl.pos.y + 326)
		scBtnCSC.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 1) (scPnl.pos.y + 344)
/*//////////   scComBox    //////////*/
		scComBox.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 2) (scPnl.pos.y + 211) ; scComBox.Width = 160 ; scComBox.Height = 21
		scComBox.Backcolor = scBC1 ; scComBox.Forecolor = scFC ; scComBox.FlatStyle = scFS2 ; scComBox.DropDownStyle = scCBS
		AddRangeFn scComBox PathTypeArr ; scComBox.SelectedIndex = 0 ;  scComBox.Font = scFont1
/*//////////   scCB1, scCB2, scCB3   //////////*/
		scCB1.Font = scCB2.Font = scCB3.Font = scFont1 ; scCB1.BackColor = scCB2.BackColor = scCB3.BackColor = scBC1 ; scCB1.ForeColor = scCB2.ForeColor = scCB3.ForeColor = scFC
		scCB1.Text = " Elevation Mode" ; scCB2.Text = "  CWW" ; scCB3.Text = "  CW"
		scCB1.FlatStyle = scCB2.FlatStyle = scCB3.FlatStyle = scFS3 ; scCB1.TextAlign = scCB2.TextAlign = scCB3.TextAlign = scAlign3
		scCB1.Width = 160 ; scCB2.Width = scCB3.Width = 80 ; scCB1.Height = scCB2.Height = scCB3.Height = 12
		scCB1.Enabled = scCB2.Enabled = scCB3.Enabled = true ; scCB1.Checked = scCB3.Checked = false ; scCB2.Checked = true
		scCB1.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 2) (scPnl.pos.y + 232)
		scCB2.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 2) (scPnl.pos.y + 245)
		scCB3.Location = dotNetObject "System.Drawing.Point" (scPnl.pos.x + 82) (scPnl.pos.y + 245)
/*//////////   ASSIGN THE EVENTS   //////////*/
		dotnet.addEventHandler scTTb1 "Draw" scTTb1Draw
		dotNet.AddEventHandler scBtn1 "Click" scBtn1Click
		dotNet.AddEventHandler scBtnTarg "Click" scBtnTargClick
		dotNet.AddEventHandler scBtnSour "Click" scBtnSourClick
		dotnet.AddEventHandler scSpnRad "GotFocus" scSpnGF
 		dotnet.AddEventHandler scSpnRad "LostFocus" scSpnLF
		dotNet.AddEventHandler scSpnRad "ValueChanged" scSpnRadVC
		dotnet.AddEventHandler scSpnRad "KeyDown" IncrementUpToTen
		dotnet.AddEventHandler scSpnRad "KeyUp" IncrementDnToZero
		dotnet.AddEventHandler scSpnEle "GotFocus" scSpnGF
 		dotnet.AddEventHandler scSpnEle "LostFocus" scSpnLF
		dotNet.AddEventHandler scSpnEle "ValueChanged" scSpnEleVC
		dotnet.AddEventHandler scSpnEle "KeyDown" IncrementUpToTen
		dotnet.AddEventHandler scSpnEle "KeyUp" IncrementDnToZero
		dotnet.AddEventHandler scSpnTargEle "GotFocus" scSpnTargEleGF
 		dotnet.AddEventHandler scSpnTargEle "LostFocus" scSpnLF
		dotNet.AddEventHandler scSpnTargEle "ValueChanged" scSpnTargEleVC
		dotnet.AddEventHandler scSpnTargEle "KeyDown" IncrementUpToTen
		dotnet.AddEventHandler scSpnTargEle "KeyUp" IncrementDnToZero
		dotnet.AddEventHandler scSpnHelpEle "GotFocus" scSpnHelpEleGF
 		dotnet.AddEventHandler scSpnHelpEle "LostFocus" scSpnLF
		dotNet.AddEventHandler scSpnHelpEle "ValueChanged" scSpnHelpEleVC
		dotnet.AddEventHandler scSpnHelpEle "KeyDown" IncrementUpToTen
		dotnet.AddEventHandler scSpnHelpEle "KeyUp" IncrementDnToZero
		dotNet.AddEventHandler scBtnRTH "Click" scBtnRTHClick
		dotNet.AddEventHandler scComBox "SelectedIndexChanged" scComBoxSIC
		dotNet.AddEventHandler scCB1 "Click" scCB1Click
		dotNet.AddEventHandler scCB2 "Click" scCB2Click
		dotNet.AddEventHandler scCB3 "Click" scCB3Click
		dotnet.AddEventHandler scSpnTurn "GotFocus" scSpnGF
 		dotnet.AddEventHandler scSpnTurn "LostFocus" scSpnLF
		dotNet.AddEventHandler scSpnTurn "ValueChanged" scSpnTurnVC
		dotnet.AddEventHandler scSpnTurn "KeyDown" IncrementUpToTen
		dotnet.AddEventHandler scSpnTurn "KeyUp" IncrementDnToOne
		dotnet.AddEventHandler scSpnStep "GotFocus" scSpnGF
 		dotnet.AddEventHandler scSpnStep "LostFocus" scSpnLF
		dotNet.AddEventHandler scSpnStep "ValueChanged" scSpnStepVC
		dotnet.AddEventHandler scSpnStep "KeyDown" IncrementUpToTen
		dotnet.AddEventHandler scSpnStep "KeyUp" IncrementDnToOne
		dotNet.AddEventHandler scBtnRevA "Click" scBtnRevAClick
		dotNet.AddEventHandler scBtnRemA "Click" scBtnRemAClick
		dotNet.AddEventHandler scBtnATC "Click" scBtnATCClick
		dotNet.AddEventHandler scBtnCSC "Click" scBtnCSCClick
/*//////////   ADD dotNET OBJECTS TO PANEL  //////////*/
		scPnl.Controls.Add(scLbl1) ; scPnl.Controls.Add(scBtn1) ; scPnl.Controls.Add(scLbl2) ; scPnl.Controls.Add(scLblTitl1)
		scPnl.Controls.Add(scBtnTarg) ; scPnl.Controls.Add(scBtnSour) ; scPnl.Controls.Add(scLblTitl2) ; scPnl.Controls.Add(scLblRad)
		scPnl.Controls.Add(scSpnRad) ; scPnl.Controls.Add(scLblEle) ; scPnl.Controls.Add(scSpnEle) ; scPnl.Controls.Add(scLblTargEle)
		scPnl.Controls.Add(scSpnTargEle) ; scPnl.Controls.Add(scLblHelpEle) ; scPnl.Controls.Add(scSpnHelpEle)
		scPnl.Controls.Add(scBtnRTH) ; scPnl.Controls.Add(scLblTitl3) ; scPnl.Controls.Add(scComBox) ; scPnl.Controls.Add(scCB1)
		scPnl.Controls.Add(scCB2) ; scPnl.Controls.Add(scCB3) ; scPnl.Controls.Add(scLblTurn) ; scPnl.Controls.Add(scSpnTurn)
		scPnl.Controls.Add(scLblStep) ; scPnl.Controls.Add(scSpnStep) ; scPnl.Controls.Add(scBtnRevA) ; scPnl.Controls.Add(scBtnRemA)
		scPnl.Controls.Add(scBtnCSC) ; scPnl.Controls.Add(scBtnATC)
/*//////////   "ON ROLLOUT OPEN" FUNCTIONS   //////////*/
		create_SC_Callbacks()
)
	on scRoll close do ( remove_SC_Callback1() ; remove_SC_Callback2() ; scGC.collect() ; gc light:true )
)
createDialog scRoll 164 103 10 110 style:#(#style_titlebar, #style_sysmenu, #style_toolwindow)
)