(
global roll_3INCAM
if roll_3INCAM != undefined do try(destroyDialog roll_3INCAM)catch()
rollout roll_3INCAM " 3 in Cam Pack "
(
	dotNetControl dnPnl3inCam "Panel" pos:[0,0]
/*///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   LOCALS   //////////*/
	local dnICOToolTip, topTape1, bottomTape1, topTape2, bottomTape2, lblCAM, lblJCam, lblCCam, lblSCam, lblJCQ, lblCCQ, lblSCQ

	local BClr_M1 = (dotNetClass "System.Drawing.Color").FromArgb 100 100 100
	local BClr_M2 = (dotNetClass "System.Drawing.Color").FromArgb 60 60 60
	local BClr_M3 = (dotNetClass "System.Drawing.Color").FromArgb 40 40 40
	local BClr_M4 = (dotNetClass "System.Drawing.Color").FromArgb 20 20 20
	local BClr_L1 = (dotNetClass "System.Drawing.Color").FromArgb 140 140 140
	local BClr_L2 = (dotNetClass "System.Drawing.Color").FromArgb 80 80 80
	local FClr = (dotNetClass "System.Drawing.Color").FromArgb 200 200 200
	local FClr1 = (dotNetClass "System.Drawing.SystemColors").MenuHighlight
	local Font1 = dotNetObject "System.Drawing.Font" "Verdana" 7 ((dotNetClass "System.Drawing.FontStyle").bold)
	local Font2 = dotNetObject "System.Drawing.Font" "Wingdings" 9.5 ((dotNetClass "System.Drawing.FontStyle").regular)
	local Font3 = dotNetObject "System.Drawing.Font" "Webdings" 75 ((dotNetClass "System.Drawing.FontStyle").regular)
	local Font4 = dotNetObject "System.Drawing.Font" "ISOCPEUR" 35 ((dotNetClass "System.Drawing.FontStyle").bold)
	local Font5 = dotNetObject "System.Drawing.Font" "ISOCPEUR" 25 ((dotNetClass "System.Drawing.FontStyle").bold)
	local Font6 = dotNetObject "System.Drawing.Font" "ISOCPEUR" 16 ((dotNetClass "System.Drawing.FontStyle").bold)
	local Font7 = dotNetObject "System.Drawing.Font" "ISOCTEUR" 11 ((dotNetClass "System.Drawing.FontStyle").bold)
	local Font8 = dotNetObject "System.Drawing.Font" "ISOCPEUR" 12 ((dotNetClass "System.Drawing.FontStyle").bold)
	local CAlign1 = (dotNetClass "System.Drawing.ContentAlignment").TopCenter
	local CAlign2 = (dotNetClass "System.Drawing.ContentAlignment").TopRight
	local CAlign3 = (dotNetClass "System.Drawing.ContentAlignment").MiddleCenter
	local CAlign4 = (dotNetClass "System.Drawing.ContentAlignment").TopLeft
	local FStyle = (dotNetClass "System.Windows.Forms.FlatStyle").Flat
	local HCrs = (dotNetClass "System.Windows.Forms.Cursors").Hand
	local dnTxtRender = dotNetClass "TextRenderer"
	local mainGC = dotNetClass "System.GC"
	local dnTRH = (dotNetClass "System.Drawing.Text.TextRenderingHint").SingleBitPerPixelGridFit
	local GradMode = (dotNetClass "System.Drawing.Drawing2D.LinearGradientMode").Vertical
	local dnFlagsHCVC = dotNet.CombineEnums (dotNetClass "TextFormatFlags").HorizontalCenter (dotNetClass "TextFormatFlags").VerticalCenter
	local dnFlagsLT = dotNet.CombineEnums (dotNetClass "TextFormatFlags").Left (dotNetClass "TextFormatFlags").Top
	local dnFlagsLB = dotNet.CombineEnums (dotNetClass "TextFormatFlags").Left (dotNetClass "TextFormatFlags").Bottom
	local dnFlagsHCT = dotNet.CombineEnums (dotNetClass "TextFormatFlags").HorizontalCenter (dotNetClass "TextFormatFlags").Top
	local dnFlagsHCB = dotNet.CombineEnums (dotNetClass "TextFormatFlags").HorizontalCenter (dotNetClass "TextFormatFlags").Bottom

	local col_M_Arr = #(BClr_M1, BClr_M2, BClr_M3, BClr_M4), col_L_Arr = #(BClr_L1, BClr_L2, BClr_M2, BClr_M3), col_D_Arr = #(BClr_M4, BClr_M3, BClr_M2, BClr_M2)
	local JCamTitle = "JUMPER*CAM", CCamTitle = "CHASER*CAM", SCamTitle = "SPIROFLY*CAM", QTitle = "?"
	local MouseOn = false, MousePress = false, paintICO = off
	local Info_Roll, BnrTxt, CamTxt, RH
/*///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   FUNCTION DEFINITIONS   //////////*/
	fn ToolTipRoll Type =
	(
		local mainRollpos = getDialogPos roll_3INCAM, scrPosX = (300+(mainRollpos.x as integer)), scrPosY = mainRollpos.y as integer
		case Type of
		(
			1: (
				BnrTxt = "JAMPER*CAM INFO" ; RH = 230
				CamTxt = "\r\n JAMPERCAM will help you to replace\r\n all scene cameras (different types)\r\n with the single 'free' camera.\r\n These includes:\r
  Support variety types of cameras >\r\n    (Standard, VRayPhysicalCamera,\r\n    FinalRenderCamera, BrazilCamera)\r\n  Transfer camera animation >\r\n    (position, rotation, fov)\r	
  Manual adjustments >\r\n    (fov, target distance, shutter speed\r\n    aperture [f-stop], film speed [iso])\r\n  Manipulate animation and time\r\n    slider in 'full screen' mode\r
  Different Grid/Info types\r\n  Read/Write camera notes\r\n  And many more features..."
			)
			2: (
				BnrTxt = "CHASER*CAM INFO" ; RH = 163
				CamTxt = "\r\n CHASERCAM introduces the\r\n 'flexibile' camera rig, which travels\r\n from one to other object with delay\r\n motion. After the creation of the\r  
 'CCRig' you get a direct feedback\r\n when you move the time slider. Also\r\n you can add more targets, forses\r\n (to achive desire effect), adjust\r\n distance and time etc.\r 
 Support all type of 'Free' (without\r\n target) non-animated cameras."
			)
			3: (
				BnrTxt = "SPIROFLY*CAM INFO" ; RH = 152
				CamTxt = "\r\n SPIROFLYCAM script is the unique\r\n 'turn table' tool which uses\r\n the simple trigonometric formulas to\r\n create an interesting path around\r\n the targeted object in the scene.\r
 In adition to this you can readjust\r\n and animate some paremeters after\r\n creation, interactively. If the target\r\n object is animated, then the camera\r\n will follow it in a 'special' way."
			)
		)
		if Info_Roll != undefined do try(destroyDialog Info_Roll)catch()
		rollout Info_Roll "" 
		(
			dotNetControl rollBnr "Label" pos:[0,0] width:210 height:15
			dotNetControl rollCInfo "Label" pos:[0,15] width:210 height:(RH-15)
			on Info_Roll open do
			(
				rollBnr.BackColor = rollCInfo.ForeColor = BClr_L1 ; rollBnr.ForeColor = BClr_M3 ; rollCInfo.BackColor = BClr_M3
				rollBnr.TextAlign = CAlign3 ; rollCInfo.TextAlign = CAlign4 ; rollBnr.Font = Font7 ; rollCInfo.Font = Font1
				rollBnr.Text = BnrTxt ; rollCInfo.Text = CamTxt
			)
			on Info_Roll close do (gc light:true)
		)
		createdialog Info_Roll 210 RH (scrPosX) (scrPosY) style: #()
	)
	fn dnLogoPainter Lbl Arr1 Arr2 clr =
	(
		local logoTxt1 = "3", logoICO = "", lblRect = Lbl.ClientRectangle, G_Brush = clr.Graphics
		lblRectW = lblRect.Width ; lblRectH = lblRect.Height ; lblRectX = lblRect.x ; lblRectY = lblRect.y
		rectBG = dotNetObject "System.Drawing.Rectangle" lblRectX lblRectY lblRectW lblRectH
		dnLGB = dotNetObject "System.Drawing.Drawing2D.LinearGradientBrush" rectBG Arr1[2] Arr1[3] GradMode
		G_Brush.TextRenderingHint = dnTRH ; G_Brush.FillRectangle dnLGB rectBG
		rectFG1 = dotNetObject "System.Drawing.Rectangle" (lblRectX+5) (lblRectY-7) lblRectW lblRectH
		rectFG1a = dotNetObject "System.Drawing.Rectangle" (lblRectX+5) (lblRectY-6) lblRectW lblRectH
		rectFG1b = dotNetObject "System.Drawing.Rectangle" (lblRectX+5) (lblRectY-8) lblRectW lblRectH
		rectFG2 = dotNetObject "System.Drawing.Rectangle" (lblRectX-2) (lblRectY+7) lblRectW lblRectH
		rectFG2a = dotNetObject "System.Drawing.Rectangle" (lblRectX-2) (lblRectY+6) lblRectW lblRectH
		rectFG2b = dotNetObject "System.Drawing.Rectangle" (lblRectX-2) (lblRectY+8) lblRectW lblRectH
		dnTxtRender.DrawText G_Brush logoICO Font3 rectFG1b Arr2[1] dnFlagsHCVC
		dnTxtRender.DrawText G_Brush logoICO Font3 rectFG1a Arr2[4] dnFlagsHCVC
		dnTxtRender.DrawText G_Brush logoICO Font3 rectFG1 Arr2[2] dnFlagsHCVC
		dnTxtRender.DrawText G_Brush logoTxt1 Font4 rectFG2b Arr2[1] dnFlagsHCVC
		dnTxtRender.DrawText G_Brush logoTxt1 Font4 rectFG2a Arr2[4] dnFlagsHCVC
		dnTxtRender.DrawText G_Brush logoTxt1 Font4 rectFG2 Arr2[2] dnFlagsHCVC
	)
	fn dnCamTitlePainter Lbl CTitle Arr1 Arr2 clr =
	(
		local lblRect = Lbl.ClientRectangle, G_Brush = clr.Graphics 
		lblRectW = lblRect.Width ; lblRectH = lblRect.Height ; lblRectX = lblRect.x ; lblRectY = lblRect.y
		rectBG = dotNetObject "System.Drawing.Rectangle" lblRectX lblRectY lblRectW lblRectH
		dnLGB = dotnetobject "System.Drawing.Drawing2D.LinearGradientBrush" rectBG Arr1[2] Arr1[3] GradMode
		G_Brush.TextRenderingHint = dnTRH ; G_Brush.FillRectangle dnLGB rectBG
		rectFG1 = dotNetObject "System.Drawing.Rectangle" lblRectX (lblRectY+0) lblRectW lblRectH
		rectFG1a = dotNetObject "System.Drawing.Rectangle" lblRectX (lblRectY+1) lblRectW lblRectH
		rectFG1b = dotNetObject "System.Drawing.Rectangle" lblRectX (lblRectY-1) lblRectW lblRectH
		dnTxtRender.DrawText G_Brush CTitle Font6 rectFG1b Arr2[1] dnFlagsHCVC
		dnTxtRender.DrawText G_Brush CTitle Font6 rectFG1a Arr2[4] dnFlagsHCVC
		dnTxtRender.DrawText G_Brush CTitle Font6 rectFG1 Arr2[2] dnFlagsHCVC
	)
	fn lblCAMPaint col1 =
	(
		case paintICO of
		(
			(off): ( dnLogoPainter lblCAM col_M_Arr col_M_Arr col1 )
			(on): ( 
			if mouseOn == true then ( dnLogoPainter lblCAM col_M_Arr col_L_Arr col1 )
			else if (MouseOn == false and MousePress == true) then ( dnLogoPainter lblCAM col_D_Arr col_D_Arr col1 )
			else ( dnLogoPainter lblCAM col_M_Arr col_M_Arr col1 )
			)
		)
	)
	fn lblCAMMH = ( paintICO = on ; MouseOn = true ; lblCAM.Invalidate() )
	fn lblCAMML = ( MouseOn = false ; lblCAM.Invalidate() ; paintICO = off )
	fn lblCAMMD = ( paintICO = on ; MouseOn = false ; MousePress = true ; topTape1.BackColor = BClr_M3 ; bottomTape1.BackColor = BClr_M2 ; lblCAM.Invalidate() )
	fn lblCAMMU = ( MousePress = false ; MouseOn = true ; topTape1.BackColor = BClr_M2 ; bottomTape1.BackColor = BClr_M3 ; lblCAM.Invalidate() ; paintICO = off )
	fn lblCAMClick = 
	(
		if roll_3INCAM.Width != 110 then 
		(
			roll_3INCAM.Width = 110 ; roll_3INCAM.Title = " 3 in Cam Pack "
			dnPnl3inCam.Width = roll_3INCAM.Width ; dnPnl3inCam.Height = roll_3INCAM.Height
		)
		else
		(
			roll_3INCAM.Width = 290 ; roll_3INCAM.Title = "                            3 in Cam Pack "
			dnPnl3inCam.Width = roll_3INCAM.Width ; dnPnl3inCam.Height = roll_3INCAM.Height
		)
	)
	fn lblJCamPaint col2 =
	(
		case paintICO of
		(
			(off): ( dnCamTitlePainter lblJCam JCamTitle col_M_Arr col_M_Arr col2 )
			(on): (
			if mouseOn == true then ( dnCamTitlePainter lblJCam JCamTitle col_M_Arr col_L_Arr col2 )
			else if (MouseOn == false and MousePress == true) then ( dnCamTitlePainter lblJCam JCamTitle col_M_Arr col_D_Arr col2 )
			else ( dnCamTitlePainter lblJCam JCamTitle col_M_Arr col_M_Arr col2 )
			)
		)
	)
	fn lblCCamPaint col2 =
	(
		case paintICO of
		(
			(off): ( dnCamTitlePainter lblCCam CCamTitle col_D_Arr col_M_Arr col2 )
			(on): (
			if mouseOn == true then ( dnCamTitlePainter lblCCam CCamTitle col_D_Arr col_L_Arr col2 )
			else if (MouseOn == false and MousePress == true) then ( dnCamTitlePainter lblCCam CCamTitle col_D_Arr col_D_Arr col2 )
			else ( dnCamTitlePainter lblCCam CCamTitle col_D_Arr col_M_Arr col2 )
			)
		)
	)
	fn lblSCamPaint col2 =
	(
		case paintICO of
		(
			(off): ( dnCamTitlePainter lblSCam SCamTitle col_M_Arr col_M_Arr col2 )
			(on): (
			if mouseOn == true then ( dnCamTitlePainter lblSCam SCamTitle col_M_Arr col_L_Arr col2 )
			else if (MouseOn == false and MousePress == true) then ( dnCamTitlePainter lblSCam SCamTitle col_M_Arr col_D_Arr col2 )
			else ( dnCamTitlePainter lblSCam SCamTitle col_M_Arr col_M_Arr col2 )
			)
		)
	)
	fn lblJCQPaint col2 =
	(
		case paintICO of
		(
			(off): ( dnCamTitlePainter lblJCQ QTitle col_M_Arr col_M_Arr col2 )
			(on): (
			if mouseOn == true then ( dnCamTitlePainter lblJCQ QTitle col_M_Arr col_L_Arr col2 )
			else if (MouseOn == false and MousePress == true) then ( dnCamTitlePainter lblJCQ QTitle col_M_Arr col_D_Arr col2 )
			else ( dnCamTitlePainter lblJCQ QTitle col_M_Arr col_M_Arr col2 )
			)
		)
	)
	fn lblCCQPaint col2 =
	(
		case paintICO of
		(
			(off): ( dnCamTitlePainter lblCCQ QTitle col_D_Arr col_M_Arr col2 )
			(on): (
			if mouseOn == true then ( dnCamTitlePainter lblCCQ QTitle col_D_Arr col_L_Arr col2 )
			else if (MouseOn == false and MousePress == true) then ( dnCamTitlePainter lblCCQ QTitle col_D_Arr col_D_Arr col2 )
			else ( dnCamTitlePainter lblCCQ QTitle col_D_Arr col_M_Arr col2 )	
			)
		)
	)
	fn lblSCQPaint col2 = 
	(
		case paintICO of
		(
			(off): ( dnCamTitlePainter lblSCQ QTitle col_M_Arr col_M_Arr col2 )
			(on): ( 
			if mouseOn == true then ( dnCamTitlePainter lblSCQ QTitle col_M_Arr col_L_Arr col2 )
			else if (MouseOn == false and MousePress == true) then ( dnCamTitlePainter lblSCQ QTitle col_M_Arr col_D_Arr col2 )
			else ( dnCamTitlePainter lblSCQ QTitle col_M_Arr col_M_Arr col2 )
			)
		)
	)
	fn lblCamTitleMH sender arg = ( paintICO = on ; MouseOn = true ; sender.Invalidate() )
	fn lblCamTitleML sender arg = ( MouseOn = false ; sender.Invalidate() ; paintICO = off )
	fn lblCamTitleMD sender arg = ( paintICO = on ; MouseOn = false ; MousePress = true ; sender.Invalidate() )
	fn lblCamTitleMU sender arg = ( MousePress = false ; MouseOn = true ; sender.Invalidate() ; paintICO = off )
	fn lblJCamClick =
	(
		local scriptJC = ((getDir #Scripts) + "\\bgaTools\\3inCamPack\\bga_JumperCam.ms")
		if not doesFileExist scriptJC then #abort else ( filein scriptJC )
	)
	fn lblCCamClick =
	(
		local scriptCC = ((getDir #Scripts) + "\\bgaTools\\3inCamPack\\bga_ChaserCam.ms")
		if not doesFileExist scriptCC then #abort else ( filein scriptCC )
	)
	fn lblSCamClick =
	(
		local scriptSC = ((getDir #Scripts) + "\\bgaTools\\3inCamPack\\bga_SpiroflyCam.ms")
		if not doesFileExist scriptSC then #abort else ( filein scriptSC )
	)
	fn lblJCQMH sender arg = ( paintICO = on ; MouseOn = true ; sender.Invalidate() ; ToolTipRoll 1 )
	fn lblCCQMH sender arg = ( paintICO = on ; MouseOn = true ; sender.Invalidate() ; ToolTipRoll 2 )
	fn lblSCQMH sender arg = ( paintICO = on ; MouseOn = true ; sender.Invalidate() ; ToolTipRoll 3 )
	fn lblQTitleML sender arg = ( MouseOn = false ; sender.Invalidate() ; paintICO = off ; try(destroydialog Info_Roll)catch() )
	fn dnICOToolTipDraw ttc =
	(
  		local ttTitle = " * 3 in Cam Pack * ", ttSize = ttc.Bounds, ttBO = 3
		local tttxt = "created by: Branko Zivkovic\r\nemail: barigazy@hotmail.com"
		rectTT1 = dotNetObject "System.Drawing.Rectangle" (ttSize.x + ttBO) (ttSize.y + ttBO) (ttSize.Width - 2*ttBO) (ttSize.Height - 2*ttBO)
		ttGBrush = dotnetobject "System.Drawing.Drawing2D.LinearGradientBrush" ttSize BClr_M1 BClr_M3 GradMode
		ttGBrush1 = dotnetobject "System.Drawing.Drawing2D.LinearGradientBrush" ttSize BClr_M4 BClr_M2 GradMode
  		ttc.Graphics.FillRectangle ttGBrush ttSize ; ttc.Graphics.FillRectangle ttGBrush1 rectTT1
		dnTxtRender.DrawText ttc.Graphics ttTitle Font8 rectTT1 FClr dnFlagsHCT
		dnTxtRender.DrawText ttc.Graphics tttxt Font1 rectTT1 BClr_L1 dnFlagsHCB
	)
/*///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   OPEN / CLOSE ROLL ACTION   //////////*/
	on roll_3INCAM open do
	(
		topTape1 = dotNetObject "Label" ; bottomTape1 = dotNetObject "Label" ; lblCAM = dotNetObject "Label"
		topTape2 = dotNetObject "Label" ; bottomTape2 = dotNetObject "Label"
		lblJCam = dotNetObject "Label" ; lblCCam = dotNetObject "Label" ; lblSCam = dotNetObject "Label"
		lblJCQ = dotNetObject "Label" ; lblCCQ = dotNetObject "Label" ; lblSCQ = dotNetObject "Label"
/*//////////   dnICOToolTip   //////////*/
		dnICOToolTip  = dotNetObject "ToolTip"
		dnICOToolTip.SetToolTip lblCAM "\t\t\t\t\n\r\n\t\r\n" ; dnICOToolTip.OwnerDraw = dnICOToolTip.UseAnimation = true
		dnICOToolTip.UseFading = true ; dnICOToolTip.InitialDelay = 1500 ; dnICOToolTip.AutoPopDelay = 15000
/*//////////   dnPnl3inCam   //////////*/
		dnPnl3inCam.BackColor = BClr_M4 ; dnPnl3inCam.Width = roll_3INCAM.Width ; dnPnl3inCam.Height = roll_3INCAM.Height
/*//////////   topTape1, bottomTape1, topTape2, bottomTape2   //////////*/
		topTape1.BackColor = topTape2.BackColor = BClr_M2 ; bottomTape1.BackColor = bottomTape2.BackColor = BClr_M3
		topTape1.ForeColor = bottomTape1.ForeColor = topTape2.ForeColor = bottomTape2.ForeColor = BClr_M4
		topTape1.Width = bottomTape1.Width = 106 ; topTape2.Width = bottomTape2.Width = 178
		topTape1.Height = bottomTape1.Height = topTape2.Height = bottomTape2.Height = 14
		topTape1.Font = bottomTape1.Font = topTape2.Font = bottomTape2.Font = Font2
		topTape1.TextAlign = bottomTape1.TextAlign = topTape2.TextAlign = bottomTape2.TextAlign = CAlign1
		topTape1.Text = bottomTape1.Text = "nnnnnnnnnn" ; topTape2.Text = bottomTape2.Text = "nnnnnnnnnnnnnnnnn"
		topTape1.Location = dotNetObject "System.Drawing.Point" (dnPnl3inCam.pos.x + 2) (dnPnl3inCam.pos.y + 2)
		bottomTape1.Location = dotNetObject "System.Drawing.Point" (dnPnl3inCam.pos.x + 2) (dnPnl3inCam.pos.y + 94)
		topTape2.Location = dotNetObject "System.Drawing.Point" (dnPnl3inCam.pos.x + 110) (dnPnl3inCam.pos.y + 2)
		bottomTape2.Location = dotNetObject "System.Drawing.Point" (dnPnl3inCam.pos.x + 110) (dnPnl3inCam.pos.y + 94)
/*//////////   lblCAM   //////////*/
		lblCAM.Location = dotNetObject "System.Drawing.Point" (dnPnl3inCam.pos.x + 2) (dnPnl3inCam.pos.y + 16)
		lblCAM.Width = 106 ; lblCAM.Height = 78 ; lblCAM.Cursor = HCrs
/*//////////   lblJCam, lblCCam, lblSCam, lblJCQ, lblCCQ, lblSCQ   //////////*/
		lblJCam.Location = dotNetObject "System.Drawing.Point" (dnPnl3inCam.pos.x + 110) (dnPnl3inCam.pos.y + 16)
		lblCCam.Location = dotNetObject "System.Drawing.Point" (dnPnl3inCam.pos.x + 110) (dnPnl3inCam.pos.y + 42)
		lblSCam.Location = dotNetObject "System.Drawing.Point" (dnPnl3inCam.pos.x + 110) (dnPnl3inCam.pos.y + 68)
		lblJCQ.Location = dotNetObject "System.Drawing.Point" (dnPnl3inCam.pos.x + 262) (dnPnl3inCam.pos.y + 16)
		lblCCQ.Location = dotNetObject "System.Drawing.Point" (dnPnl3inCam.pos.x + 262) (dnPnl3inCam.pos.y + 42)
		lblSCQ.Location = dotNetObject "System.Drawing.Point" (dnPnl3inCam.pos.x + 262) (dnPnl3inCam.pos.y + 68)
		lblJCam.Width = lblCCam.Width = lblSCam.Width = 152 ; lblJCam.Height = lblCCam.Height = lblSCam.Height = 26
		lblJCQ.Width = lblCCQ.Width = lblSCQ.Width = lblJCQ.Height = lblCCQ.Height = lblSCQ.Height = 26
		lblJCam.Cursor = lblCCam.Cursor = lblSCam.Cursor = lblJCQ.Cursor = lblCCQ.Cursor = lblSCQ.Cursor = HCrs
/*//////////   ASSIGN THE EVENTS   //////////*/
		dotnet.addEventHandler dnICOToolTip "Draw" dnICOToolTipDraw
		dotnet.addEventHandler lblCAM "Paint" lblCAMPaint
		dotnet.addEventHandler lblCAM "MouseHover" lblCAMMH
		dotnet.addEventHandler lblCAM "MouseLeave" lblCAMML
		dotnet.addEventHandler lblCAM "MouseDown" lblCAMMD
		dotnet.addEventHandler lblCAM "MouseUp" lblCAMMU
		dotnet.addEventHandler lblCAM "Click" lblCAMClick
		dotnet.addEventHandler lblJCam "Paint" lblJCamPaint
		dotnet.addEventHandler lblJCam "MouseHover" lblCamTitleMH
		dotnet.addEventHandler lblJCam "MouseLeave" lblCamTitleML
		dotnet.addEventHandler lblJCam "MouseDown" lblCamTitleMD
		dotnet.addEventHandler lblJCam "MouseUp" lblCamTitleMU
		dotnet.addEventHandler lblJCam "Click" lblJCamClick
		dotnet.addEventHandler lblCCam "Paint" lblCCamPaint
		dotnet.addEventHandler lblCCam "MouseHover" lblCamTitleMH
		dotnet.addEventHandler lblCCam "MouseLeave" lblCamTitleML
		dotnet.addEventHandler lblCCam "MouseDown" lblCamTitleMD
		dotnet.addEventHandler lblCCam "MouseUp" lblCamTitleMU
		dotnet.addEventHandler lblCCam "Click" lblCCamClick
		dotnet.addEventHandler lblSCam "Paint" lblSCamPaint
		dotnet.addEventHandler lblSCam "MouseHover" lblCamTitleMH
		dotnet.addEventHandler lblSCam "MouseLeave" lblCamTitleML
		dotnet.addEventHandler lblSCam "MouseDown" lblCamTitleMD
		dotnet.addEventHandler lblSCam "MouseUp" lblCamTitleMU
		dotnet.addEventHandler lblSCam "Click" lblSCamClick
		dotnet.addEventHandler lblJCQ "Paint" lblJCQPaint
		dotnet.addEventHandler lblJCQ "MouseHover" lblJCQMH
		dotnet.addEventHandler lblJCQ "MouseLeave" lblQTitleML
		dotnet.addEventHandler lblCCQ "Paint" lblCCQPaint
		dotnet.addEventHandler lblCCQ "MouseHover" lblCCQMH
		dotnet.addEventHandler lblCCQ "MouseLeave" lblQTitleML
		dotnet.addEventHandler lblSCQ "Paint" lblSCQPaint
		dotnet.addEventHandler lblSCQ "MouseHover" lblSCQMH
		dotnet.addEventHandler lblSCQ "MouseLeave" lblQTitleML
/*//////////   ADD dotNET OBJECTS TO PANEL  //////////*/
		dnPnl3inCam.Controls.AddRange #(topTape1, bottomTape1, lblCAM, topTape2, bottomTape2, lblJCam, lblCCam, lblSCam, lblJCQ, lblCCQ, lblSCQ)
	)
	on roll_3INCAM close do	( mainGC.collect() ; gc light:true ; clearListener() )
)
createDialog roll_3INCAM 110 110 style:#(#style_titlebar, #style_sysmenu, #style_toolwindow)
)