/*//////////   SCRIPT:   3inCamPack Installer   //////////*/
/*//////////   WRITTEN BY:   Branko Zivkovic   //////////*/
/*//////////   EMAIL:   barigazy@hotmail.com   //////////*/
(
try(destroyDialog ::roll_3ICPI)catch()
rollout roll_3ICPI "      3 in Cam Pack Installer "
(
	dotNetControl dnPnl3icpi "Panel" pos:[0,0]
/*///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   LOCALS   //////////*/
	local lbl1, lbl2, lbl3, lbl4, lbl5, lbl6, lbl7, lbl8, mainBtn, TT1, TT2, xVal = 0
	local BClr = (dotNetClass "System.Drawing.Color").FromArgb 0 0 0
	local BClr1 = (dotNetClass "System.Drawing.Color").FromArgb 60 60 60
	local BClr2 = (dotNetClass "System.Drawing.Color").FromArgb 140 140 140
	local BClr3 = (dotNetClass "System.Drawing.Color").FromArgb 40 40 40
	local BClr4 = (dotNetClass "System.Drawing.Color").FromArgb 80 80 80
	local FClr = (dotNetClass "System.Drawing.Color").FromArgb 235 235 235
	local FClr1 = (dotNetClass "System.Drawing.SystemColors").MenuHighlight
	local lblF1 = dotNetObject "System.Drawing.Font" "Verdana" 10.5 ((dotNetClass "System.Drawing.FontStyle").bold)
	local lblF2 = dotNetObject "System.Drawing.Font" "Webdings" 45 ((dotNetClass "System.Drawing.FontStyle").regular)
	local lblF3 = dotNetObject "System.Drawing.Font" "ISOCPEUR" 20 ((dotNetClass "System.Drawing.FontStyle").bold)
	local lblF4 = dotNetObject "System.Drawing.Font" "ISOCPEUR" 10 ((dotNetClass "System.Drawing.FontStyle").regular)
	local lblF5 = dotNetObject "System.Drawing.Font" "ISOCPEUR" 10 ((dotNetClass "System.Drawing.FontStyle").regular)
	local lblF6 = dotNetObject "System.Drawing.Font" "ISOCPEUR" 14 ((dotNetClass "System.Drawing.FontStyle").Underline)
	local lblCA1 = (dotNetClass "System.Drawing.ContentAlignment").MiddleCenter
	local lblCA2 = (dotNetClass "System.Drawing.ContentAlignment").MiddleLeft
	local lblCrs = (dotNetClass "System.Windows.Forms.Cursors").Hand
	local lblCrs1 = (dotNetClass "System.Windows.Forms.Cursors").Help
	local lblTRH = (dotNetClass "System.Drawing.Text.TextRenderingHint").AntiAlias
	local lblTxtRender = dotNetClass "TextRenderer"
	local SIOFile = dotNetClass "System.IO.File"
	local SIODir = dotNetClass "System.IO.Directory"
	local instalGC = dotNetClass "System.GC"
	local txtF1 = dotNet.CombineEnums (dotNetClass "TextFormatFlags").HorizontalCenter (dotNetClass "TextFormatFlags").VerticalCenter
	local txtF2 = dotNet.CombineEnums (dotNetClass "TextFormatFlags").Left (dotNetClass "TextFormatFlags").VerticalCenter

	local tempDir = (GetDir #temp) + @"\bgaTools_3inCamPack"
	local tSDir = (GetDir #temp) + @"\bgaTools_3inCamPack\Scripts\bgaTools\3inCamPack"
	local tMDir = (GetDir #temp) + @"\bgaTools_3inCamPack\ui\macroscripts"
	local tIDir = (GetDir #temp) + @"\bgaTools_3inCamPack\ui\Icons"
	local dirbgaT = (GetDir #Scripts) + @"\bgaTools", usermcr = GetDir #userMacros
	local dir3icp = (GetDir #Scripts) + @"\bgaTools\3inCamPack"
	local mcrDir = if (maxversion())[1]/1000 > 14 then (GetDir #maxroot) + @"MacroScripts" else (GetDir #ui) + @"macroscripts" 
	local iconDir = if (maxversion())[1]/1000 > 14 then (GetDir #maxroot) + @"UI_ln\Icons" else (GetDir #ui) + @"Icons"
	local iconDDir = if (maxversion())[1]/1000 > 14 then (GetDir #maxroot) + @"UI_ln\IconsDark" else (GetDir #ui) + @"IconsDark"
/*///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   FUNCTION DEFINITIONS   //////////*/
	fn dnICOMH s e = (s.ForeColor = FClr1) ; fn dnICOML s e = (s.ForeColor = FClr) ; fn dnICOMD s e = (s.ForeColor = BClr1)
	fn dnLogoPainter dnLbl C1 C2 C3 C4 clr =
	(
		local lblRect = dnLbl.ClientRectangle, logoTxt = "3", logoICO = "", G_Brush = clr.Graphics
		lblRectW = lblRect.Width ; lblRectH = lblRect.Height ; lblRectX = lblRect.x ; lblRectY = lblRect.y
		rectICO3 = dotNetObject "System.Drawing.Rectangle" (lblRectX+5) (lblRectY-3) lblRectW lblRectH
		rectICO2 = dotNetObject "System.Drawing.Rectangle" (lblRectX+5) (lblRectY-1) lblRectW lblRectH
		rectICO1 = dotNetObject "System.Drawing.Rectangle" (lblRectX+5) (lblRectY+1) lblRectW lblRectH
		rectTXT = dotNetObject "System.Drawing.Rectangle" (lblRectX-1) (lblRectY+10) lblRectW lblRectH
		G_Brush.TextRenderingHint = lblTRH
		lblTxtRender.DrawText G_Brush logoICO lblF2 rectICO3 C4 txtF1
		lblTxtRender.DrawText G_Brush logoICO lblF2 rectICO2 C3 txtF1
		lblTxtRender.DrawText G_Brush logoICO lblF2 rectICO1 C1 txtF1
		lblTxtRender.DrawText G_Brush logoTxt lblF3 rectTXT C2 txtF1
	)
	fn lbl3Paint clr =
	(
		local PBRect = lbl3.ClientRectangle, PBTxt = " ", G_Brush = clr.Graphics, inc = 0
		PBRectH = PBRect.Height ; PBRectX = PBRect.x ; PBRectY = PBRect.y
		G_Brush.TextRenderingHint = lblTRH
		for t = 0 to xVal do
		(
			if inc > 0 do (lbl4.Text = (inc/10) as string+"%") ; PBRectW = inc/7.5
			rectTXT = dotNetObject "System.Drawing.Rectangle" (PBRectX) (PBRectY-1) PBRectW PBRectH
			lblTxtRender.DrawText G_Brush PBTxt lblF1 rectTXT FClr1 txtF2 ; inc+=1
		)
	)
	fn deleteTempDirectory = ( if (SIODir.Exists tempDir) do try ( setFileAttribute dir3icp #readOnly false ; SIODir.Delete tempDir true ) catch() )
	fn checkIfInstalled =
	(
		if lbl6.Enabled != true do (lbl6.Enabled = true)
		if (SIODir.Exists dir3icp) != true then (lbl6.Text = "INSTALL" ; lbl7.Enabled = false)
		else (lbl6.Text = "UPDATE" ; lbl7.Enabled = true)
	)
	fn destroyDialogs =
	(
		if roll_3INCAM != undefined do try(destroyDialog roll_3INCAM)catch()
		if jcRoll != undefined do try (destroyDialog jcRoll) catch()
		if scRoll != undefined do try (destroyDialog scRoll) catch()
		if ccRoll != undefined do try (destroyDialog ccRoll) catch()
		if noteBox != undefined do try(destroyDialog noteBox)catch()
		if tcRoll  != undefined do try (destroyDialog tcRoll) catch()
		global roll_3INCAM = undefined, jcRoll = undefined, scRoll = undefined, ccRoll = undefined, noteBox = undefined, tcRoll = undefined
	)
	function copyFilesFromTo sDir tDir =
	(
		local tempFilesArr = SIODir.GetFiles(sDir)
		for sFile in tempFilesArr do ( local tFile = tDir + (substring sFile (sDir.count + 1) -1) ; SIOFile.Copy sFile tFile )
	)
	fn uninstall3ICP =
	(
		destroyDialogs() ; xVal = 0 ; lbl3.Invalidate() ; lbl4.Text == "" ; lbl5.Text = ""
		local uninstall = "uninstalled successfully", toDelArr = #(), msArr = #()
		if (SIODir.Exists dir3icp) == true do msArr = SIODir.GetFiles(dir3icp)
		for mcr in SIODir.GetFiles(mcrDir) where getFilenameFile mcr == "Macro_3inCamPack" do append toDelArr mcr
		for ico in SIODir.GetFiles(iconDir) where substring (getFilenameFile ico) 1 14 == "bga_3inCamPack" do append toDelArr ico
		for umcr in SIODir.GetFiles(usermcr) where substring (getFilenameFile umcr) 1 9 == "bgaTools-" do append toDelArr umcr
		if toDelArr == #() then #abort else (
		for f in toDelArr do
		(
			if getFileAttribute f #readOnly == true or getFileAttribute f #hidden == true do
			(
				setFileAttribute f #readOnly false ; setFileAttribute f #hidden false
			)
			try (SIOFile.Delete(f) ; (print ("Deleting Managed: "+ filenameFromPath f)))
			catch (print ("Deleting False: "+ filenameFromPath f+". Try to delete manualy.") ; uninstall = "uninstallation failed")
		))
		if msArr == #() then (#abort) else (
		for f in msArr do
		(
			if getFileAttribute f #readOnly == true or getFileAttribute f #hidden == true do
			(
				setFileAttribute f #readOnly false ; setFileAttribute f #hidden false
			)
			try (SIOFile.Delete(f) ; (print ("Deleting Managed: "+ filenameFromPath f)))
			catch (print ("Deleting False: "+ filenameFromPath f+". Try to delete manualy.") ; uninstall = "uninstallation failed")
		))
		if (SIODir.Exists dir3icp) == true do
		(
			try ( setFileAttribute dir3icp #readOnly false ; SIODir.Delete(dir3icp) true ; (print ("Deleting Managed: "+ pathConfig.stripPathToLeaf dir3icp + " Directory")))
			catch (print ("Deleting False: "+ pathConfig.stripPathToLeaf dir3icp + " Directory. Try to delete manualy.") ; uninstall = "uninstallation failed")
		)
		if (SIODir.Exists dirbgaT) == true do
		(
			local bgaTDirArr = (SIODir.GetDirectories(dirbgaT))
			if bgaTDirArr.count == 0 do
			try ( setFileAttribute dirbgaT #readOnly false ; SIODir.Delete(dirbgaT) true ; (print ("Deleting Managed: "+ pathConfig.stripPathToLeaf dirbgaT + " Directory")))
			catch (print ("Deleting False: "+ pathConfig.stripPathToLeaf dirbgaT + " Directory. Try to delete manualy.") ; uninstall = "uninstallation failed")
		) ; print uninstall
		if uninstall == "uninstalled successfully" do
		(
			xVal = 1000 ; lbl3.Invalidate()
			lbl5.Text = "uninstalled successfully" ; lbl7.Enabled = false ; lbl6.Enabled = true ; lbl6.Text = "INSTALL"
		)
	)
	fn install3ICP =
	(	
		destroyDialogs() ; xVal = 0 ; lbl3.Invalidate() ; lbl4.Text == "" ; lbl5.Text = ""
		local startInstall = true, warning = "installation failed, you need to have writing permission for creating or deleting files and folders", install = con1 = con2 = ""
		case lbl6.Text of (
			("INSTALL"): (con1 = "installed successfully" ; con2 = "installation failed")
			("UPDATE"): (con1 = "updateded successfully" ; con2 = "update failed")
		) ; install = con1
		if (lbl6.Text == "INSTALL" and (SIODir.Exists dir3icp) == false) then
		(
			try ( SIODir.CreateDirectory dir3icp ) catch (startInstall = false)
			if startInstall != true then ( print warning ; #abort )
			else (	try (copyFilesFromTo tSDir dir3icp ; copyFilesFromTo tMDir mcrDir ; copyFilesFromTo tIDir iconDir ; copyFilesFromTo tIDir iconDDir) catch ( install = con2 ; print warning ) )
		)
		else if (lbl6.Text == "UPDATE" and  (SIODir.Exists dir3icp) == true) do
		(
			setFileAttribute dir3icp #readOnly false
			try ( (SIODir.Delete(dir3icp) true) ; if (SIODir.Exists dir3icp) == false do ( SIODir.CreateDirectory dir3icp ) ) catch(startInstall = false)
			if startInstall != true then ( print warning ; #abort ) else ( try (copyFilesFromTo tSDir dir3icp) catch ( install = con2 ; print warning ) )
		)
		if install == con1 do 
		(
			local mcrFile = ((getDir #ui) + "\\macroscripts\\Macro_3inCamPack.mcr")
			if not doesFileExist mcrFile then #abort else ( filein mcrFile )
			xVal = 1000 ; lbl3.Invalidate()
			if (lbl6.Text == "INSTALL") then (lbl5.Text = "installed successfully") else (lbl5.Text = "updated successfully")
			lbl6.Enabled = false ; lbl7.Enabled = true
		) ; print install
	)
	fn lbl6Click = ( install3ICP() ) ; fn lbl7Click = ( uninstall3ICP() )
	fn lbl8Click = (try(destroyDialog roll_3ICPI)catch())
	fn mainBtnPaint clr = dnLogoPainter mainBtn FClr BClr BClr2 BClr4 clr
	fn TT1Draw tt3icpi =
	(
		local tt3icpiSize = tt3icpi.Bounds, TTtxt = "barigazy@hotmail.com"
		tt3icpiSBrush = dotnetobject "System.Drawing.SolidBrush" BClr3
  		tt3icpi.Graphics.FillRectangle tt3icpiSBrush tt3icpiSize
		lblTxtRender.DrawText tt3icpi.Graphics TTtxt lblF5 tt3icpiSize FClr1 txtF1
	)
	fn TT2Draw tt3icpi =
	(
		local tt3icpiSize = tt3icpi.Bounds, TTtxt = "After installation go to the\r\n*Customize User Interface* >\r\n*Toolbars*, browse to the\r\ncategory *bgaTools* and\r\nadd buttons to the toolbar,\r\nquad or to the menu."
		tt3icpiSBrush = dotnetobject "System.Drawing.SolidBrush" BClr3
  		tt3icpi.Graphics.FillRectangle tt3icpiSBrush tt3icpiSize
		lblTxtRender.DrawText tt3icpi.Graphics TTtxt lblF5 tt3icpiSize FClr1 txtF2
	)
/*///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   OPEN / CLOSE ROLL ACTION   //////////*/
	on roll_3ICPI open do
	(
		lbl1 = dotNetObject "Label" ; lbl2 = dotNetObject "Label" ; lbl3 = dotNetObject "Label" ; lbl4 = dotNetObject "Label" ; lbl5 = dotNetObject "Label"
		lbl6 = dotNetObject "Label" ; lbl7 = dotNetObject "Label" ; lbl8 = dotNetObject "Label" ; mainBtn = dotNetObject "Label"
/*//////////   dnToolTip's Options   //////////*/
		TT1 = dotNetObject "ToolTip" ; TT2 = dotNetObject "ToolTip"
		TT1.SetToolTip lbl2 "\t\t\t" ; TT2.SetToolTip mainBtn "\n\t \t\t\r\n\r\n\t\r\n\t\r\n\t\r\n\t" ; TT1.OwnerDraw = TT2.OwnerDraw = true
		TT1.InitialDelay = TT2.InitialDelay = TT1.ReshowDelay = TT2.ReshowDelay = 2000 ; TT1.AutoPopDelay = TT2.AutoPopDelay = 20000
/*//////////   dnPnl3icpi    //////////*/
		dnPnl3icpi.BackColor = BClr2 ; dnPnl3icpi.Width = roll_3ICPI.Width ; dnPnl3icpi.Height = roll_3ICPI.Height
/*//////////   lbl1, lbl2, lbl3, lbl4, lbl5, lbl6, lbl7, lbl8, mainBtn   //////////*/
		lbl1.BackColor = lbl2.BackColor = lbl3.BackColor = lbl4.BackColor = lbl5.BackColor = lbl6.BackColor = lbl7.BackColor = lbl8.BackColor = mainBtn.BackColor = BClr
		lbl1.ForeColor = lbl2.ForeColor = lbl3.ForeColor = lbl4.ForeColor = lbl5.ForeColor = lbl6.ForeColor = lbl7.ForeColor = lbl8.ForeColor = FClr ; mainBtn.Height = 49 ; mainBtn.Width = 60
		lbl1.Width = lbl2.Width = lbl3.Width = lbl5.Width = 136 ; lbl4.Width = 60 ; lbl1.Height = 20 ; lbl2.Height = lbl4.Height = lbl5.Height = 14 ; lbl3.Height = 15
		lbl6.Height = lbl7.Height = lbl8.Height = 20 ; lbl6.Width = lbl8.Width = 65 ; lbl7.Width = 66 ; lbl1.Font = lblF6 ; lbl2.Font = lbl4.Font = lbl5.Font = lblF5 ; lbl6.Font = lbl7.Font = lbl8.Font = lblF4
		lbl3.Font = lblF1 ; lbl1.TextAlign = lbl2.TextAlign = lbl4.TextAlign = lbl5.TextAlign = lbl6.TextAlign = lbl7.TextAlign = lbl8.TextAlign = lblCA1 ; lbl3.TextAlign = lblCA2
		lbl1.Text = "3 in Cam Pack" ; lbl2.Text = "by Branko Zivkovic" ; lbl4.Text = "" ; lbl5.Text = "" ; lbl6.Text = "INSTALL" ; lbl7.Text = "UNINSTALL" ; lbl8.Text = "CLOSE" ; lbl3.Text = ""
		lbl1.Location = dotNetObject "System.Drawing.Point" (dnPnl3icpi.pos.x + 62) (dnPnl3icpi.pos.y + 2) ; lbl6.Cursor = lbl7.Cursor = lbl8.Cursor = lblCrs ; mainBtn.Cursor = lbl2.Cursor = lblCrs1
		lbl2.Location = dotNetObject "System.Drawing.Point" (dnPnl3icpi.pos.x + 62) (dnPnl3icpi.pos.y + 22)
		lbl3.Location = dotNetObject "System.Drawing.Point" (dnPnl3icpi.pos.x + 62) (dnPnl3icpi.pos.y + 36)
		lbl4.Location = dotNetObject "System.Drawing.Point" (dnPnl3icpi.pos.x + 2) (dnPnl3icpi.pos.y + 51)
		lbl5.Location = dotNetObject "System.Drawing.Point" (dnPnl3icpi.pos.x + 62) (dnPnl3icpi.pos.y + 51)
		lbl6.Location = dotNetObject "System.Drawing.Point" (dnPnl3icpi.pos.x + 2) (dnPnl3icpi.pos.y + 66)
		lbl7.Location = dotNetObject "System.Drawing.Point" (dnPnl3icpi.pos.x + 67) (dnPnl3icpi.pos.y + 66)
		lbl8.Location = dotNetObject "System.Drawing.Point" (dnPnl3icpi.pos.x + 132) (dnPnl3icpi.pos.y + 66)
		mainBtn.Location = dotNetObject "System.Drawing.Point" (dnPnl3icpi.pos.x + 2) (dnPnl3icpi.pos.y + 2)
/*//////////   ASSIGN THE EVENTS   //////////*/
		dotnet.addEventHandler TT1 "Draw" TT1Draw
		dotnet.addEventHandler TT2 "Draw" TT2Draw
		dotNet.addEventHandler lbl6 "MouseHover" dnICOMH
		dotNet.addEventHandler lbl6 "MouseLeave" dnICOML
		dotNet.addEventHandler lbl6 "MouseUp" dnICOMH
		dotNet.addEventHandler lbl6 "MouseDown" dnICOMD
		dotNet.addEventHandler lbl6 "MouseClick" lbl6Click
		dotNet.addEventHandler lbl7 "MouseHover" dnICOMH
		dotNet.addEventHandler lbl7 "MouseLeave" dnICOML
		dotNet.addEventHandler lbl7 "MouseUp" dnICOMH
		dotNet.addEventHandler lbl7 "MouseDown" dnICOMD
		dotNet.addEventHandler lbl7 "MouseClick" lbl7Click
		dotNet.addEventHandler lbl8 "MouseHover" dnICOMH
		dotNet.addEventHandler lbl8 "MouseLeave" dnICOML
		dotNet.addEventHandler lbl8 "MouseUp" lbl8Click
		dotNet.addEventHandler lbl8 "MouseDown" dnICOMD
		dotNet.addEventHandler lbl8 "MouseClick" lbl8Click
		dotnet.addEventHandler mainBtn "Paint" mainBtnPaint
		dotnet.addEventHandler lbl3 "Paint" lbl3Paint
/*//////////   ADD dotNET OBJECTS TO PANEL  //////////*/	
		dnPnl3icpi.Controls.Add(lbl1) ; dnPnl3icpi.Controls.Add(lbl2) ; dnPnl3icpi.Controls.Add(lbl3) ; dnPnl3icpi.Controls.Add(lbl4) ; dnPnl3icpi.Controls.Add(lbl5)
		dnPnl3icpi.Controls.Add(lbl6) ; dnPnl3icpi.Controls.Add(lbl7) ; dnPnl3icpi.Controls.Add(lbl8) ; dnPnl3icpi.Controls.Add(mainBtn)
		checkIfInstalled() ; clearListener()
	)
	on roll_3ICPI close do 
	(
		filein (mcrDir + "\Macro_3inCamPack.mcr") quiet:on
		if lbl6.Text == "INSTALL" do colorman.reInitIcons()
		deleteTempDirectory() /*; instalGC.collect() ; gc light:true */ ; clearListener()
	)
)
	createDialog roll_3ICPI 200 88 style:#(#style_border)
)